Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:13 2011
FILE NAME: arare4fileio.f90
PROGRAM NAME: arare4fileio
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   146  vec  (   4): Vectorized array expression.
   146  vec  (   4): Vectorized array expression.
   153  vec  (   4): Vectorized array expression.
   153  vec  (   4): Vectorized array expression.
   158  vec  (   4): Vectorized array expression.
   163  vec  (   4): Vectorized array expression.
   163  vec  (   4): Vectorized array expression.
   170  vec  (   4): Vectorized array expression.
   170  vec  (   4): Vectorized array expression.
   177  vec  (   4): Vectorized array expression.
   177  vec  (   4): Vectorized array expression.
   184  vec  (   4): Vectorized array expression.
   184  vec  (   4): Vectorized array expression.
   192  vec  (   3): Unvectorized loop.
   196  vec  (   4): Vectorized array expression.
   196  vec  (   4): Vectorized array expression.
   202  vec  (   4): Vectorized array expression.
   262  vec  (   4): Vectorized array expression.
   262  vec  (   4): Vectorized array expression.
   268  vec  (   4): Vectorized array expression.
   268  vec  (   4): Vectorized array expression.
   274  vec  (   4): Vectorized array expression.
   274  vec  (   4): Vectorized array expression.
   280  vec  (   4): Vectorized array expression.
   280  vec  (   4): Vectorized array expression.
   286  vec  (   4): Vectorized array expression.
   286  vec  (   4): Vectorized array expression.
   292  vec  (   4): Vectorized array expression.
   292  vec  (   4): Vectorized array expression.
   300  vec  (   3): Unvectorized loop.
   303  vec  (   4): Vectorized array expression.
   303  vec  (   4): Vectorized array expression.
   309  vec  (   4): Vectorized array expression.
   309  vec  (   4): Vectorized array expression.
   372  vec  (   4): Vectorized array expression.
   372  vec  (   4): Vectorized array expression.
   379  vec  (   4): Vectorized array expression.
   379  vec  (   4): Vectorized array expression.
   384  vec  (   4): Vectorized array expression.
   389  vec  (   4): Vectorized array expression.
   389  vec  (   4): Vectorized array expression.
   396  vec  (   4): Vectorized array expression.
   396  vec  (   4): Vectorized array expression.
   403  vec  (   4): Vectorized array expression.
   403  vec  (   4): Vectorized array expression.
   410  vec  (   4): Vectorized array expression.
   410  vec  (   4): Vectorized array expression.
   417  vec  (   4): Vectorized array expression.
   417  vec  (   4): Vectorized array expression.
   425  vec  (   4): Vectorized array expression.
   425  vec  (   4): Vectorized array expression.
   485  vec  (   4): Vectorized array expression.
   485  vec  (   4): Vectorized array expression.
   491  vec  (   4): Vectorized array expression.
   491  vec  (   4): Vectorized array expression.
   497  vec  (   4): Vectorized array expression.
   497  vec  (   4): Vectorized array expression.
   503  vec  (   4): Vectorized array expression.
   503  vec  (   4): Vectorized array expression.
   509  vec  (   4): Vectorized array expression.
   509  vec  (   4): Vectorized array expression.
   515  vec  (   4): Vectorized array expression.
   515  vec  (   4): Vectorized array expression.
   522  vec  (   4): Vectorized array expression.
   526  vec  (   4): Vectorized array expression.
   526  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:13 2011
FILE NAME: arare4fileio.f90
PROGRAM NAME: arare4fileio
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module Arare4fileio
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4  ! Version::   $Id: arare4fileio.f90,v 1.10 2011-06-17 19:07:25 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !ꥹѤξξ netCDF ե˽Ϥ뤿Υ롼
    12  !
    13  !== Error Handling
    14  !
    15  !== Known Bugs
    16  !
    17  !== Note
    18  !
    19  !®٤ɾʻҰ֤, ȤϤƤɸͤŪǤʤȤ
    20  !
    21  !== Future Plans
    22  !
    23  
    24  module Arare4fileio
    25    !
    26    !ꥹѤξξ netCDF ե˽Ϥ뤿Υ롼
    27    !
    28  
    29    !⥸塼ɤ߹
    30    use gtool_history
    31    use dc_types,  only : DP, STRING
    32    use dc_message,only : MessageNotify
    33    use dc_string, only : toChar
    34    use dc_iounit, only : FileOpen
    35    use mpi_wrapper,   only: myrank, FLAG_LIB_MPI
    36    use gridset,  only: &
    37      &                 imin,           &!X β
    38      &                 imax,           &!X ξ
    39      &                 jmin,           &!Y β
    40      &                 jmax,           &!Y ξ
    41      &                 kmin,           &!Z β
    42      &                 kmax,           &!Z ξ
    43      &                 nx,nz,ncmax              !Žʬο
    44    use setmargin
    45    use composition, only: SpcWetSymbol
    46    use namelist_util, only: namelist_filename
    47  
    48    !ۤηػ
    49    implicit none
    50  
    51    !°λ
    52    private
    53  
    54    !ؿ public ˻
    55    public Arare4fileio_init
    56    public Arare4fileio_BZ_Get
    57    public Arare4fileio_Var_Get
    58    public Arare4fileio_MMC_BZ_Get
    59    public Arare4fileio_MMC_Var_Get
    60  
    61    character(STRING), save :: Arare4Prefix  = "arare4_"
    62  
    63  contains
    64  
    65    subroutine Arare4fileio_Init
    66      !
    67      !ꥹȥեν񤭽Ф
    68      !
    69      !ۤηػ
    70      implicit none
    71  
    72      !ѿ
    73      integer            :: unit     !ֹ
    74  
    75      !NAMELIST 
    76      NAMELIST /arare4fileio_nml/ Arare4Prefix
    77  
    78      call FileOpen(unit, file=namelist_filename, mode='r')
    79      read(unit, NML=arare4fileio_nml)
    80      close(unit)
    81  
    82      !ǧ
    83      if (myrank == 0) then
    84        call MessageNotify( "M", &
    85          & "arare4FileIO_init", "Arare4Prefix = %c", c1=trim(Arare4Prefix) )
    86      end if
    87  
    88    end subroutine Arare4fileio_Init
    89  
    90  
    91    subroutine Arare4fileio_Var_Get(   &
    92      & pyz_VelX,     & ! (out)
    93      & xqz_VelY,     & ! (out)
    94      & xyr_VelZ,     & ! (out)
    95      & xyz_PTemp,    & ! (out)
    96      & xyz_Exner,    & ! (out)
    97      & xyzf_QMix,    & ! (out)
    98      & xyz_Km,       & ! (out)
    99      & xyz_Kh,       & ! (out)
   100      & xyz_CDens   )   ! (out)
   101      !
   102      !ꥹȥե뤫
   103      !
   104  
   105      !ۤηػ
   106      implicit none
   107  
   108      !ѿ
   109      real(DP)              :: Var3D(1:nx, 1, 1:nz)
   110      real(DP), intent(out) :: pyz_VelX &
   111        &                      (imin:imax,jmin:jmax,kmin:kmax)
   112      real(DP), intent(out) :: xqz_VelY &
   113        &                      (imin:imax,jmin:jmax,kmin:kmax)
   114      real(DP), intent(out) :: xyr_VelZ &
   115        &                      (imin:imax,jmin:jmax,kmin:kmax)
   116      real(DP), intent(out) :: xyz_Exner &
   117        &                      (imin:imax,jmin:jmax,kmin:kmax)
   118      real(DP), intent(out) :: xyz_PTemp &
   119        &                      (imin:imax,jmin:jmax,kmin:kmax)
   120      real(DP), intent(out) :: xyz_Km &
   121        &                      (imin:imax,jmin:jmax,kmin:kmax)
   122      real(DP), intent(out) :: xyz_Kh &
   123        &                      (imin:imax,jmin:jmax,kmin:kmax)
   124      real(DP), intent(out) :: xyz_CDens &
   125        &                      (imin:imax,jmin:jmax,kmin:kmax)
   126      real(DP), intent(out) :: xyzf_QMix &
   127        &                      (imin:imax,jmin:jmax,kmin:kmax,ncmax)
   128      real(DP)             :: RestartTime
   129      integer              :: f
   130  
   131      character(STRING)    :: name               !ѿ̾
   132  !    character(STRING)    :: name1
   133      character(STRING)    :: Time
   134      character(STRING)    :: InputFile
   135  
   136      !-------------------------------------------------------------
   137      ! Get a Value from netCDF File
   138      !-------------------------------------------------------------
   139      RestartTime = 0.0d0
   140      time = 't=' // trim(toChar( RestartTime ))
   141  
   142      name = "PotTemp"
   143  !    name1 = "PotTempDist"
   144      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   145      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   146      xyz_PTemp(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J1 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t557 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t559 = 1, nx                                             
     .                 xyz_ptemp(t559,1,t557) = var3d(t559,1,t557)              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t557 = J1 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t559 = 1, nx                                             
     .                 xyz_ptemp(t559,1,t557) = var3d(t559,1,t557)              
     .                 xyz_ptemp(t559,1,t557+1) = var3d(t559,1,t557+1)          
     .                 xyz_ptemp(t559,1,t557+2) = var3d(t559,1,t557+2)          
     .                 xyz_ptemp(t559,1,t557+3) = var3d(t559,1,t557+3)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   147  
   148      call SetMargin_xyz( xyz_PTemp )
   149  
   150      name = "VelX"
   151      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   152      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   153      pyz_VelX(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J2 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t565 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t567 = 1, nx                                             
     .                 pyz_velx(t567,1,t565) = var3d(t567,1,t565)               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t565 = J2 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t567 = 1, nx                                             
     .                 pyz_velx(t567,1,t565) = var3d(t567,1,t565)               
     .                 pyz_velx(t567,1,t565+1) = var3d(t567,1,t565+1)           
     .                 pyz_velx(t567,1,t565+2) = var3d(t567,1,t565+2)           
     .                 pyz_velx(t567,1,t565+3) = var3d(t567,1,t565+3)           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   154  
   155      call SetMargin_pyz( pyz_VelX )
   156  
   157      name = "VelY"
   158      xqz_VelY = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t573 = 1, (kmax + 1 - kmin)*(jmax + 1 - jmin)*(imax + 1 - imin)
     .           xqz_vely(t67+t573-1,t69,t71) = 0.0000000000000000e+000         
     .        end do                                                            
   159  
   160      name = "VelZ"
   161      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   162      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   163      xyr_VelZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J3 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t582 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t584 = 1, nx                                             
     .                 xyr_velz(t584,1,t582) = var3d(t584,1,t582)               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t582 = J3 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t584 = 1, nx                                             
     .                 xyr_velz(t584,1,t582) = var3d(t584,1,t582)               
     .                 xyr_velz(t584,1,t582+1) = var3d(t584,1,t582+1)           
     .                 xyr_velz(t584,1,t582+2) = var3d(t584,1,t582+2)           
     .                 xyr_velz(t584,1,t582+3) = var3d(t584,1,t582+3)           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   164  
   165      call SetMargin_xyr( xyr_VelZ )
   166  
   167      name = "Exner"
   168      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   169      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   170      xyz_Exner(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J4 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t590 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t592 = 1, nx                                             
     .                 xyz_exner(t592,1,t590) = var3d(t592,1,t590)              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t590 = J4 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t592 = 1, nx                                             
     .                 xyz_exner(t592,1,t590) = var3d(t592,1,t590)              
     .                 xyz_exner(t592,1,t590+1) = var3d(t592,1,t590+1)          
     .                 xyz_exner(t592,1,t590+2) = var3d(t592,1,t590+2)          
     .                 xyz_exner(t592,1,t590+3) = var3d(t592,1,t590+3)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   171  
   172      call SetMargin_xyz( xyz_Exner )
   173  
   174      name = "Km"
   175      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   176      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   177      xyz_Km(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J5 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t598 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t600 = 1, nx                                             
     .                 xyz_km(t600,1,t598) = var3d(t600,1,t598)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t598 = J5 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t600 = 1, nx                                             
     .                 xyz_km(t600,1,t598) = var3d(t600,1,t598)                 
     .                 xyz_km(t600,1,t598+1) = var3d(t600,1,t598+1)             
     .                 xyz_km(t600,1,t598+2) = var3d(t600,1,t598+2)             
     .                 xyz_km(t600,1,t598+3) = var3d(t600,1,t598+3)             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   178  
   179      call SetMargin_xyz( xyz_Km )
   180  
   181      name = "Kh"
   182      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   183      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   184      xyz_Kh(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J6 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t606 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t608 = 1, nx                                             
     .                 xyz_kh(t608,1,t606) = var3d(t608,1,t606)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t606 = J6 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t608 = 1, nx                                             
     .                 xyz_kh(t608,1,t606) = var3d(t608,1,t606)                 
     .                 xyz_kh(t608,1,t606+1) = var3d(t608,1,t606+1)             
     .                 xyz_kh(t608,1,t606+2) = var3d(t608,1,t606+2)             
     .                 xyz_kh(t608,1,t606+3) = var3d(t608,1,t606+3)             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   185  
   186      call SetMargin_xyz( xyz_Kh )
   187  
   188  !    name = "MixRt"
   189  !    InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   190  !    call HistoryGet( InputFile, name, Var4D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   191  !    xyzf_QMix(1:nx,1,1:nz,1:ncmax) = Var4D(1:nx,1,1:nz,1:ncmax)
   192      do f = 1, ncmax
   193        name = trim(SpcWetSymbol(f))
   194        InputFile = trim(Arare4Prefix) // trim(SpcWetSymbol(f)) // ".nc"
   195        call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   196        xyzf_QMix(1:nx,1,1:nz,f) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J7 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t614 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t616 = 1, nx                                             
     .                 xyzf_qmix(t616,1,t614,f) = var3d(t616,1,t614)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t614 = J7 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t616 = 1, nx                                             
     .                 xyzf_qmix(t616,1,t614,f) = var3d(t616,1,t614)            
     .                 xyzf_qmix(t616,1,t614+1,f) = var3d(t616,1,t614+1)        
     .                 xyzf_qmix(t616,1,t614+2,f) = var3d(t616,1,t614+2)        
     .                 xyzf_qmix(t616,1,t614+3,f) = var3d(t616,1,t614+3)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   197      end do
   198  
   199      call SetMargin_xyzf( xyzf_QMix )
   200  
   201      name = "CloudDensity"
   202      xyz_CDens = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t622 = 1, (kmax + 1 - kmin)*(jmax + 1 - jmin)*(imax + 1 - imin)
     .           xyz_cdens(t139+t622-1,t141,t143) = 0.0000000000000000e+000     
     .        end do                                                            
   203  
   204    end subroutine Arare4fileio_Var_Get
   205  
   206  
   207    subroutine Arare4fileio_BZ_Get(   &
   208      & xyz_PressBZ,   &
   209      & xyz_ExnerBZ,   &
   210      & xyz_TempBZ,    &
   211      & xyz_PTempBZ, &
   212      & xyz_DensBZ,    &
   213      & xyz_VelSoundBZ,&
   214      & xyzf_QMixBZ,  &
   215      & xyz_EffMolWtBZ &
   216      & )
   217  
   218      !
   219      !ꥹȥե뤫
   220      !
   221  
   222      !ۤηػ
   223      implicit none
   224  
   225      !ѿ
   226      real(DP)              :: Var3D(1:nx,1,1:nz)
   227      real(DP), intent(out) :: xyz_ExnerBZ &
   228        &                     (imin:imax,jmin:jmax,kmin:kmax)
   229                                                 !ܾΥʡؿ
   230      real(DP), intent(out) :: xyz_DensBZ &
   231        &                     (imin:imax,jmin:jmax,kmin:kmax)
   232                                                 !ܾ̩
   233      real(DP), intent(out) :: xyz_PTempBZ &
   234        &                     (imin:imax,jmin:jmax,kmin:kmax)
   235                                                 !ܾβ
   236      real(DP), intent(out) :: xyz_VelSoundBZ &
   237        &                     (imin:imax,jmin:jmax,kmin:kmax)
   238                                                 !ܾβ®
   239      real(DP), intent(out) :: xyz_PressBZ &
   240        &                     (imin:imax,jmin:jmax,kmin:kmax)
   241                                                 !ܾΰ
   242      real(DP), intent(out) :: xyz_TempBZ &
   243        &                     (imin:imax,jmin:jmax,kmin:kmax)
   244                                                 !ܾβ
   245      real(DP), intent(out) :: xyzf_QMixBZ &
   246        &                     (imin:imax,jmin:jmax,kmin:kmax, ncmax)
   247                                                 !ܾκ
   248      real(DP), intent(out) :: xyz_EffMolWtBZ &
   249        &                     (imin:imax,jmin:jmax,kmin:kmax)
   250                                                 !ܾʬ̸
   251      character(STRING)    :: name               !ѿ̾
   252      character(STRING)    :: InputFile
   253      integer              :: f
   254  
   255      !-------------------------------------------------------------
   256      ! ܾμ
   257      !
   258      InputFile = trim(Arare4Prefix) // "BasicZ.nc"
   259  
   260      name = "DensBasicZ"
   261      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   262      xyz_DensBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J1 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t341 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t343 = 1, nx                                             
     .                 xyz_densbz(t343,1,t341) = var3d(t343,1,t341)             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t341 = J1 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t343 = 1, nx                                             
     .                 xyz_densbz(t343,1,t341) = var3d(t343,1,t341)             
     .                 xyz_densbz(t343,1,t341+1) = var3d(t343,1,t341+1)         
     .                 xyz_densbz(t343,1,t341+2) = var3d(t343,1,t341+2)         
     .                 xyz_densbz(t343,1,t341+3) = var3d(t343,1,t341+3)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   263  
   264      call SetMargin_xyz( xyz_DensBZ )
   265  
   266      name = "ExnerBasicZ"
   267      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   268      xyz_ExnerBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J2 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t349 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t351 = 1, nx                                             
     .                 xyz_exnerbz(t351,1,t349) = var3d(t351,1,t349)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t349 = J2 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t351 = 1, nx                                             
     .                 xyz_exnerbz(t351,1,t349) = var3d(t351,1,t349)            
     .                 xyz_exnerbz(t351,1,t349+1) = var3d(t351,1,t349+1)        
     .                 xyz_exnerbz(t351,1,t349+2) = var3d(t351,1,t349+2)        
     .                 xyz_exnerbz(t351,1,t349+3) = var3d(t351,1,t349+3)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   269  
   270      call SetMargin_xyz( xyz_ExnerBZ )
   271  
   272      name = "PotTempBasicZ"
   273      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   274      xyz_PTempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J3 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t357 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t359 = 1, nx                                             
     .                 xyz_ptempbz(t359,1,t357) = var3d(t359,1,t357)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t357 = J3 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t359 = 1, nx                                             
     .                 xyz_ptempbz(t359,1,t357) = var3d(t359,1,t357)            
     .                 xyz_ptempbz(t359,1,t357+1) = var3d(t359,1,t357+1)        
     .                 xyz_ptempbz(t359,1,t357+2) = var3d(t359,1,t357+2)        
     .                 xyz_ptempbz(t359,1,t357+3) = var3d(t359,1,t357+3)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   275  
   276      call SetMargin_xyz( xyz_PTempBZ )
   277  
   278      name = "VelSoundBasicZ"
   279      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   280      xyz_VelSoundBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J4 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t365 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t367 = 1, nx                                             
     .                 xyz_velsoundbz(t367,1,t365) = var3d(t367,1,t365)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t365 = J4 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t367 = 1, nx                                             
     .                 xyz_velsoundbz(t367,1,t365) = var3d(t367,1,t365)         
     .                 xyz_velsoundbz(t367,1,t365+1) = var3d(t367,1,t365+1)     
     .                 xyz_velsoundbz(t367,1,t365+2) = var3d(t367,1,t365+2)     
     .                 xyz_velsoundbz(t367,1,t365+3) = var3d(t367,1,t365+3)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   281  
   282      call SetMargin_xyz( xyz_VelSoundBZ )
   283  
   284      name = "TempBasicZ"
   285      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   286      xyz_TempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J5 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t373 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t375 = 1, nx                                             
     .                 xyz_tempbz(t375,1,t373) = var3d(t375,1,t373)             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t373 = J5 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t375 = 1, nx                                             
     .                 xyz_tempbz(t375,1,t373) = var3d(t375,1,t373)             
     .                 xyz_tempbz(t375,1,t373+1) = var3d(t375,1,t373+1)         
     .                 xyz_tempbz(t375,1,t373+2) = var3d(t375,1,t373+2)         
     .                 xyz_tempbz(t375,1,t373+3) = var3d(t375,1,t373+3)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   287  
   288      call SetMargin_xyz( xyz_TempBZ )
   289  
   290      name = "PressBasicZ"
   291      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   292      xyz_PressBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J6 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t381 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t383 = 1, nx                                             
     .                 xyz_pressbz(t383,1,t381) = var3d(t383,1,t381)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t381 = J6 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t383 = 1, nx                                             
     .                 xyz_pressbz(t383,1,t381) = var3d(t383,1,t381)            
     .                 xyz_pressbz(t383,1,t381+1) = var3d(t383,1,t381+1)        
     .                 xyz_pressbz(t383,1,t381+2) = var3d(t383,1,t381+2)        
     .                 xyz_pressbz(t383,1,t381+3) = var3d(t383,1,t381+3)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   293  
   294      call SetMargin_xyz( xyz_PressBZ)
   295  
   296  !    name = "MixRtBasicZ"
   297  !    call HistoryGet( InputFile, name, Var4D(:,1,:,:), flag_mpi_split = FLAG_LIB_MPI )
   298  !    xyzf_QMixBZ(1:nx,1,1:nz,1:ncmax) = Var4D(1:nx,1,1:nz,1:ncmax)
   299  
   300      do f = 1, ncmax
   301        name = trim(SpcWetSymbol(f))//"BasicZ"
   302        call HistoryGet( InputFile, name, Var3D, flag_mpi_split = FLAG_LIB_MPI )
   303        xyzf_QMixBZ(1:nx,1,1:nz,f) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J7 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t389 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t391 = 1, nx                                             
     .                 xyzf_qmixbz(t391,1,t389,f) = var3d(t391,1,t389)          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t389 = J7 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t391 = 1, nx                                             
     .                 xyzf_qmixbz(t391,1,t389,f) = var3d(t391,1,t389)          
     .                 xyzf_qmixbz(t391,1,t389+1,f) = var3d(t391,1,t389+1)      
     .                 xyzf_qmixbz(t391,1,t389+2,f) = var3d(t391,1,t389+2)      
     .                 xyzf_qmixbz(t391,1,t389+3,f) = var3d(t391,1,t389+3)      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   304      end do
   305      call SetMargin_xyzf( xyzf_QMixBZ )
   306  
   307      name = "EffMolWtBasicZ"
   308      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   309      xyz_EffMolWtBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J8 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t397 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t399 = 1, nx                                             
     .                 xyz_effmolwtbz(t399,1,t397) = var3d(t399,1,t397)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t397 = J8 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t399 = 1, nx                                             
     .                 xyz_effmolwtbz(t399,1,t397) = var3d(t399,1,t397)         
     .                 xyz_effmolwtbz(t399,1,t397+1) = var3d(t399,1,t397+1)     
     .                 xyz_effmolwtbz(t399,1,t397+2) = var3d(t399,1,t397+2)     
     .                 xyz_effmolwtbz(t399,1,t397+3) = var3d(t399,1,t397+3)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   310  
   311      call SetMargin_xyz( xyz_EffMolWtBZ )
   312  
   313    end subroutine Arare4fileio_BZ_Get
   314  
   315  
   316  
   317    subroutine Arare4fileio_MMC_Var_Get(   &
   318      & pyz_VelX,     & ! (out)
   319      & xqz_VelY,     & ! (out)
   320      & xyr_VelZ,     & ! (out)
   321      & xyz_PTemp,    & ! (out)
   322      & xyz_Exner,    & ! (out)
   323      & xyzf_QMix,    & ! (out)
   324      & xyz_Km,       & ! (out)
   325      & xyz_Kh,       & ! (out)
   326      & xyz_CDens   )   ! (out)
   327      !
   328      !ꥹȥե뤫
   329      !
   330  
   331      !ۤηػ
   332      implicit none
   333  
   334      !ѿ
   335      real(DP)              :: Var3D(1:nx, 1, 1:nz)
   336  !    real(DP)              :: Var4D(1:nx, 1, 1:nz, 1:ncmax)
   337      real(DP), intent(out) :: pyz_VelX &
   338        &                      (imin:imax,jmin:jmax,kmin:kmax)
   339      real(DP), intent(out) :: xqz_VelY &
   340        &                      (imin:imax,jmin:jmax,kmin:kmax)
   341      real(DP), intent(out) :: xyr_VelZ &
   342        &                      (imin:imax,jmin:jmax,kmin:kmax)
   343      real(DP), intent(out) :: xyz_Exner &
   344        &                      (imin:imax,jmin:jmax,kmin:kmax)
   345      real(DP), intent(out) :: xyz_PTemp &
   346        &                      (imin:imax,jmin:jmax,kmin:kmax)
   347      real(DP), intent(out) :: xyz_Km &
   348        &                      (imin:imax,jmin:jmax,kmin:kmax)
   349      real(DP), intent(out) :: xyz_Kh &
   350        &                      (imin:imax,jmin:jmax,kmin:kmax)
   351      real(DP), intent(out) :: xyz_CDens &
   352        &                      (imin:imax,jmin:jmax,kmin:kmax)
   353      real(DP), intent(out) :: xyzf_QMix &
   354        &                      (imin:imax,jmin:jmax,kmin:kmax,ncmax)
   355      real(DP)             :: RestartTime
   356  
   357      character(STRING)    :: name               !ѿ̾
   358      character(STRING)    :: name1
   359      character(STRING)    :: Time
   360      character(STRING)    :: InputFile
   361  
   362      !-------------------------------------------------------------
   363      ! Get a Value from netCDF File
   364      !-------------------------------------------------------------
   365      RestartTime = 0.0d0
   366      time = 't=' // trim(toChar( RestartTime ))
   367  
   368      name = "PotTemp"
   369      name1 = "PotTempDist"
   370      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   371      call HistoryGet( InputFile, name1, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   372      xyz_PTemp(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J1 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t533 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t535 = 1, nx                                             
     .                 xyz_ptemp(t535,1,t533) = var3d(t535,1,t533)              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t533 = J1 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t535 = 1, nx                                             
     .                 xyz_ptemp(t535,1,t533) = var3d(t535,1,t533)              
     .                 xyz_ptemp(t535,1,t533+1) = var3d(t535,1,t533+1)          
     .                 xyz_ptemp(t535,1,t533+2) = var3d(t535,1,t533+2)          
     .                 xyz_ptemp(t535,1,t533+3) = var3d(t535,1,t533+3)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   373  
   374      call SetMargin_xyz( xyz_PTemp )
   375  
   376      name = "VelX"
   377      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   378      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   379      pyz_VelX(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J2 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t541 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t543 = 1, nx                                             
     .                 pyz_velx(t543,1,t541) = var3d(t543,1,t541)               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t541 = J2 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t543 = 1, nx                                             
     .                 pyz_velx(t543,1,t541) = var3d(t543,1,t541)               
     .                 pyz_velx(t543,1,t541+1) = var3d(t543,1,t541+1)           
     .                 pyz_velx(t543,1,t541+2) = var3d(t543,1,t541+2)           
     .                 pyz_velx(t543,1,t541+3) = var3d(t543,1,t541+3)           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   380  
   381      call SetMargin_pyz( pyz_VelX )
   382  
   383      name = "VelY"
   384      xqz_VelY = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t549 = 1, (kmax + 1 - kmin)*(jmax + 1 - jmin)*(imax + 1 - imin)
     .           xqz_vely(t63+t549-1,t65,t67) = 0.0000000000000000e+000         
     .        end do                                                            
   385  
   386      name = "VelZ"
   387      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   388      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   389      xyr_VelZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J3 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t558 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t560 = 1, nx                                             
     .                 xyr_velz(t560,1,t558) = var3d(t560,1,t558)               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t558 = J3 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t560 = 1, nx                                             
     .                 xyr_velz(t560,1,t558) = var3d(t560,1,t558)               
     .                 xyr_velz(t560,1,t558+1) = var3d(t560,1,t558+1)           
     .                 xyr_velz(t560,1,t558+2) = var3d(t560,1,t558+2)           
     .                 xyr_velz(t560,1,t558+3) = var3d(t560,1,t558+3)           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   390  
   391      call SetMargin_xyr( xyr_VelZ )
   392  
   393      name = "Exner"
   394      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   395      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   396      xyz_Exner(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J4 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t566 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t568 = 1, nx                                             
     .                 xyz_exner(t568,1,t566) = var3d(t568,1,t566)              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t566 = J4 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t568 = 1, nx                                             
     .                 xyz_exner(t568,1,t566) = var3d(t568,1,t566)              
     .                 xyz_exner(t568,1,t566+1) = var3d(t568,1,t566+1)          
     .                 xyz_exner(t568,1,t566+2) = var3d(t568,1,t566+2)          
     .                 xyz_exner(t568,1,t566+3) = var3d(t568,1,t566+3)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   397  
   398      call SetMargin_xyz( xyz_Exner )
   399  
   400      name = "Km"
   401      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   402      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   403      xyz_Km(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J5 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t574 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t576 = 1, nx                                             
     .                 xyz_km(t576,1,t574) = var3d(t576,1,t574)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t574 = J5 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t576 = 1, nx                                             
     .                 xyz_km(t576,1,t574) = var3d(t576,1,t574)                 
     .                 xyz_km(t576,1,t574+1) = var3d(t576,1,t574+1)             
     .                 xyz_km(t576,1,t574+2) = var3d(t576,1,t574+2)             
     .                 xyz_km(t576,1,t574+3) = var3d(t576,1,t574+3)             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   404  
   405      call SetMargin_xyz( xyz_Km )
   406  
   407      name = "Kh"
   408      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   409      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   410      xyz_Kh(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J6 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t582 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t584 = 1, nx                                             
     .                 xyz_kh(t584,1,t582) = var3d(t584,1,t582)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t582 = J6 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t584 = 1, nx                                             
     .                 xyz_kh(t584,1,t582) = var3d(t584,1,t582)                 
     .                 xyz_kh(t584,1,t582+1) = var3d(t584,1,t582+1)             
     .                 xyz_kh(t584,1,t582+2) = var3d(t584,1,t582+2)             
     .                 xyz_kh(t584,1,t582+3) = var3d(t584,1,t582+3)             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   411  
   412      call SetMargin_xyz( xyz_Kh )
   413  
   414      name = "DensCloud"
   415      InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   416      call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   417      xyz_CDens(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J7 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t590 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t592 = 1, nx                                             
     .                 xyz_cdens(t592,1,t590) = var3d(t592,1,t590)              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t590 = J7 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t592 = 1, nx                                             
     .                 xyz_cdens(t592,1,t590) = var3d(t592,1,t590)              
     .                 xyz_cdens(t592,1,t590+1) = var3d(t592,1,t590+1)          
     .                 xyz_cdens(t592,1,t590+2) = var3d(t592,1,t590+2)          
     .                 xyz_cdens(t592,1,t590+3) = var3d(t592,1,t590+3)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   418  
   419      call SetMargin_xyz( xyz_CDens )
   420  
   421  !    name = "MixRt"
   422  !    InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   423  !    call HistoryGet( InputFile, name, Var4D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   424  !    xyzf_QMix(1:nx,1,1:nz,1:ncmax) = Var4D(1:nx,1,1:nz,1:ncmax)
   425      xyzf_QMix(1:nx,1,1:nz,1:ncmax) = 0.0d0
     .        if (nz .gt. 0) then                                               
     .           J8 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t600 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t602 = 1, nx                                             
     .                 xyzf_qmix(t602,1,t600,t598+1) = 0.0000000000000000e+000  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t600 = J8 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t602 = 1, nx                                             
     .                 xyzf_qmix(t602,1,t600,t598+1) = 0.0000000000000000e+000  
     .                 xyzf_qmix(t602,1,t600+1,t598+1) = 0.0000000000000000e+000
     .                 xyzf_qmix(t602,1,t600+2,t598+1) = 0.0000000000000000e+000
     .                 xyzf_qmix(t602,1,t600+3,t598+1) = 0.0000000000000000e+000
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   426  
   427    end subroutine Arare4fileio_MMC_Var_Get
   428  
   429  
   430    subroutine Arare4fileio_MMC_BZ_Get(   &
   431      & xyz_PressBZ,   &
   432      & xyz_ExnerBZ,   &
   433      & xyz_TempBZ,    &
   434      & xyz_PTempBZ, &
   435      & xyz_DensBZ,    &
   436      & xyz_VelSoundBZ,&
   437      & xyzf_QMixBZ,  &
   438      & xyz_EffMolWtBZ &
   439      & )
   440  
   441      !
   442      !ꥹȥե뤫
   443      !
   444  
   445      !ۤηػ
   446      implicit none
   447  
   448      !ѿ
   449      real(DP)              :: Var3D(1:nx,1,1:nz)
   450  !    real(DP)              :: Var4D(1:nx,1,1:nz,1:ncmax)
   451      real(DP), intent(out) :: xyz_ExnerBZ &
   452        &                     (imin:imax,jmin:jmax,kmin:kmax)
   453                                                 !ܾΥʡؿ
   454      real(DP), intent(out) :: xyz_DensBZ &
   455        &                     (imin:imax,jmin:jmax,kmin:kmax)
   456                                                 !ܾ̩
   457      real(DP), intent(out) :: xyz_PTempBZ &
   458        &                     (imin:imax,jmin:jmax,kmin:kmax)
   459                                                 !ܾβ
   460      real(DP), intent(out) :: xyz_VelSoundBZ &
   461        &                     (imin:imax,jmin:jmax,kmin:kmax)
   462                                                 !ܾβ®
   463      real(DP), intent(out) :: xyz_PressBZ &
   464        &                     (imin:imax,jmin:jmax,kmin:kmax)
   465                                                 !ܾΰ
   466      real(DP), intent(out) :: xyz_TempBZ &
   467        &                     (imin:imax,jmin:jmax,kmin:kmax)
   468                                                 !ܾβ
   469      real(DP), intent(out) :: xyzf_QMixBZ &
   470        &                     (imin:imax,jmin:jmax,kmin:kmax, ncmax)
   471                                                 !ܾκ
   472      real(DP), intent(out) :: xyz_EffMolWtBZ &
   473        &                     (imin:imax,jmin:jmax,kmin:kmax)
   474                                                 !ܾʬ̸
   475      character(STRING)    :: name               !ѿ̾
   476      character(STRING)    :: InputFile
   477  
   478      !-------------------------------------------------------------
   479      ! ܾμ
   480      !
   481      InputFile = trim(Arare4Prefix) // "BasicZ.nc"
   482  
   483      name = "DensBasicZ"
   484      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   485      xyz_DensBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J1 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t302 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t304 = 1, nx                                             
     .                 xyz_densbz(t304,1,t302) = var3d(t304,1,t302)             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t302 = J1 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t304 = 1, nx                                             
     .                 xyz_densbz(t304,1,t302) = var3d(t304,1,t302)             
     .                 xyz_densbz(t304,1,t302+1) = var3d(t304,1,t302+1)         
     .                 xyz_densbz(t304,1,t302+2) = var3d(t304,1,t302+2)         
     .                 xyz_densbz(t304,1,t302+3) = var3d(t304,1,t302+3)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   486  
   487      call SetMargin_xyz( xyz_DensBZ )
   488  
   489      name = "ExnerBasicZ"
   490      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   491      xyz_ExnerBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J2 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t310 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t312 = 1, nx                                             
     .                 xyz_exnerbz(t312,1,t310) = var3d(t312,1,t310)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t310 = J2 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t312 = 1, nx                                             
     .                 xyz_exnerbz(t312,1,t310) = var3d(t312,1,t310)            
     .                 xyz_exnerbz(t312,1,t310+1) = var3d(t312,1,t310+1)        
     .                 xyz_exnerbz(t312,1,t310+2) = var3d(t312,1,t310+2)        
     .                 xyz_exnerbz(t312,1,t310+3) = var3d(t312,1,t310+3)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   492  
   493      call SetMargin_xyz( xyz_ExnerBZ )
   494  
   495      name = "PotTempBasicZ"
   496      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   497      xyz_PTempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J3 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t318 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t320 = 1, nx                                             
     .                 xyz_ptempbz(t320,1,t318) = var3d(t320,1,t318)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t318 = J3 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t320 = 1, nx                                             
     .                 xyz_ptempbz(t320,1,t318) = var3d(t320,1,t318)            
     .                 xyz_ptempbz(t320,1,t318+1) = var3d(t320,1,t318+1)        
     .                 xyz_ptempbz(t320,1,t318+2) = var3d(t320,1,t318+2)        
     .                 xyz_ptempbz(t320,1,t318+3) = var3d(t320,1,t318+3)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   498  
   499      call SetMargin_xyz( xyz_PTempBZ )
   500  
   501      name = "VelSoundBasicZ"
   502      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   503      xyz_VelSoundBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J4 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t326 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t328 = 1, nx                                             
     .                 xyz_velsoundbz(t328,1,t326) = var3d(t328,1,t326)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t326 = J4 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t328 = 1, nx                                             
     .                 xyz_velsoundbz(t328,1,t326) = var3d(t328,1,t326)         
     .                 xyz_velsoundbz(t328,1,t326+1) = var3d(t328,1,t326+1)     
     .                 xyz_velsoundbz(t328,1,t326+2) = var3d(t328,1,t326+2)     
     .                 xyz_velsoundbz(t328,1,t326+3) = var3d(t328,1,t326+3)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   504  
   505      call SetMargin_xyz( xyz_VelSoundBZ )
   506  
   507      name = "TempBasicZ"
   508      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   509      xyz_TempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J5 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t334 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t336 = 1, nx                                             
     .                 xyz_tempbz(t336,1,t334) = var3d(t336,1,t334)             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t334 = J5 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t336 = 1, nx                                             
     .                 xyz_tempbz(t336,1,t334) = var3d(t336,1,t334)             
     .                 xyz_tempbz(t336,1,t334+1) = var3d(t336,1,t334+1)         
     .                 xyz_tempbz(t336,1,t334+2) = var3d(t336,1,t334+2)         
     .                 xyz_tempbz(t336,1,t334+3) = var3d(t336,1,t334+3)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   510  
   511      call SetMargin_xyz( xyz_TempBZ )
   512  
   513      name = "PressBasicZ"
   514      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   515      xyz_PressBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J6 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t342 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t344 = 1, nx                                             
     .                 xyz_pressbz(t344,1,t342) = var3d(t344,1,t342)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t342 = J6 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t344 = 1, nx                                             
     .                 xyz_pressbz(t344,1,t342) = var3d(t344,1,t342)            
     .                 xyz_pressbz(t344,1,t342+1) = var3d(t344,1,t342+1)        
     .                 xyz_pressbz(t344,1,t342+2) = var3d(t344,1,t342+2)        
     .                 xyz_pressbz(t344,1,t342+3) = var3d(t344,1,t342+3)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   516  
   517      call SetMargin_xyz( xyz_PressBZ)
   518  
   519  !    name = "MixRtBasicZ"
   520  !    call HistoryGet( InputFile, name, Var4D(:,1,:,:), flag_mpi_split = FLAG_LIB_MPI )
   521  !    xyzf_QMixBZ(1:nx,1,1:nz) = Var4D(1:nx,1,1:nz)
   522       xyzf_QMixBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t350=1,ncmax*(kmax+1-kmin)*(jmax+1-jmin)*(imax+1-imin)         
     .           xyzf_qmixbz(t71+t350-1,t73,t75,1) = 0.0000000000000000e+000    
     .        end do                                                            
   523  
   524      name = "EffMolWtBasicZ"
   525      call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   526      xyz_EffMolWtBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
     .        if (nz .gt. 0) then                                               
     .           J7 = and(nz,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t362 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t364 = 1, nx                                             
     .                 xyz_effmolwtbz(t364,1,t362) = var3d(t364,1,t362)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t362 = J7 + 1, nz, 4                                        
     .  !CDIR       NODEP                                                       
     .              do t364 = 1, nx                                             
     .                 xyz_effmolwtbz(t364,1,t362) = var3d(t364,1,t362)         
     .                 xyz_effmolwtbz(t364,1,t362+1) = var3d(t364,1,t362+1)     
     .                 xyz_effmolwtbz(t364,1,t362+2) = var3d(t364,1,t362+2)     
     .                 xyz_effmolwtbz(t364,1,t362+3) = var3d(t364,1,t362+3)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   527  
   528      call SetMargin_xyz( xyz_EffMolWtBZ )
   529  
   530    end subroutine Arare4fileio_MMC_BZ_Get
   531  
   532  end module Arare4fileio
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:13 2011
FILE NAME: arare4fileio.f90
PROGRAM NAME: 
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   533  warn (   6): Only comment lines in program.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:13 2011
FILE NAME: arare4fileio.f90
PROGRAM NAME: 
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

   533  
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:13 2011
FILE NAME: arare4fileio.f90
PROGRAM NAME: arare4fileio
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module Arare4fileio
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4:            ! Version::   $Id: arare4fileio.f90,v 1.10 2011-06-17 19:07:25 sugiyama Exp $ 
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview 
    10:            !
    11:            !ꥹѤξξ netCDF ե˽Ϥ뤿Υ롼
    12:            !
    13:            !== Error Handling
    14:            !
    15:            !== Known Bugs
    16:            !
    17:            !== Note
    18:            !
    19:            !®٤ɾʻҰ֤, ȤϤƤɸͤŪǤʤȤ
    20:            !
    21:            !== Future Plans
    22:            !
    23:            
    24:            module Arare4fileio
    25:              !
    26:              !ꥹѤξξ netCDF ե˽Ϥ뤿Υ롼
    27:              !
    28:            
    29:              !⥸塼ɤ߹
    30:              use gtool_history
    31:              use dc_types,  only : DP, STRING
    32:              use dc_message,only : MessageNotify
    33:              use dc_string, only : toChar
    34:              use dc_iounit, only : FileOpen
    35:              use mpi_wrapper,   only: myrank, FLAG_LIB_MPI
    36:              use gridset,  only: &
    37:                &                 imin,           &!X β
    38:                &                 imax,           &!X ξ
    39:                &                 jmin,           &!Y β
    40:                &                 jmax,           &!Y ξ
    41:                &                 kmin,           &!Z β
    42:                &                 kmax,           &!Z ξ
    43:                &                 nx,nz,ncmax              !Žʬο
    44:              use setmargin
    45:              use composition, only: SpcWetSymbol
    46:              use namelist_util, only: namelist_filename
    47:            
    48:              !ۤηػ
    49:              implicit none
    50:              
    51:              !°λ
    52:              private
    53:            
    54:              !ؿ public ˻
    55:              public Arare4fileio_init
    56:              public Arare4fileio_BZ_Get
    57:              public Arare4fileio_Var_Get
    58:              public Arare4fileio_MMC_BZ_Get
    59:              public Arare4fileio_MMC_Var_Get
    60:            
    61:              character(STRING), save :: Arare4Prefix  = "arare4_"
    62:              
    63:            contains
    64:            
    65:              subroutine Arare4fileio_Init
    66:                !
    67:                !ꥹȥեν񤭽Ф
    68:                !
    69:                !ۤηػ
    70:                implicit none
    71:            
    72:                !ѿ
    73:                integer            :: unit     !ֹ
    74:                 
    75:                !NAMELIST 
    76:                NAMELIST /arare4fileio_nml/ Arare4Prefix
    77:                
    78:                call FileOpen(unit, file=namelist_filename, mode='r')
    79:                read(unit, NML=arare4fileio_nml)
    80:                close(unit)
    81:                
    82:                !ǧ
    83:                if (myrank == 0) then 
    84:                  call MessageNotify( "M", &
    85:                    & "arare4FileIO_init", "Arare4Prefix = %c", c1=trim(Arare4Prefix) )
    86:                end if
    87:            
    88:              end subroutine Arare4fileio_Init
    89:              
    90:              
    91:              subroutine Arare4fileio_Var_Get(   &
    92:                & pyz_VelX,     & ! (out)
    93:                & xqz_VelY,     & ! (out)
    94:                & xyr_VelZ,     & ! (out)
    95:                & xyz_PTemp,    & ! (out)
    96:                & xyz_Exner,    & ! (out)
    97:                & xyzf_QMix,    & ! (out)
    98:                & xyz_Km,       & ! (out)
    99:                & xyz_Kh,       & ! (out)
   100:                & xyz_CDens   )   ! (out)
   101:                !
   102:                !ꥹȥե뤫
   103:                !
   104:            
   105:                !ۤηػ
   106:                implicit none
   107:            
   108:                !ѿ
   109:                real(DP)              :: Var3D(1:nx, 1, 1:nz)
   110:                real(DP), intent(out) :: pyz_VelX &
   111:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   112:                real(DP), intent(out) :: xqz_VelY &
   113:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   114:                real(DP), intent(out) :: xyr_VelZ &
   115:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   116:                real(DP), intent(out) :: xyz_Exner &
   117:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   118:                real(DP), intent(out) :: xyz_PTemp &
   119:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   120:                real(DP), intent(out) :: xyz_Km &
   121:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   122:                real(DP), intent(out) :: xyz_Kh &
   123:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   124:                real(DP), intent(out) :: xyz_CDens &
   125:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   126:                real(DP), intent(out) :: xyzf_QMix &
   127:                  &                      (imin:imax,jmin:jmax,kmin:kmax,ncmax)
   128:                real(DP)             :: RestartTime
   129:                integer              :: f
   130:            
   131:                character(STRING)    :: name               !ѿ̾
   132:            !    character(STRING)    :: name1
   133:                character(STRING)    :: Time
   134:                character(STRING)    :: InputFile
   135:            
   136:                !-------------------------------------------------------------
   137:                ! Get a Value from netCDF File
   138:                !-------------------------------------------------------------    
   139:                RestartTime = 0.0d0
   140:                time = 't=' // trim(toChar( RestartTime ))
   141:            
   142:                name = "PotTemp"
   143:            !    name1 = "PotTempDist"
   144:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   145:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   146: +V=====        xyz_PTemp(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   147:            
   148:                call SetMargin_xyz( xyz_PTemp )
   149:            
   150:                name = "VelX"
   151:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   152:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   153: +V=====        pyz_VelX(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   154:            
   155:                call SetMargin_pyz( pyz_VelX )
   156:            
   157:                name = "VelY"
   158: W++====        xqz_VelY = 0.0d0
   159:            
   160:                name = "VelZ"
   161:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   162:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   163: +V=====        xyr_VelZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   164:            
   165:                call SetMargin_xyr( xyr_VelZ )
   166:            
   167:                name = "Exner"
   168:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   169:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   170: +V=====        xyz_Exner(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   171:            
   172:                call SetMargin_xyz( xyz_Exner )
   173:            
   174:                name = "Km"
   175:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   176:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   177: +V=====        xyz_Km(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   178:                
   179:                call SetMargin_xyz( xyz_Km )
   180:            
   181:                name = "Kh"
   182:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   183:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   184: +V=====        xyz_Kh(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   185:            
   186:                call SetMargin_xyz( xyz_Kh )
   187:                  
   188:            !    name = "MixRt"
   189:            !    InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   190:            !    call HistoryGet( InputFile, name, Var4D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   191:            !    xyzf_QMix(1:nx,1,1:nz,1:ncmax) = Var4D(1:nx,1,1:nz,1:ncmax)
   192: +------>       do f = 1, ncmax
   193: |                name = trim(SpcWetSymbol(f))
   194: |                InputFile = trim(Arare4Prefix) // trim(SpcWetSymbol(f)) // ".nc"
   195: |                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   196: |+V====          xyzf_QMix(1:nx,1,1:nz,f) = Var3D(1:nx,1,1:nz)
   197: +------        end do
   198:            
   199:                call SetMargin_xyzf( xyzf_QMix )
   200:            
   201:                name = "CloudDensity"    
   202: W++====        xyz_CDens = 0.0d0
   203:            
   204:              end subroutine Arare4fileio_Var_Get
   205:                   
   206:            
   207:              subroutine Arare4fileio_BZ_Get(   &
   208:                & xyz_PressBZ,   &
   209:                & xyz_ExnerBZ,   &
   210:                & xyz_TempBZ,    &
   211:                & xyz_PTempBZ, &
   212:                & xyz_DensBZ,    &
   213:                & xyz_VelSoundBZ,&
   214:                & xyzf_QMixBZ,  &
   215:                & xyz_EffMolWtBZ &
   216:                & )
   217:            
   218:                !
   219:                !ꥹȥե뤫
   220:                !
   221:            
   222:                !ۤηػ
   223:                implicit none
   224:            
   225:                !ѿ
   226:                real(DP)              :: Var3D(1:nx,1,1:nz)
   227:                real(DP), intent(out) :: xyz_ExnerBZ &
   228:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   229:                                                           !ܾΥʡؿ
   230:                real(DP), intent(out) :: xyz_DensBZ &
   231:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   232:                                                           !ܾ̩
   233:                real(DP), intent(out) :: xyz_PTempBZ &
   234:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   235:                                                           !ܾβ
   236:                real(DP), intent(out) :: xyz_VelSoundBZ &
   237:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   238:                                                           !ܾβ®
   239:                real(DP), intent(out) :: xyz_PressBZ &
   240:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   241:                                                           !ܾΰ
   242:                real(DP), intent(out) :: xyz_TempBZ &
   243:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   244:                                                           !ܾβ
   245:                real(DP), intent(out) :: xyzf_QMixBZ &
   246:                  &                     (imin:imax,jmin:jmax,kmin:kmax, ncmax)
   247:                                                           !ܾκ
   248:                real(DP), intent(out) :: xyz_EffMolWtBZ &
   249:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   250:                                                           !ܾʬ̸
   251:                character(STRING)    :: name               !ѿ̾
   252:                character(STRING)    :: InputFile
   253:                integer              :: f
   254:             
   255:                !-------------------------------------------------------------
   256:                ! ܾμ
   257:                !
   258:                InputFile = trim(Arare4Prefix) // "BasicZ.nc"
   259:            
   260:                name = "DensBasicZ"
   261:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   262: +V=====        xyz_DensBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   263:                
   264:                call SetMargin_xyz( xyz_DensBZ )
   265:            
   266:                name = "ExnerBasicZ"
   267:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   268: +V=====        xyz_ExnerBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   269:            
   270:                call SetMargin_xyz( xyz_ExnerBZ )
   271:                
   272:                name = "PotTempBasicZ"
   273:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   274: +V=====        xyz_PTempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   275:            
   276:                call SetMargin_xyz( xyz_PTempBZ )
   277:                
   278:                name = "VelSoundBasicZ"
   279:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   280: +V=====        xyz_VelSoundBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   281:            
   282:                call SetMargin_xyz( xyz_VelSoundBZ )
   283:                
   284:                name = "TempBasicZ"
   285:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   286: +V=====        xyz_TempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   287:            
   288:                call SetMargin_xyz( xyz_TempBZ )
   289:                
   290:                name = "PressBasicZ"
   291:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   292: +V=====        xyz_PressBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   293:                
   294:                call SetMargin_xyz( xyz_PressBZ)
   295:            
   296:            !    name = "MixRtBasicZ"
   297:            !    call HistoryGet( InputFile, name, Var4D(:,1,:,:), flag_mpi_split = FLAG_LIB_MPI )
   298:            !    xyzf_QMixBZ(1:nx,1,1:nz,1:ncmax) = Var4D(1:nx,1,1:nz,1:ncmax)
   299:            
   300: +------>       do f = 1, ncmax
   301: |                name = trim(SpcWetSymbol(f))//"BasicZ"
   302: |                call HistoryGet( InputFile, name, Var3D, flag_mpi_split = FLAG_LIB_MPI )
   303: |+V====          xyzf_QMixBZ(1:nx,1,1:nz,f) = Var3D(1:nx,1,1:nz)
   304: +------        end do
   305:                call SetMargin_xyzf( xyzf_QMixBZ )
   306:               
   307:                name = "EffMolWtBasicZ"
   308:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   309: +V=====        xyz_EffMolWtBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   310:            
   311:                call SetMargin_xyz( xyz_EffMolWtBZ )
   312:            
   313:              end subroutine Arare4fileio_BZ_Get
   314:            
   315:            
   316:                   
   317:              subroutine Arare4fileio_MMC_Var_Get(   &
   318:                & pyz_VelX,     & ! (out)
   319:                & xqz_VelY,     & ! (out)
   320:                & xyr_VelZ,     & ! (out)
   321:                & xyz_PTemp,    & ! (out)
   322:                & xyz_Exner,    & ! (out)
   323:                & xyzf_QMix,    & ! (out)
   324:                & xyz_Km,       & ! (out)
   325:                & xyz_Kh,       & ! (out)
   326:                & xyz_CDens   )   ! (out)
   327:                !
   328:                !ꥹȥե뤫
   329:                !
   330:            
   331:                !ۤηػ
   332:                implicit none
   333:            
   334:                !ѿ
   335:                real(DP)              :: Var3D(1:nx, 1, 1:nz)
   336:            !    real(DP)              :: Var4D(1:nx, 1, 1:nz, 1:ncmax)
   337:                real(DP), intent(out) :: pyz_VelX &
   338:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   339:                real(DP), intent(out) :: xqz_VelY &
   340:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   341:                real(DP), intent(out) :: xyr_VelZ &
   342:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   343:                real(DP), intent(out) :: xyz_Exner &
   344:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   345:                real(DP), intent(out) :: xyz_PTemp &
   346:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   347:                real(DP), intent(out) :: xyz_Km &
   348:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   349:                real(DP), intent(out) :: xyz_Kh &
   350:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   351:                real(DP), intent(out) :: xyz_CDens &
   352:                  &                      (imin:imax,jmin:jmax,kmin:kmax)
   353:                real(DP), intent(out) :: xyzf_QMix &
   354:                  &                      (imin:imax,jmin:jmax,kmin:kmax,ncmax)
   355:                real(DP)             :: RestartTime
   356:            
   357:                character(STRING)    :: name               !ѿ̾
   358:                character(STRING)    :: name1
   359:                character(STRING)    :: Time
   360:                character(STRING)    :: InputFile
   361:            
   362:                !-------------------------------------------------------------
   363:                ! Get a Value from netCDF File
   364:                !-------------------------------------------------------------    
   365:                RestartTime = 0.0d0
   366:                time = 't=' // trim(toChar( RestartTime ))
   367:            
   368:                name = "PotTemp"
   369:                name1 = "PotTempDist"
   370:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   371:                call HistoryGet( InputFile, name1, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   372: +V=====        xyz_PTemp(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   373:            
   374:                call SetMargin_xyz( xyz_PTemp )
   375:            
   376:                name = "VelX"
   377:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   378:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   379: +V=====        pyz_VelX(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   380:            
   381:                call SetMargin_pyz( pyz_VelX )
   382:            
   383:                name = "VelY"
   384: W++====        xqz_VelY = 0.0d0
   385:            
   386:                name = "VelZ"
   387:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   388:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   389: +V=====        xyr_VelZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   390:            
   391:                call SetMargin_xyr( xyr_VelZ )
   392:            
   393:                name = "Exner"
   394:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   395:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   396: +V=====        xyz_Exner(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   397:            
   398:                call SetMargin_xyz( xyz_Exner )
   399:            
   400:                name = "Km"
   401:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   402:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   403: +V=====        xyz_Km(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   404:                
   405:                call SetMargin_xyz( xyz_Km )
   406:            
   407:                name = "Kh"
   408:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   409:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   410: +V=====        xyz_Kh(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   411:            
   412:                call SetMargin_xyz( xyz_Kh )
   413:            
   414:                name = "DensCloud"
   415:                InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   416:                call HistoryGet( InputFile, name, Var3D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   417: +V=====        xyz_CDens(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   418:            
   419:                call SetMargin_xyz( xyz_CDens )
   420:                  
   421:            !    name = "MixRt"
   422:            !    InputFile = trim(Arare4Prefix) // trim(name) // ".nc"
   423:            !    call HistoryGet( InputFile, name, Var4D, range=Time, flag_mpi_split = FLAG_LIB_MPI )
   424:            !    xyzf_QMix(1:nx,1,1:nz,1:ncmax) = Var4D(1:nx,1,1:nz,1:ncmax)
   425: ++V====        xyzf_QMix(1:nx,1,1:nz,1:ncmax) = 0.0d0
   426:                
   427:              end subroutine Arare4fileio_MMC_Var_Get
   428:                   
   429:            
   430:              subroutine Arare4fileio_MMC_BZ_Get(   &
   431:                & xyz_PressBZ,   &
   432:                & xyz_ExnerBZ,   &
   433:                & xyz_TempBZ,    &
   434:                & xyz_PTempBZ, &
   435:                & xyz_DensBZ,    &
   436:                & xyz_VelSoundBZ,&
   437:                & xyzf_QMixBZ,  &
   438:                & xyz_EffMolWtBZ &
   439:                & )
   440:            
   441:                !
   442:                !ꥹȥե뤫
   443:                !
   444:            
   445:                !ۤηػ
   446:                implicit none
   447:            
   448:                !ѿ
   449:                real(DP)              :: Var3D(1:nx,1,1:nz)
   450:            !    real(DP)              :: Var4D(1:nx,1,1:nz,1:ncmax)
   451:                real(DP), intent(out) :: xyz_ExnerBZ &
   452:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   453:                                                           !ܾΥʡؿ
   454:                real(DP), intent(out) :: xyz_DensBZ &
   455:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   456:                                                           !ܾ̩
   457:                real(DP), intent(out) :: xyz_PTempBZ &
   458:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   459:                                                           !ܾβ
   460:                real(DP), intent(out) :: xyz_VelSoundBZ &
   461:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   462:                                                           !ܾβ®
   463:                real(DP), intent(out) :: xyz_PressBZ &
   464:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   465:                                                           !ܾΰ
   466:                real(DP), intent(out) :: xyz_TempBZ &
   467:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   468:                                                           !ܾβ
   469:                real(DP), intent(out) :: xyzf_QMixBZ &
   470:                  &                     (imin:imax,jmin:jmax,kmin:kmax, ncmax)
   471:                                                           !ܾκ
   472:                real(DP), intent(out) :: xyz_EffMolWtBZ &
   473:                  &                     (imin:imax,jmin:jmax,kmin:kmax)
   474:                                                           !ܾʬ̸
   475:                character(STRING)    :: name               !ѿ̾
   476:                character(STRING)    :: InputFile
   477:             
   478:                !-------------------------------------------------------------
   479:                ! ܾμ
   480:                !
   481:                InputFile = trim(Arare4Prefix) // "BasicZ.nc"
   482:            
   483:                name = "DensBasicZ"
   484:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   485: +V=====        xyz_DensBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   486:                
   487:                call SetMargin_xyz( xyz_DensBZ )
   488:            
   489:                name = "ExnerBasicZ"
   490:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   491: +V=====        xyz_ExnerBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   492:            
   493:                call SetMargin_xyz( xyz_ExnerBZ )
   494:                
   495:                name = "PotTempBasicZ"
   496:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   497: +V=====        xyz_PTempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   498:            
   499:                call SetMargin_xyz( xyz_PTempBZ )
   500:                
   501:                name = "VelSoundBasicZ"
   502:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   503: +V=====        xyz_VelSoundBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   504:            
   505:                call SetMargin_xyz( xyz_VelSoundBZ )
   506:                
   507:                name = "TempBasicZ"
   508:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   509: +V=====        xyz_TempBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   510:            
   511:                call SetMargin_xyz( xyz_TempBZ )
   512:                
   513:                name = "PressBasicZ"
   514:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   515: +V=====        xyz_PressBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   516:                
   517:                call SetMargin_xyz( xyz_PressBZ)
   518:            
   519:            !    name = "MixRtBasicZ"
   520:            !    call HistoryGet( InputFile, name, Var4D(:,1,:,:), flag_mpi_split = FLAG_LIB_MPI )
   521:            !    xyzf_QMixBZ(1:nx,1,1:nz) = Var4D(1:nx,1,1:nz)
   522: W+++===         xyzf_QMixBZ = 0.0d0
   523:                
   524:                name = "EffMolWtBasicZ"
   525:                call HistoryGet( InputFile, name, Var3D(:,1,:), flag_mpi_split = FLAG_LIB_MPI )
   526: +V=====        xyz_EffMolWtBZ(1:nx,1,1:nz) = Var3D(1:nx,1,1:nz)
   527:            
   528:                call SetMargin_xyz( xyz_EffMolWtBZ )
   529:            
   530:              end subroutine Arare4fileio_MMC_BZ_Get
   531:                   
   532:            end module Arare4fileio
