Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:40 2011
FILE NAME: basicset.f90
PROGRAM NAME: basicset
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    98  opt  (1222): Procedure "basicset_array_init" expanded inline.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
    98  vec  (   1): Vectorized loop.
   101  opt  (  11): Fused array assignments. :line 101 - 106
   101  vec  (   4): Vectorized array expression.
   107  vec  (   4): Vectorized array expression.
   107  vec  (   4): Vectorized array expression.
   110  vec  (   4): Vectorized array expression.
   110  vec  (   4): Vectorized array expression.
   111  vec  (   4): Vectorized array expression.
   113  vec  (   3): Unvectorized loop.
   114  vec  (   4): Vectorized array expression.
   114  vec  (   4): Vectorized array expression.
   118  vec  (   4): Vectorized array expression.
   118  vec  (   4): Vectorized array expression.
   118  vec  (   4): Vectorized array expression.
   118  vec  (   4): Vectorized array expression.
   118  vec  (   4): Vectorized array expression.
   119  vec  (   4): Vectorized array expression.
   119  vec  (   4): Vectorized array expression.
   119  vec  (   4): Vectorized array expression.
   119  vec  (   4): Vectorized array expression.
   119  vec  (   4): Vectorized array expression.
   120  vec  (   4): Vectorized array expression.
   120  vec  (   4): Vectorized array expression.
   120  vec  (   4): Vectorized array expression.
   120  vec  (   4): Vectorized array expression.
   120  vec  (   4): Vectorized array expression.
   121  vec  (   4): Vectorized array expression.
   121  vec  (   4): Vectorized array expression.
   121  vec  (   4): Vectorized array expression.
   121  vec  (   4): Vectorized array expression.
   121  vec  (   4): Vectorized array expression.
   124  vec  (   4): Vectorized array expression.
   124  vec  (   4): Vectorized array expression.
   153  vec  (   4): Vectorized array expression.
   154  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   156  vec  (   4): Vectorized array expression.
   157  vec  (   4): Vectorized array expression.
   158  vec  (   4): Vectorized array expression.
   159  vec  (   4): Vectorized array expression.
   160  vec  (   4): Vectorized array expression.
   161  vec  (   4): Vectorized array expression.
   163  vec  (   4): Vectorized array expression.
   164  vec  (   4): Vectorized array expression.
   165  vec  (   4): Vectorized array expression.
   166  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:40 2011
FILE NAME: basicset.f90
PROGRAM NAME: basicset
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module BasicSet
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4  ! Version::   $Id: basicset.f90,v 1.9 2011-10-04 05:17:35 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  ! ǥեȤδܾꤹ뤿ѿȷ⥸塼
    12  ! * BasicEnvFile_init: ܾͤ netCDF ե뤫
    13  ! * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
    14  !
    15  !== Error Handling
    16  !
    17  !== Known Bugs
    18  !
    19  !== Note
    20  !
    21  !== Future Plans
    22  !
    23  
    24  module basicset
    25    !
    26    !ǥեȤδܾꤹ뤿ѿȷ⥸塼
    27    !, hogeBZ Ȥʤ, ͤϤ뤳Ȥ
    28    !Ԥ.
    29    !
    30  
    31    !⥸塼ɤ߹
    32    use dc_types,   only: DP
    33    use gridset,    only: imin,       &!  X β
    34      &                   imax,       &!  X ξ
    35      &                   jmin,       &!  Z β
    36      &                   jmax,       &!  Z ξ
    37      &                   kmin,       &!  Z β
    38      &                   kmax,       &!  Z ξ
    39      &                   ncmax           ! ؼο
    40    use axesset,  only: xyr_avr_xyz
    41    use composition, only: GasNum,       &!Το
    42      &                 IdxG,         &!Τź
    43      &                 MolWtWet       !Žʬʬ
    44  
    45    !ۤηػ
    46    implicit none
    47  
    48    !save °
    49    private
    50  
    51    !Public Interface
    52    real(DP), allocatable, save, public :: xyz_DensBZ(:,:,:)    !̩
    53    real(DP), allocatable, save, public :: xyz_PressBZ(:,:,:)   !̵
    54    real(DP), allocatable, save, public :: xyz_ExnerBZ(:,:,:)   !̵
    55    real(DP), allocatable, save, public :: xyz_TempBZ(:,:,:)    !
    56    real(DP), allocatable, save, public :: xyz_PTempBZ(:,:,:) !
    57    real(DP), allocatable, save, public :: xyz_VPTempBZ(:,:,:) !
    58    real(DP), allocatable, save, public :: xyz_VelSoundBZ(:,:,:)!®
    59    real(DP), allocatable, save, public :: xyzf_QMixBZ(:,:,:,:)!Žʬ
    60    real(DP), allocatable, save, public :: xyz_EffMolWtBZ(:,:,:)!ʬ̸
    61    real(DP), allocatable, save, public :: xyz_QMixBZPerMolWt(:,:,:)
    62                                !ܾκ / ʬ 
    63    real(DP), allocatable, save, public :: xyr_QMixBZPerMolWt(:,:,:)
    64                                !ܾκ / ʬ 
    65    real(DP), allocatable, save, public :: xyz_QMixBZ(:,:,:)
    66                                !ܾκ
    67    real(DP), allocatable, save, public :: xyr_QMixBZ(:,:,:)
    68                                !ܾκ
    69  
    70    public basicset_init
    71  
    72  contains
    73  
    74  !!!-----------------------------------------------------------------!!!
    75    subroutine basicset_init(                                     &
    76      &   xyz_Press, xyz_Exner, xyz_Temp, xyz_PTemp, xyz_Dens,    &
    77      &   xyz_VelSound, xyzf_QMix, xyz_EffMolWt &
    78      & )
    79      !
    80      ! ܾͤ.
    81      ! dry ξϺ䴥ʬȶŷʬ¸ۤ˻ȤʤΤ,
    82      ! ѿ optional ˤƤ.
    83      !
    84  
    85      !ѿ
    86      real(DP), intent(in) :: xyz_Press(imin:imax,jmin:jmax,kmin:kmax)
    87      real(DP), intent(in) :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax)
    88      real(DP), intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
    89      real(DP), intent(in) :: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax)
    90      real(DP), intent(in) :: xyz_Dens(imin:imax,jmin:jmax,kmin:kmax)
    91      real(DP), intent(in) :: xyz_VelSound(imin:imax,jmin:jmax,kmin:kmax)
    92      real(DP), intent(in), optional :: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax,ncmax)
    93      real(DP), intent(in), optional :: xyz_EffMolWt(imin:imax,jmin:jmax,kmin:kmax)
    94      real(DP)             :: xyzf_QMixBZPerMolWt(imin:imax,jmin:jmax,kmin:kmax,GasNum)
    95      integer              :: s
    96  
    97      ! ν
    98      call basicset_array_init
     .        xyz_densbz.DSC.RANK = 3                                           
     .        xyz_densbz.DSC.L1 = imin                                          
     .        xyz_densbz.DSC.U1 = imax                                          
     .        xyz_densbz.DSC.L2 = jmin                                          
     .        xyz_densbz.DSC.U2 = jmax                                          
     .        xyz_densbz.DSC.L3 = kmin                                          
     .        xyz_densbz.DSC.U3 = kmax                                          
     .        allocate (xyz_densbz(xyz_densbz.DSC.L1:xyz_densbz.DSC.U1,         
     .       1   xyz_densbz.DSC.L2:xyz_densbz.DSC.U2,xyz_densbz.DSC.L3:         
     .       2   xyz_densbz.DSC.U3))                                            
     .        xyz_pressbz.DSC.RANK = 3                                          
     .        xyz_pressbz.DSC.L1 = imin                                         
     .        xyz_pressbz.DSC.U1 = imax                                         
     .        xyz_pressbz.DSC.L2 = jmin                                         
     .        xyz_pressbz.DSC.U2 = jmax                                         
     .        xyz_pressbz.DSC.L3 = kmin                                         
     .        xyz_pressbz.DSC.U3 = kmax                                         
     .        allocate (xyz_pressbz(xyz_pressbz.DSC.L1:xyz_pressbz.DSC.U1,      
     .       1   xyz_pressbz.DSC.L2:xyz_pressbz.DSC.U2,xyz_pressbz.DSC.L3:      
     .       2   xyz_pressbz.DSC.U3))                                           
     .        xyz_exnerbz.DSC.RANK = 3                                          
     .        xyz_exnerbz.DSC.L1 = imin                                         
     .        xyz_exnerbz.DSC.U1 = imax                                         
     .        xyz_exnerbz.DSC.L2 = jmin                                         
     .        xyz_exnerbz.DSC.U2 = jmax                                         
     .        xyz_exnerbz.DSC.L3 = kmin                                         
     .        xyz_exnerbz.DSC.U3 = kmax                                         
     .        allocate (xyz_exnerbz(xyz_exnerbz.DSC.L1:xyz_exnerbz.DSC.U1,      
     .       1   xyz_exnerbz.DSC.L2:xyz_exnerbz.DSC.U2,xyz_exnerbz.DSC.L3:      
     .       2   xyz_exnerbz.DSC.U3))                                           
     .        xyz_tempbz.DSC.RANK = 3                                           
     .        xyz_tempbz.DSC.L1 = imin                                          
     .        xyz_tempbz.DSC.U1 = imax                                          
     .        xyz_tempbz.DSC.L2 = jmin                                          
     .        xyz_tempbz.DSC.U2 = jmax                                          
     .        xyz_tempbz.DSC.L3 = kmin                                          
     .        xyz_tempbz.DSC.U3 = kmax                                          
     .        allocate (xyz_tempbz(xyz_tempbz.DSC.L1:xyz_tempbz.DSC.U1,         
     .       1   xyz_tempbz.DSC.L2:xyz_tempbz.DSC.U2,xyz_tempbz.DSC.L3:         
     .       2   xyz_tempbz.DSC.U3))                                            
     .        xyz_ptempbz.DSC.RANK = 3                                          
     .        xyz_ptempbz.DSC.L1 = imin                                         
     .        xyz_ptempbz.DSC.U1 = imax                                         
     .        xyz_ptempbz.DSC.L2 = jmin                                         
     .        xyz_ptempbz.DSC.U2 = jmax                                         
     .        xyz_ptempbz.DSC.L3 = kmin                                         
     .        xyz_ptempbz.DSC.U3 = kmax                                         
     .        allocate (xyz_ptempbz(xyz_ptempbz.DSC.L1:xyz_ptempbz.DSC.U1,      
     .       1   xyz_ptempbz.DSC.L2:xyz_ptempbz.DSC.U2,xyz_ptempbz.DSC.L3:      
     .       2   xyz_ptempbz.DSC.U3))                                           
     .        xyz_vptempbz.DSC.RANK = 3                                         
     .        xyz_vptempbz.DSC.L1 = imin                                        
     .        xyz_vptempbz.DSC.U1 = imax                                        
     .        xyz_vptempbz.DSC.L2 = jmin                                        
     .        xyz_vptempbz.DSC.U2 = jmax                                        
     .        xyz_vptempbz.DSC.L3 = kmin                                        
     .        xyz_vptempbz.DSC.U3 = kmax                                        
     .        allocate (xyz_vptempbz(xyz_vptempbz.DSC.L1:xyz_vptempbz.DSC.U1,   
     .       1   xyz_vptempbz.DSC.L2:xyz_vptempbz.DSC.U2,xyz_vptempbz.DSC.L3:   
     .       2   xyz_vptempbz.DSC.U3))                                          
     .        xyz_velsoundbz.DSC.RANK = 3                                       
     .        xyz_velsoundbz.DSC.L1 = imin                                      
     .        xyz_velsoundbz.DSC.U1 = imax                                      
     .        xyz_velsoundbz.DSC.L2 = jmin                                      
     .        xyz_velsoundbz.DSC.U2 = jmax                                      
     .        xyz_velsoundbz.DSC.L3 = kmin                                      
     .        xyz_velsoundbz.DSC.U3 = kmax                                      
     .        allocate (xyz_velsoundbz(xyz_velsoundbz.DSC.L1:                   
     .       1   xyz_velsoundbz.DSC.U1,xyz_velsoundbz.DSC.L2:                   
     .       2   xyz_velsoundbz.DSC.U2,xyz_velsoundbz.DSC.L3:                   
     .       3   xyz_velsoundbz.DSC.U3))                                        
     .        xyzf_qmixbz.DSC.RANK = 4                                          
     .        xyzf_qmixbz.DSC.L1 = imin                                         
     .        xyzf_qmixbz.DSC.U1 = imax                                         
     .        xyzf_qmixbz.DSC.L2 = jmin                                         
     .        xyzf_qmixbz.DSC.U2 = jmax                                         
     .        xyzf_qmixbz.DSC.L3 = kmin                                         
     .        xyzf_qmixbz.DSC.U3 = kmax                                         
     .        xyzf_qmixbz.DSC.L4 = 1                                            
     .        xyzf_qmixbz.DSC.U4 = ncmax                                        
     .        allocate (xyzf_qmixbz(xyzf_qmixbz.DSC.L1:xyzf_qmixbz.DSC.U1,      
     .       1   xyzf_qmixbz.DSC.L2:xyzf_qmixbz.DSC.U2,xyzf_qmixbz.DSC.L3:      
     .       2   xyzf_qmixbz.DSC.U3,xyzf_qmixbz.DSC.L4:xyzf_qmixbz.DSC.U4))     
     .        xyz_effmolwtbz.DSC.RANK = 3                                       
     .        xyz_effmolwtbz.DSC.L1 = imin                                      
     .        xyz_effmolwtbz.DSC.U1 = imax                                      
     .        xyz_effmolwtbz.DSC.L2 = jmin                                      
     .        xyz_effmolwtbz.DSC.U2 = jmax                                      
     .        xyz_effmolwtbz.DSC.L3 = kmin                                      
     .        xyz_effmolwtbz.DSC.U3 = kmax                                      
     .        allocate (xyz_effmolwtbz(xyz_effmolwtbz.DSC.L1:                   
     .       1   xyz_effmolwtbz.DSC.U1,xyz_effmolwtbz.DSC.L2:                   
     .       2   xyz_effmolwtbz.DSC.U2,xyz_effmolwtbz.DSC.L3:                   
     .       3   xyz_effmolwtbz.DSC.U3))                                        
     .        xyr_qmixbzpermolwt.DSC.RANK = 3                                   
     .        xyr_qmixbzpermolwt.DSC.L1 = imin                                  
     .        xyr_qmixbzpermolwt.DSC.U1 = imax                                  
     .        xyr_qmixbzpermolwt.DSC.L2 = jmin                                  
     .        xyr_qmixbzpermolwt.DSC.U2 = jmax                                  
     .        xyr_qmixbzpermolwt.DSC.L3 = kmin                                  
     .        xyr_qmixbzpermolwt.DSC.U3 = kmax                                  
     .        allocate (xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1:           
     .       1   xyr_qmixbzpermolwt.DSC.U1,xyr_qmixbzpermolwt.DSC.L2:           
     .       2   xyr_qmixbzpermolwt.DSC.U2,xyr_qmixbzpermolwt.DSC.L3:           
     .       3   xyr_qmixbzpermolwt.DSC.U3))                                    
     .        xyz_qmixbzpermolwt.DSC.RANK = 3                                   
     .        xyz_qmixbzpermolwt.DSC.L1 = imin                                  
     .        xyz_qmixbzpermolwt.DSC.U1 = imax                                  
     .        xyz_qmixbzpermolwt.DSC.L2 = jmin                                  
     .        xyz_qmixbzpermolwt.DSC.U2 = jmax                                  
     .        xyz_qmixbzpermolwt.DSC.L3 = kmin                                  
     .        xyz_qmixbzpermolwt.DSC.U3 = kmax                                  
     .        allocate (xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1:           
     .       1   xyz_qmixbzpermolwt.DSC.U1,xyz_qmixbzpermolwt.DSC.L2:           
     .       2   xyz_qmixbzpermolwt.DSC.U2,xyz_qmixbzpermolwt.DSC.L3:           
     .       3   xyz_qmixbzpermolwt.DSC.U3))                                    
     .        xyr_qmixbz.DSC.RANK = 3                                           
     .        xyr_qmixbz.DSC.L1 = imin                                          
     .        xyr_qmixbz.DSC.U1 = imax                                          
     .        xyr_qmixbz.DSC.L2 = jmin                                          
     .        xyr_qmixbz.DSC.U2 = jmax                                          
     .        xyr_qmixbz.DSC.L3 = kmin                                          
     .        xyr_qmixbz.DSC.U3 = kmax                                          
     .        allocate (xyr_qmixbz(xyr_qmixbz.DSC.L1:xyr_qmixbz.DSC.U1,         
     .       1   xyr_qmixbz.DSC.L2:xyr_qmixbz.DSC.U2,xyr_qmixbz.DSC.L3:         
     .       2   xyr_qmixbz.DSC.U3))                                            
     .        xyz_qmixbz.DSC.RANK = 3                                           
     .        xyz_qmixbz.DSC.L1 = imin                                          
     .        xyz_qmixbz.DSC.U1 = imax                                          
     .        xyz_qmixbz.DSC.L2 = jmin                                          
     .        xyz_qmixbz.DSC.U2 = jmax                                          
     .        xyz_qmixbz.DSC.L3 = kmin                                          
     .        xyz_qmixbz.DSC.U3 = kmax                                          
     .        allocate (xyz_qmixbz(xyz_qmixbz.DSC.L1:xyz_qmixbz.DSC.U1,         
     .       1   xyz_qmixbz.DSC.L2:xyz_qmixbz.DSC.U2,xyz_qmixbz.DSC.L3:         
     .       2   xyz_qmixbz.DSC.U3))                                            
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t3581 = 1, (xyz_densbz.DSC.U3 - xyz_densbz.DSC.L3 + 1)*(       
     .       1   xyz_densbz.DSC.U2 - xyz_densbz.DSC.L2 + 1)*(xyz_densbz.DSC.U1  
     .       2    - xyz_densbz.DSC.L1 + 1)                                      
     .           xyz_densbz(xyz_densbz.DSC.L1+t3581-1,xyz_densbz.DSC.L2,        
     .       1      xyz_densbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
     .  31051 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t3671 = 1, (xyz_pressbz.DSC.U3 - xyz_pressbz.DSC.L3 + 1)*(     
     .       1   xyz_pressbz.DSC.U2 - xyz_pressbz.DSC.L2 + 1)*(                 
     .       2   xyz_pressbz.DSC.U1 - xyz_pressbz.DSC.L1 + 1)                   
     .           xyz_pressbz(xyz_pressbz.DSC.L1+t3671-1,xyz_pressbz.DSC.L2,     
     .       1      xyz_pressbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
     .  31055 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t3761 = 1, (xyz_exnerbz.DSC.U3 - xyz_exnerbz.DSC.L3 + 1)*(     
     .       1   xyz_exnerbz.DSC.U2 - xyz_exnerbz.DSC.L2 + 1)*(                 
     .       2   xyz_exnerbz.DSC.U1 - xyz_exnerbz.DSC.L1 + 1)                   
     .           xyz_exnerbz(xyz_exnerbz.DSC.L1+t3761-1,xyz_exnerbz.DSC.L2,     
     .       1      xyz_exnerbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
     .  31059 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t3851 = 1, (xyz_tempbz.DSC.U3 - xyz_tempbz.DSC.L3 + 1)*(       
     .       1   xyz_tempbz.DSC.U2 - xyz_tempbz.DSC.L2 + 1)*(xyz_tempbz.DSC.U1  
     .       2    - xyz_tempbz.DSC.L1 + 1)                                      
     .           xyz_tempbz(xyz_tempbz.DSC.L1+t3851-1,xyz_tempbz.DSC.L2,        
     .       1      xyz_tempbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
     .  31063 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t3941 = 1, (xyz_ptempbz.DSC.U3 - xyz_ptempbz.DSC.L3 + 1)*(     
     .       1   xyz_ptempbz.DSC.U2 - xyz_ptempbz.DSC.L2 + 1)*(                 
     .       2   xyz_ptempbz.DSC.U1 - xyz_ptempbz.DSC.L1 + 1)                   
     .           xyz_ptempbz(xyz_ptempbz.DSC.L1+t3941-1,xyz_ptempbz.DSC.L2,     
     .       1      xyz_ptempbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
     .  31067 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4031 = 1, (xyz_vptempbz.DSC.U3 - xyz_vptempbz.DSC.L3 + 1)*(   
     .       1   xyz_vptempbz.DSC.U2 - xyz_vptempbz.DSC.L2 + 1)*(               
     .       2   xyz_vptempbz.DSC.U1 - xyz_vptempbz.DSC.L1 + 1)                 
     .           xyz_vptempbz(xyz_vptempbz.DSC.L1+t4031-1,xyz_vptempbz.DSC.L2,  
     .       1      xyz_vptempbz.DSC.L3) = 0.0000000000000000e+000              
     .        end do                                                            
     .  31071 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4121 = 1, (xyz_velsoundbz.DSC.U3 - xyz_velsoundbz.DSC.L3 + 1)*
     .       1   (xyz_velsoundbz.DSC.U2 - xyz_velsoundbz.DSC.L2 + 1)*(          
     .       2   xyz_velsoundbz.DSC.U1 - xyz_velsoundbz.DSC.L1 + 1)             
     .           xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t4121-1,                  
     .       1      xyz_velsoundbz.DSC.L2,xyz_velsoundbz.DSC.L3) =              
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
     .  31075 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4211 = 1, (xyzf_qmixbz.DSC.U4 - xyzf_qmixbz.DSC.L4 + 1)*(     
     .       1   xyzf_qmixbz.DSC.U3 - xyzf_qmixbz.DSC.L3 + 1)*(                 
     .       2   xyzf_qmixbz.DSC.U2 - xyzf_qmixbz.DSC.L2 + 1)*(                 
     .       3   xyzf_qmixbz.DSC.U1 - xyzf_qmixbz.DSC.L1 + 1)                   
     .           xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t4211-1,xyzf_qmixbz.DSC.L2,     
     .       1      xyzf_qmixbz.DSC.L3,xyzf_qmixbz.DSC.L4) =                    
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
     .  31079 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4331 = 1, (xyz_effmolwtbz.DSC.U3 - xyz_effmolwtbz.DSC.L3 + 1)*
     .       1   (xyz_effmolwtbz.DSC.U2 - xyz_effmolwtbz.DSC.L2 + 1)*(          
     .       2   xyz_effmolwtbz.DSC.U1 - xyz_effmolwtbz.DSC.L1 + 1)             
     .           xyz_effmolwtbz(xyz_effmolwtbz.DSC.L1+t4331-1,                  
     .       1      xyz_effmolwtbz.DSC.L2,xyz_effmolwtbz.DSC.L3) =              
     .       2      1.00000000000000e+000                                       
     .        end do                                                            
     .  31084 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4421 = 1, (xyr_qmixbzpermolwt.DSC.U3 -                        
     .       1   xyr_qmixbzpermolwt.DSC.L3 + 1)*(xyr_qmixbzpermolwt.DSC.U2 -    
     .       2   xyr_qmixbzpermolwt.DSC.L2 + 1)*(xyr_qmixbzpermolwt.DSC.U1 -    
     .       3   xyr_qmixbzpermolwt.DSC.L1 + 1)                                 
     .           xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1+t4421-1,          
     .       1      xyr_qmixbzpermolwt.DSC.L2,xyr_qmixbzpermolwt.DSC.L3) =      
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
     .  31088 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4511 = 1, (xyz_qmixbzpermolwt.DSC.U3 -                        
     .       1   xyz_qmixbzpermolwt.DSC.L3 + 1)*(xyz_qmixbzpermolwt.DSC.U2 -    
     .       2   xyz_qmixbzpermolwt.DSC.L2 + 1)*(xyz_qmixbzpermolwt.DSC.U1 -    
     .       3   xyz_qmixbzpermolwt.DSC.L1 + 1)                                 
     .           xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1+t4511-1,          
     .       1      xyz_qmixbzpermolwt.DSC.L2,xyz_qmixbzpermolwt.DSC.L3) =      
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
     .  31092 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4601 = 1, (xyr_qmixbz.DSC.U3 - xyr_qmixbz.DSC.L3 + 1)*(       
     .       1   xyr_qmixbz.DSC.U2 - xyr_qmixbz.DSC.L2 + 1)*(xyr_qmixbz.DSC.U1  
     .       2    - xyr_qmixbz.DSC.L1 + 1)                                      
     .           xyr_qmixbz(xyr_qmixbz.DSC.L1+t4601-1,xyr_qmixbz.DSC.L2,        
     .       1      xyr_qmixbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
     .  31096 continue                                                          
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t4691 = 1, (xyz_qmixbz.DSC.U3 - xyz_qmixbz.DSC.L3 + 1)*(       
     .       1   xyz_qmixbz.DSC.U2 - xyz_qmixbz.DSC.L2 + 1)*(xyz_qmixbz.DSC.U1  
     .       2    - xyz_qmixbz.DSC.L1 + 1)                                      
     .           xyz_qmixbz(xyz_qmixbz.DSC.L1+t4691-1,xyz_qmixbz.DSC.L2,        
     .       1      xyz_qmixbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
     .  31100 continue                                                          
     .  C*****  End of Code Expanded From Routine:  basicset_array_init         
    99  
   100      !ͤ
   101      xyz_PressBZ    = xyz_Press
     .  !CDIR NODEP                                                             
     .        do t673 = 1, xyz_pressbz.DSC.U1 - xyz_pressbz.DSC.L1 + 1          
     .           xyz_pressbz(xyz_pressbz.DSC.L1+t673-1,t671+xyz_pressbz.DSC.L2, 
     .       1      t669+xyz_pressbz.DSC.L3) = xyz_press(t214+t673-1,t671+t216, 
     .       2      t669+t218)                                                  
     .           xyz_exnerbz(xyz_exnerbz.DSC.L1+t673-1,t671+xyz_exnerbz.DSC.L2, 
     .       1      t669+xyz_exnerbz.DSC.L3) = xyz_exner(t224+t673-1,t671+t226, 
     .       2      t669+t228)                                                  
     .           xyz_tempbz(xyz_tempbz.DSC.L1+t673-1,t671+xyz_tempbz.DSC.L2,t669
     .       1      +xyz_tempbz.DSC.L3) = xyz_temp(t234+t673-1,t671+t236,t669+  
     .       2      t238)                                                       
     .           xyz_ptempbz(t2+t673-1,t671+t4,t669+t6) = xyz_ptemp(t244+t673-1,
     .       1      t671+t246,t669+t248)                                        
     .           xyz_densbz(xyz_densbz.DSC.L1+t673-1,t671+xyz_densbz.DSC.L2,t669
     .       1      +xyz_densbz.DSC.L3) = xyz_dens(t254+t673-1,t671+t256,t669+  
     .       2      t258)                                                       
     .           xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t673-1,t671+              
     .       1      xyz_velsoundbz.DSC.L2,t669+xyz_velsoundbz.DSC.L3) =         
     .       2      xyz_velsound(t264+t673-1,t671+t266,t669+t268)               
     .        end do                                                            
   102      xyz_ExnerBZ    = xyz_Exner
   103      xyz_TempBZ     = xyz_Temp
   104      xyz_PTempBZ  = xyz_PTemp
   105      xyz_DensBZ     = xyz_Dens
   106      xyz_VelSoundBZ = xyz_VelSound
   107      if (present(xyz_EffMolWt)) xyz_EffMolWtBZ = xyz_EffMolWt
     .        if (xyz_effmolwtbz.DSC.U2 - t48 + 1 .gt. 0) then                  
     .           J1 = and(xyz_effmolwtbz.DSC.U2 - t48 + 1,3)                    
     .  !CDIR    NODEP                                                          
     .           do t816 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t818 = 1, xyz_effmolwtbz.DSC.U1 - t46 + 1                
     .                 xyz_effmolwtbz(t46+t818-1,t816-1+t48,t814+t50) =         
     .       1            xyz_effmolwt(t286+t818-1,t816-1+t288,t814+t290)       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t816 = J1 + 1, xyz_effmolwtbz.DSC.U2 - t48 + 1, 4           
     .  !CDIR       NODEP                                                       
     .              do t818 = 1, xyz_effmolwtbz.DSC.U1 - t46 + 1                
     .                 xyz_effmolwtbz(t46+t818-1,t816-1+t48,t814+t50) =         
     .       1            xyz_effmolwt(t286+t818-1,t816-1+t288,t814+t290)       
     .                 xyz_effmolwtbz(t46+t818-1,t816+t48,t814+t50) =           
     .       1            xyz_effmolwt(t286+t818-1,t816+t288,t814+t290)         
     .                 xyz_effmolwtbz(t46+t818-1,t816+1+t48,t814+t50) =         
     .       1            xyz_effmolwt(t286+t818-1,t816+1+t288,t814+t290)       
     .                 xyz_effmolwtbz(t46+t818-1,t816+2+t48,t814+t50) =         
     .       1            xyz_effmolwt(t286+t818-1,t816+2+t288,t814+t290)       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   108  
   109      if (present(xyzf_QMix)) then
   110        xyzf_QMixBZ = xyzf_QMix
     .        if (t80 - t81 + 1 .gt. 0) then                                    
     .           J2 = and(t80 - t81 + 1,3)                                      
     .  !CDIR    NODEP                                                          
     .           do t730 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t732 = 1, t78 - t79 + 1                                  
     .                 xyzf_qmixbz(t79+t732-1,t730-1+t81,t728+t83,t726+t85) =   
     .       1            xyzf_qmix(t274+t732-1,t730-1+t276,t728+t278,t726+1)   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t730 = J2 + 1, t80 - t81 + 1, 4                             
     .  !CDIR       NODEP                                                       
     .              do t732 = 1, t78 - t79 + 1                                  
     .                 xyzf_qmixbz(t79+t732-1,t730-1+t81,t728+t83,t726+t85) =   
     .       1            xyzf_qmix(t274+t732-1,t730-1+t276,t728+t278,t726+1)   
     .                 xyzf_qmixbz(t79+t732-1,t730+t81,t728+t83,t726+t85) =     
     .       1            xyzf_qmix(t274+t732-1,t730+t276,t728+t278,t726+1)     
     .                 xyzf_qmixbz(t79+t732-1,t730+1+t81,t728+t83,t726+t85) =   
     .       1            xyzf_qmix(t274+t732-1,t730+1+t276,t728+t278,t726+1)   
     .                 xyzf_qmixbz(t79+t732-1,t730+2+t81,t728+t83,t726+t85) =   
     .       1            xyzf_qmix(t274+t732-1,t730+2+t276,t728+t278,t726+1)   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   111        xyzf_QMixBZPerMolWt = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t742 = 1, xyzf_qmixbzpermolwt.DSC.U4*(                         
     .       1   xyzf_qmixbzpermolwt.DSC.U3 + 1 - xyzf_qmixbzpermolwt.DSC.L3)*( 
     .       2   xyzf_qmixbzpermolwt.DSC.U2 + 1 - xyzf_qmixbzpermolwt.DSC.L2)*( 
     .       3   xyzf_qmixbzpermolwt.DSC.U1 + 1 - xyzf_qmixbzpermolwt.DSC.L1)   
     .           xyzf_qmixbzpermolwt(xyzf_qmixbzpermolwt.DSC.L1+t742-1,         
     .       1      xyzf_qmixbzpermolwt.DSC.L2,xyzf_qmixbzpermolwt.DSC.L3,1) =  
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   112  
   113        do s = 1, GasNum
   114          xyzf_QMixBZPerMolWt(:,:,:,s) = &
     .        if (t80 - t81 + 1 .gt. 0) then                                    
     .           J3 = and(t80 - t81 + 1,3)                                      
     .  !CDIR    NODEP                                                          
     .           do t756 = 1, J3                                                
     .              D2 = 1.D0/molwtwet(idxg(s))                                 
     .  !CDIR       NODEP                                                       
     .              do t758 = 1, t78 - t79 + 1                                  
     .                 xyzf_qmixbzpermolwt(xyzf_qmixbzpermolwt.DSC.L1+t758-1,   
     .       1            t756-1+xyzf_qmixbzpermolwt.DSC.L2,t754+               
     .       2            xyzf_qmixbzpermolwt.DSC.L3,s) = xyzf_qmixbz(t79+t758-1
     .       3            ,t756-1+t81,t754+t83,idxg(s))*D2                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t756 = J3 + 1, t80 - t81 + 1, 4                             
     .              D1 = molwtwet(idxg(s))                                      
     .  !CDIR       NODEP                                                       
     .              do t758 = 1, t78 - t79 + 1                                  
     .                 xyzf_qmixbzpermolwt(xyzf_qmixbzpermolwt.DSC.L1+t758-1,   
     .       1            t756-1+xyzf_qmixbzpermolwt.DSC.L2,t754+               
     .       2            xyzf_qmixbzpermolwt.DSC.L3,s) = xyzf_qmixbz(t79+t758-1
     .       3            ,t756-1+t81,t754+t83,idxg(s))/D1                      
     .                 xyzf_qmixbzpermolwt(xyzf_qmixbzpermolwt.DSC.L1+t758-1,   
     .       1            t756+xyzf_qmixbzpermolwt.DSC.L2,t754+                 
     .       2            xyzf_qmixbzpermolwt.DSC.L3,s) = xyzf_qmixbz(t79+t758-1
     .       3            ,t756+t81,t754+t83,idxg(s))/D1                        
     .                 xyzf_qmixbzpermolwt(xyzf_qmixbzpermolwt.DSC.L1+t758-1,   
     .       1            t756+1+xyzf_qmixbzpermolwt.DSC.L2,t754+               
     .       2            xyzf_qmixbzpermolwt.DSC.L3,s) = xyzf_qmixbz(t79+t758-1
     .       3            ,t756+1+t81,t754+t83,idxg(s))/D1                      
     .                 xyzf_qmixbzpermolwt(xyzf_qmixbzpermolwt.DSC.L1+t758-1,   
     .       1            t756+2+xyzf_qmixbzpermolwt.DSC.L2,t754+               
     .       2            xyzf_qmixbzpermolwt.DSC.L3,s) = xyzf_qmixbz(t79+t758-1
     .       3            ,t756+2+t81,t754+t83,idxg(s))/D1                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   115            & xyzf_QMixBZ(:,:,:,IdxG(s)) / MolWtWet(IdxG(s))
   116        end do
   117  
   118        xyz_QMixBZPerMolWt = sum(xyzf_QMixBZPerMolWt, 4)
     .  !CDIR NODEP                                                             
     .        do J9 = 0, xyzf_qmixbzpermolwt.DSC.U1 - xyzf_qmixbzpermolwt.DSC.L1
     .       1   , 9993                                                         
     .           J10 = min0(xyzf_qmixbzpermolwt.DSC.U1 + 1 -                    
     .       1      xyzf_qmixbzpermolwt.DSC.L1 - J9,9993)                       
     .  !CDIR    NODEP                                                          
     .           do t493 = 1, J10                                               
     .              D3(t493) = 0.0000000000000000e+000                          
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t496 = 1, xyzf_qmixbzpermolwt.DSC.U4                        
     .  !CDIR       NODEP                                                       
     .              do t493 = 1, J10                                            
     .                 D3(t493) = D3(t493) + xyzf_qmixbzpermolwt(t492+J9+t493-1,
     .       1            t489,t486,t496)                                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t493 = 1, J10                                               
     .              %00050c(J9+t493,t490,t487) = D3(t493)                       
     .           end do                                                         
     .        end do                                                            
     .        if (xyz_qmixbzpermolwt.DSC.U2 - xyz_qmixbzpermolwt.DSC.L2 + 1     
     .       1    .gt. 0) then                                                  
     .           J4 = and(xyz_qmixbzpermolwt.DSC.U2 - xyz_qmixbzpermolwt.DSC.L2 
     .       1       + 1,3)                                                     
     .  !CDIR    NODEP                                                          
     .           do t768 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t770 = 1, xyz_qmixbzpermolwt.DSC.U1 -                    
     .       1         xyz_qmixbzpermolwt.DSC.L1 + 1                            
     .                 xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1+t770-1,t768-
     .       1            1+xyz_qmixbzpermolwt.DSC.L2,t766+                     
     .       2            xyz_qmixbzpermolwt.DSC.L3) = %00050c(t770,t768,t766+1)
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t768 = J4 + 1, xyz_qmixbzpermolwt.DSC.U2 -                  
     .       1      xyz_qmixbzpermolwt.DSC.L2 + 1, 4                            
     .  !CDIR       NODEP                                                       
     .              do t770 = 1, xyz_qmixbzpermolwt.DSC.U1 -                    
     .       1         xyz_qmixbzpermolwt.DSC.L1 + 1                            
     .                 xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1+t770-1,t768-
     .       1            1+xyz_qmixbzpermolwt.DSC.L2,t766+                     
     .       2            xyz_qmixbzpermolwt.DSC.L3) = %00050c(t770,t768,t766+1)
     .                 xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1+t770-1,t768+
     .       1            xyz_qmixbzpermolwt.DSC.L2,t766+                       
     .       2            xyz_qmixbzpermolwt.DSC.L3) = %00050c(t770,t768+1,t766+
     .       3            1)                                                    
     .                 xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1+t770-1,t768+
     .       1            1+xyz_qmixbzpermolwt.DSC.L2,t766+                     
     .       2            xyz_qmixbzpermolwt.DSC.L3) = %00050c(t770,t768+2,t766+
     .       3            1)                                                    
     .                 xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1+t770-1,t768+
     .       1            2+xyz_qmixbzpermolwt.DSC.L2,t766+                     
     .       2            xyz_qmixbzpermolwt.DSC.L3) = %00050c(t770,t768+3,t766+
     .       3            1)                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   119        xyr_QMixBZPerMolWt = xyr_avr_xyz( sum(xyzf_QMixBZPerMolWt, 4) )
     .  !CDIR NODEP                                                             
     .        do J11 = 0, xyzf_qmixbzpermolwt.DSC.U1 -                          
     .       1   xyzf_qmixbzpermolwt.DSC.L1, 9993                               
     .           J12 = min0(xyzf_qmixbzpermolwt.DSC.U1 + 1 -                    
     .       1      xyzf_qmixbzpermolwt.DSC.L1 - J11,9993)                      
     .  !CDIR    NODEP                                                          
     .           do t536 = 1, J12                                               
     .              D4(t536) = 0.0000000000000000e+000                          
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t539 = 1, xyzf_qmixbzpermolwt.DSC.U4                        
     .  !CDIR       NODEP                                                       
     .              do t536 = 1, J12                                            
     .                 D4(t536) = D4(t536) + xyzf_qmixbzpermolwt(t535+J11+t536-1
     .       1            ,t532,t529,t539)                                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t536 = 1, J12                                               
     .              %00051a(J11+t536,t533,t530) = D4(t536)                      
     .           end do                                                         
     .        end do                                                            
     .        if (xyr_qmixbzpermolwt.DSC.U2 - xyr_qmixbzpermolwt.DSC.L2 + 1     
     .       1    .gt. 0) then                                                  
     .           J5 = and(xyr_qmixbzpermolwt.DSC.U2 - xyr_qmixbzpermolwt.DSC.L2 
     .       1       + 1,3)                                                     
     .  !CDIR    NODEP                                                          
     .           do t780 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t782 = 1, xyr_qmixbzpermolwt.DSC.U1 -                    
     .       1         xyr_qmixbzpermolwt.DSC.L1 + 1                            
     .                 xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1+t782-1,t780-
     .       1            1+xyr_qmixbzpermolwt.DSC.L2,t778+                     
     .       2            xyr_qmixbzpermolwt.DSC.L3) = %000521(%000521.DSC.L1+  
     .       3            t782-1,t780-1+%000521.DSC.L2,t778+%000521.DSC.L3)     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t780 = J5 + 1, xyr_qmixbzpermolwt.DSC.U2 -                  
     .       1      xyr_qmixbzpermolwt.DSC.L2 + 1, 4                            
     .  !CDIR       NODEP                                                       
     .              do t782 = 1, xyr_qmixbzpermolwt.DSC.U1 -                    
     .       1         xyr_qmixbzpermolwt.DSC.L1 + 1                            
     .                 xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1+t782-1,t780-
     .       1            1+xyr_qmixbzpermolwt.DSC.L2,t778+                     
     .       2            xyr_qmixbzpermolwt.DSC.L3) = %000521(%000521.DSC.L1+  
     .       3            t782-1,t780-1+%000521.DSC.L2,t778+%000521.DSC.L3)     
     .                 xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1+t782-1,t780+
     .       1            xyr_qmixbzpermolwt.DSC.L2,t778+                       
     .       2            xyr_qmixbzpermolwt.DSC.L3) = %000521(%000521.DSC.L1+  
     .       3            t782-1,t780+%000521.DSC.L2,t778+%000521.DSC.L3)       
     .                 xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1+t782-1,t780+
     .       1            1+xyr_qmixbzpermolwt.DSC.L2,t778+                     
     .       2            xyr_qmixbzpermolwt.DSC.L3) = %000521(%000521.DSC.L1+  
     .       3            t782-1,t780+1+%000521.DSC.L2,t778+%000521.DSC.L3)     
     .                 xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1+t782-1,t780+
     .       1            2+xyr_qmixbzpermolwt.DSC.L2,t778+                     
     .       2            xyr_qmixbzpermolwt.DSC.L3) = %000521(%000521.DSC.L1+  
     .       3            t782-1,t780+2+%000521.DSC.L2,t778+%000521.DSC.L3)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   120        xyz_QMixBZ         = sum(xyzf_QMixBZ, 4)
     .  !CDIR NODEP                                                             
     .        do J13 = 0, xyzf_qmixbz.DSC.U1 - xyzf_qmixbz.DSC.L1, 9993         
     .           J14=min0(xyzf_qmixbz.DSC.U1+1-xyzf_qmixbz.DSC.L1-J13,9993)     
     .  !CDIR    NODEP                                                          
     .           do t582 = 1, J14                                               
     .              D5(t582) = 0.0000000000000000e+000                          
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t585 = 1, t84 - t85 + 1                                     
     .  !CDIR       NODEP                                                       
     .              do t582 = 1, J14                                            
     .                 D5(t582) = D5(t582) + xyzf_qmixbz(t581+J13+t582-1,t578,  
     .       1            t575,t585-1+t85)                                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t582 = 1, J14                                               
     .              %000534(J13+t582,t579,t576) = D5(t582)                      
     .           end do                                                         
     .        end do                                                            
     .        if (xyz_qmixbz.DSC.U2 - xyz_qmixbz.DSC.L2 + 1 .gt. 0) then        
     .           J6 = and(xyz_qmixbz.DSC.U2 - xyz_qmixbz.DSC.L2 + 1,3)          
     .  !CDIR    NODEP                                                          
     .           do t792 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t794 = 1, xyz_qmixbz.DSC.U1 - xyz_qmixbz.DSC.L1 + 1      
     .                 xyz_qmixbz(xyz_qmixbz.DSC.L1+t794-1,t792-1+              
     .       1            xyz_qmixbz.DSC.L2,t790+xyz_qmixbz.DSC.L3) = %000534(  
     .       2            t794,t792,t790+1)                                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t792 = J6 + 1, xyz_qmixbz.DSC.U2 - xyz_qmixbz.DSC.L2 + 1, 4 
     .  !CDIR       NODEP                                                       
     .              do t794 = 1, xyz_qmixbz.DSC.U1 - xyz_qmixbz.DSC.L1 + 1      
     .                 xyz_qmixbz(xyz_qmixbz.DSC.L1+t794-1,t792-1+              
     .       1            xyz_qmixbz.DSC.L2,t790+xyz_qmixbz.DSC.L3) = %000534(  
     .       2            t794,t792,t790+1)                                     
     .                 xyz_qmixbz(xyz_qmixbz.DSC.L1+t794-1,t792+                
     .       1            xyz_qmixbz.DSC.L2,t790+xyz_qmixbz.DSC.L3) = %000534(  
     .       2            t794,t792+1,t790+1)                                   
     .                 xyz_qmixbz(xyz_qmixbz.DSC.L1+t794-1,t792+1+              
     .       1            xyz_qmixbz.DSC.L2,t790+xyz_qmixbz.DSC.L3) = %000534(  
     .       2            t794,t792+2,t790+1)                                   
     .                 xyz_qmixbz(xyz_qmixbz.DSC.L1+t794-1,t792+2+              
     .       1            xyz_qmixbz.DSC.L2,t790+xyz_qmixbz.DSC.L3) = %000534(  
     .       2            t794,t792+3,t790+1)                                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   121        xyr_QMixBZ         = xyr_avr_xyz( sum(xyzf_QMixBZ, 4) )
     .  !CDIR NODEP                                                             
     .        do J15 = 0, xyzf_qmixbz.DSC.U1 - xyzf_qmixbz.DSC.L1, 9993         
     .           J16=min0(xyzf_qmixbz.DSC.U1+1-xyzf_qmixbz.DSC.L1-J15,9993)     
     .  !CDIR    NODEP                                                          
     .           do t626 = 1, J16                                               
     .              D6(t626) = 0.0000000000000000e+000                          
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t629 = 1, t84 - t85 + 1                                     
     .  !CDIR       NODEP                                                       
     .              do t626 = 1, J16                                            
     .                 D6(t626) = D6(t626) + xyzf_qmixbz(t625+J15+t626-1,t622,  
     .       1            t619,t629-1+t85)                                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t626 = 1, J16                                               
     .              %000542(J15+t626,t623,t620) = D6(t626)                      
     .           end do                                                         
     .        end do                                                            
     .        if (xyr_qmixbz.DSC.U2 - xyr_qmixbz.DSC.L2 + 1 .gt. 0) then        
     .           J7 = and(xyr_qmixbz.DSC.U2 - xyr_qmixbz.DSC.L2 + 1,3)          
     .  !CDIR    NODEP                                                          
     .           do t804 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t806 = 1, xyr_qmixbz.DSC.U1 - xyr_qmixbz.DSC.L1 + 1      
     .                 xyr_qmixbz(xyr_qmixbz.DSC.L1+t806-1,t804-1+              
     .       1            xyr_qmixbz.DSC.L2,t802+xyr_qmixbz.DSC.L3) = %000549(  
     .       2            %000549.DSC.L1+t806-1,t804-1+%000549.DSC.L2,t802+     
     .       3            %000549.DSC.L3)                                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t804 = J7 + 1, xyr_qmixbz.DSC.U2 - xyr_qmixbz.DSC.L2 + 1, 4 
     .  !CDIR       NODEP                                                       
     .              do t806 = 1, xyr_qmixbz.DSC.U1 - xyr_qmixbz.DSC.L1 + 1      
     .                 xyr_qmixbz(xyr_qmixbz.DSC.L1+t806-1,t804-1+              
     .       1            xyr_qmixbz.DSC.L2,t802+xyr_qmixbz.DSC.L3) = %000549(  
     .       2            %000549.DSC.L1+t806-1,t804-1+%000549.DSC.L2,t802+     
     .       3            %000549.DSC.L3)                                       
     .                 xyr_qmixbz(xyr_qmixbz.DSC.L1+t806-1,t804+                
     .       1            xyr_qmixbz.DSC.L2,t802+xyr_qmixbz.DSC.L3) = %000549(  
     .       2            %000549.DSC.L1+t806-1,t804+%000549.DSC.L2,t802+       
     .       3            %000549.DSC.L3)                                       
     .                 xyr_qmixbz(xyr_qmixbz.DSC.L1+t806-1,t804+1+              
     .       1            xyr_qmixbz.DSC.L2,t802+xyr_qmixbz.DSC.L3) = %000549(  
     .       2            %000549.DSC.L1+t806-1,t804+1+%000549.DSC.L2,t802+     
     .       3            %000549.DSC.L3)                                       
     .                 xyr_qmixbz(xyr_qmixbz.DSC.L1+t806-1,t804+2+              
     .       1            xyr_qmixbz.DSC.L2,t802+xyr_qmixbz.DSC.L3) = %000549(  
     .       2            %000549.DSC.L1+t806-1,t804+2+%000549.DSC.L2,t802+     
     .       3            %000549.DSC.L3)                                       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   122      end if
   123  
   124      xyz_VPTempBZ = xyz_PTempBZ / xyz_EffMolWtBZ
     .        if (xyz_ptempbz.DSC.U2 - t4 + 1 .gt. 0) then                      
     .           J8 = and(xyz_ptempbz.DSC.U2 - t4 + 1,3)                        
     .  !CDIR    NODEP                                                          
     .           do t713 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t715 = 1, xyz_ptempbz.DSC.U1 - t2 + 1                    
     .                 xyz_vptempbz(xyz_vptempbz.DSC.L1+t715-1,t713-1+          
     .       1            xyz_vptempbz.DSC.L2,t711+xyz_vptempbz.DSC.L3) =       
     .       2            xyz_ptempbz(t2+t715-1,t713-1+t4,t711+t6)/             
     .       3            xyz_effmolwtbz(t46+t715-1,t713-1+t48,t711+t50)        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t713 = J8 + 1, xyz_ptempbz.DSC.U2 - t4 + 1, 4               
     .  !CDIR       NODEP                                                       
     .              do t715 = 1, xyz_ptempbz.DSC.U1 - t2 + 1                    
     .                 xyz_vptempbz(xyz_vptempbz.DSC.L1+t715-1,t713-1+          
     .       1            xyz_vptempbz.DSC.L2,t711+xyz_vptempbz.DSC.L3) =       
     .       2            xyz_ptempbz(t2+t715-1,t713-1+t4,t711+t6)/             
     .       3            xyz_effmolwtbz(t46+t715-1,t713-1+t48,t711+t50)        
     .                 xyz_vptempbz(xyz_vptempbz.DSC.L1+t715-1,t713+            
     .       1            xyz_vptempbz.DSC.L2,t711+xyz_vptempbz.DSC.L3) =       
     .       2            xyz_ptempbz(t2+t715-1,t713+t4,t711+t6)/xyz_effmolwtbz(
     .       3            t46+t715-1,t713+t48,t711+t50)                         
     .                 xyz_vptempbz(xyz_vptempbz.DSC.L1+t715-1,t713+1+          
     .       1            xyz_vptempbz.DSC.L2,t711+xyz_vptempbz.DSC.L3) =       
     .       2            xyz_ptempbz(t2+t715-1,t713+1+t4,t711+t6)/             
     .       3            xyz_effmolwtbz(t46+t715-1,t713+1+t48,t711+t50)        
     .                 xyz_vptempbz(xyz_vptempbz.DSC.L1+t715-1,t713+2+          
     .       1            xyz_vptempbz.DSC.L2,t711+xyz_vptempbz.DSC.L3) =       
     .       2            xyz_ptempbz(t2+t715-1,t713+2+t4,t711+t6)/             
     .       3            xyz_effmolwtbz(t46+t715-1,t713+2+t48,t711+t50)        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   125  
   126    end subroutine basicset_init
   127  
   128  
   129    subroutine basicset_array_init
   130      !
   131      ! *BZ ν
   132      !
   133  
   134      allocate( &
   135        & xyz_DensBZ(imin:imax,jmin:jmax,kmin:kmax), &
   136        & xyz_PressBZ(imin:imax,jmin:jmax,kmin:kmax), &
   137        & xyz_ExnerBZ(imin:imax,jmin:jmax,kmin:kmax), &
   138        & xyz_TempBZ(imin:imax,jmin:jmax,kmin:kmax), &
   139        & xyz_PTempBZ (imin:imax,jmin:jmax,kmin:kmax), &
   140        & xyz_VPTempBZ (imin:imax,jmin:jmax,kmin:kmax), &
   141        & xyz_VelSoundBZ(imin:imax,jmin:jmax,kmin:kmax), &
   142        & xyzf_QMixBZ(imin:imax,jmin:jmax,kmin:kmax,ncmax), &
   143        & xyz_EffMolWtBZ(imin:imax,jmin:jmax,kmin:kmax)  &
   144        & )
   145      allocate( &
   146        & xyr_QMixBZPerMolWt(imin:imax,jmin:jmax,kmin:kmax),           &
   147        & xyz_QMixBZPerMolWt(imin:imax,jmin:jmax,kmin:kmax),           &
   148        & xyr_QMixBZ(imin:imax,jmin:jmax,kmin:kmax),                   &
   149        & xyz_QMixBZ(imin:imax,jmin:jmax,kmin:kmax)                    &
   150        & )
   151  
   152      ! ͤγ
   153      xyz_DensBZ     = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t358 = 1, (xyz_densbz.DSC.U3 - xyz_densbz.DSC.L3 + 1)*(        
     .       1   xyz_densbz.DSC.U2 - xyz_densbz.DSC.L2 + 1)*(xyz_densbz.DSC.U1  
     .       2    - xyz_densbz.DSC.L1 + 1)                                      
     .           xyz_densbz(xyz_densbz.DSC.L1+t358-1,xyz_densbz.DSC.L2,         
     .       1      xyz_densbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
   154      xyz_PressBZ    = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t367 = 1, (xyz_pressbz.DSC.U3 - xyz_pressbz.DSC.L3 + 1)*(      
     .       1   xyz_pressbz.DSC.U2 - xyz_pressbz.DSC.L2 + 1)*(                 
     .       2   xyz_pressbz.DSC.U1 - xyz_pressbz.DSC.L1 + 1)                   
     .           xyz_pressbz(xyz_pressbz.DSC.L1+t367-1,xyz_pressbz.DSC.L2,      
     .       1      xyz_pressbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
   155      xyz_ExnerBZ    = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t376 = 1, (xyz_exnerbz.DSC.U3 - xyz_exnerbz.DSC.L3 + 1)*(      
     .       1   xyz_exnerbz.DSC.U2 - xyz_exnerbz.DSC.L2 + 1)*(                 
     .       2   xyz_exnerbz.DSC.U1 - xyz_exnerbz.DSC.L1 + 1)                   
     .           xyz_exnerbz(xyz_exnerbz.DSC.L1+t376-1,xyz_exnerbz.DSC.L2,      
     .       1      xyz_exnerbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
   156      xyz_TempBZ     = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t385 = 1, (xyz_tempbz.DSC.U3 - xyz_tempbz.DSC.L3 + 1)*(        
     .       1   xyz_tempbz.DSC.U2 - xyz_tempbz.DSC.L2 + 1)*(xyz_tempbz.DSC.U1  
     .       2    - xyz_tempbz.DSC.L1 + 1)                                      
     .           xyz_tempbz(xyz_tempbz.DSC.L1+t385-1,xyz_tempbz.DSC.L2,         
     .       1      xyz_tempbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
   157      xyz_PTempBZ    = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t394 = 1, (xyz_ptempbz.DSC.U3 - xyz_ptempbz.DSC.L3 + 1)*(      
     .       1   xyz_ptempbz.DSC.U2 - xyz_ptempbz.DSC.L2 + 1)*(                 
     .       2   xyz_ptempbz.DSC.U1 - xyz_ptempbz.DSC.L1 + 1)                   
     .           xyz_ptempbz(xyz_ptempbz.DSC.L1+t394-1,xyz_ptempbz.DSC.L2,      
     .       1      xyz_ptempbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
   158      xyz_VPTempBZ   = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t403 = 1, (xyz_vptempbz.DSC.U3 - xyz_vptempbz.DSC.L3 + 1)*(    
     .       1   xyz_vptempbz.DSC.U2 - xyz_vptempbz.DSC.L2 + 1)*(               
     .       2   xyz_vptempbz.DSC.U1 - xyz_vptempbz.DSC.L1 + 1)                 
     .           xyz_vptempbz(xyz_vptempbz.DSC.L1+t403-1,xyz_vptempbz.DSC.L2,   
     .       1      xyz_vptempbz.DSC.L3) = 0.0000000000000000e+000              
     .        end do                                                            
   159      xyz_VelSoundBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t412 = 1, (xyz_velsoundbz.DSC.U3 - xyz_velsoundbz.DSC.L3 + 1)*(
     .       1   xyz_velsoundbz.DSC.U2 - xyz_velsoundbz.DSC.L2 + 1)*(           
     .       2   xyz_velsoundbz.DSC.U1 - xyz_velsoundbz.DSC.L1 + 1)             
     .           xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t412-1,                   
     .       1      xyz_velsoundbz.DSC.L2,xyz_velsoundbz.DSC.L3) =              
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   160      xyzf_QMixBZ    = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t421 = 1, (xyzf_qmixbz.DSC.U4 - xyzf_qmixbz.DSC.L4 + 1)*(      
     .       1   xyzf_qmixbz.DSC.U3 - xyzf_qmixbz.DSC.L3 + 1)*(                 
     .       2   xyzf_qmixbz.DSC.U2 - xyzf_qmixbz.DSC.L2 + 1)*(                 
     .       3   xyzf_qmixbz.DSC.U1 - xyzf_qmixbz.DSC.L1 + 1)                   
     .           xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t421-1,xyzf_qmixbz.DSC.L2,      
     .       1      xyzf_qmixbz.DSC.L3,xyzf_qmixbz.DSC.L4) =                    
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   161      xyz_EffMolWtBZ = 1.0d0 ! dry ξɬ 1.0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t433 = 1, (xyz_effmolwtbz.DSC.U3 - xyz_effmolwtbz.DSC.L3 + 1)*(
     .       1   xyz_effmolwtbz.DSC.U2 - xyz_effmolwtbz.DSC.L2 + 1)*(           
     .       2   xyz_effmolwtbz.DSC.U1 - xyz_effmolwtbz.DSC.L1 + 1)             
     .           xyz_effmolwtbz(xyz_effmolwtbz.DSC.L1+t433-1,                   
     .       1      xyz_effmolwtbz.DSC.L2,xyz_effmolwtbz.DSC.L3) =              
     .       2      1.00000000000000e+000                                       
     .        end do                                                            
   162  
   163      xyr_QMixBZPerMolWt = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t442 = 1, (xyr_qmixbzpermolwt.DSC.U3 -                         
     .       1   xyr_qmixbzpermolwt.DSC.L3 + 1)*(xyr_qmixbzpermolwt.DSC.U2 -    
     .       2   xyr_qmixbzpermolwt.DSC.L2 + 1)*(xyr_qmixbzpermolwt.DSC.U1 -    
     .       3   xyr_qmixbzpermolwt.DSC.L1 + 1)                                 
     .           xyr_qmixbzpermolwt(xyr_qmixbzpermolwt.DSC.L1+t442-1,           
     .       1      xyr_qmixbzpermolwt.DSC.L2,xyr_qmixbzpermolwt.DSC.L3) =      
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   164      xyz_QMixBZPerMolWt = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t451 = 1, (xyz_qmixbzpermolwt.DSC.U3 -                         
     .       1   xyz_qmixbzpermolwt.DSC.L3 + 1)*(xyz_qmixbzpermolwt.DSC.U2 -    
     .       2   xyz_qmixbzpermolwt.DSC.L2 + 1)*(xyz_qmixbzpermolwt.DSC.U1 -    
     .       3   xyz_qmixbzpermolwt.DSC.L1 + 1)                                 
     .           xyz_qmixbzpermolwt(xyz_qmixbzpermolwt.DSC.L1+t451-1,           
     .       1      xyz_qmixbzpermolwt.DSC.L2,xyz_qmixbzpermolwt.DSC.L3) =      
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   165      xyr_QMixBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t460 = 1, (xyr_qmixbz.DSC.U3 - xyr_qmixbz.DSC.L3 + 1)*(        
     .       1   xyr_qmixbz.DSC.U2 - xyr_qmixbz.DSC.L2 + 1)*(xyr_qmixbz.DSC.U1  
     .       2    - xyr_qmixbz.DSC.L1 + 1)                                      
     .           xyr_qmixbz(xyr_qmixbz.DSC.L1+t460-1,xyr_qmixbz.DSC.L2,         
     .       1      xyr_qmixbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
   166      xyz_QMixBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t469 = 1, (xyz_qmixbz.DSC.U3 - xyz_qmixbz.DSC.L3 + 1)*(        
     .       1   xyz_qmixbz.DSC.U2 - xyz_qmixbz.DSC.L2 + 1)*(xyz_qmixbz.DSC.U1  
     .       2    - xyz_qmixbz.DSC.L1 + 1)                                      
     .           xyz_qmixbz(xyz_qmixbz.DSC.L1+t469-1,xyz_qmixbz.DSC.L2,         
     .       1      xyz_qmixbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
   167  
   168    end subroutine basicset_array_init
   169  
   170  end module basicset
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:40 2011
FILE NAME: basicset.f90
PROGRAM NAME: basicset
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module BasicSet
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4:            ! Version::   $Id: basicset.f90,v 1.9 2011-10-04 05:17:35 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview 
    10:            !
    11:            ! ǥեȤδܾꤹ뤿ѿȷ⥸塼
    12:            ! * BasicEnvFile_init: ܾͤ netCDF ե뤫
    13:            ! * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
    14:            !
    15:            !== Error Handling
    16:            !
    17:            !== Known Bugs
    18:            !
    19:            !== Note
    20:            !
    21:            !== Future Plans
    22:            !
    23:            
    24:            module basicset
    25:              !
    26:              !ǥեȤδܾꤹ뤿ѿȷ⥸塼
    27:              !, hogeBZ Ȥʤ, ͤϤ뤳Ȥ
    28:              !Ԥ. 
    29:              !
    30:            
    31:              !⥸塼ɤ߹
    32:              use dc_types,   only: DP
    33:              use gridset,    only: imin,       &!  X β
    34:                &                   imax,       &!  X ξ
    35:                &                   jmin,       &!  Z β
    36:                &                   jmax,       &!  Z ξ
    37:                &                   kmin,       &!  Z β
    38:                &                   kmax,       &!  Z ξ
    39:                &                   ncmax           ! ؼο
    40:              use axesset,  only: xyr_avr_xyz
    41:              use composition, only: GasNum,       &!Το
    42:                &                 IdxG,         &!Τź
    43:                &                 MolWtWet       !Žʬʬ
    44:            
    45:              !ۤηػ
    46:              implicit none
    47:            
    48:              !save °
    49:              private
    50:            
    51:              !Public Interface
    52:              real(DP), allocatable, save, public :: xyz_DensBZ(:,:,:)    !̩
    53:              real(DP), allocatable, save, public :: xyz_PressBZ(:,:,:)   !̵
    54:              real(DP), allocatable, save, public :: xyz_ExnerBZ(:,:,:)   !̵
    55:              real(DP), allocatable, save, public :: xyz_TempBZ(:,:,:)    !
    56:              real(DP), allocatable, save, public :: xyz_PTempBZ(:,:,:) !
    57:              real(DP), allocatable, save, public :: xyz_VPTempBZ(:,:,:) !
    58:              real(DP), allocatable, save, public :: xyz_VelSoundBZ(:,:,:)!®
    59:              real(DP), allocatable, save, public :: xyzf_QMixBZ(:,:,:,:)!Žʬ
    60:              real(DP), allocatable, save, public :: xyz_EffMolWtBZ(:,:,:)!ʬ̸
    61:              real(DP), allocatable, save, public :: xyz_QMixBZPerMolWt(:,:,:)
    62:                                          !ܾκ / ʬ 
    63:              real(DP), allocatable, save, public :: xyr_QMixBZPerMolWt(:,:,:)
    64:                                          !ܾκ / ʬ 
    65:              real(DP), allocatable, save, public :: xyz_QMixBZ(:,:,:)
    66:                                          !ܾκ
    67:              real(DP), allocatable, save, public :: xyr_QMixBZ(:,:,:)
    68:                                          !ܾκ
    69:            
    70:              public basicset_init
    71:            
    72:            contains
    73:            
    74:            !!!-----------------------------------------------------------------!!!
    75:              subroutine basicset_init(                                     &
    76:                &   xyz_Press, xyz_Exner, xyz_Temp, xyz_PTemp, xyz_Dens,    & 
    77:                &   xyz_VelSound, xyzf_QMix, xyz_EffMolWt &
    78:                & )
    79:                !
    80:                ! ܾͤ. 
    81:                ! dry ξϺ䴥ʬȶŷʬ¸ۤ˻ȤʤΤ,
    82:                ! ѿ optional ˤƤ. 
    83:                !
    84:                
    85:                !ѿ
    86:                real(DP), intent(in) :: xyz_Press(imin:imax,jmin:jmax,kmin:kmax)
    87:                real(DP), intent(in) :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax)
    88:                real(DP), intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
    89:                real(DP), intent(in) :: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax)
    90:                real(DP), intent(in) :: xyz_Dens(imin:imax,jmin:jmax,kmin:kmax)
    91:                real(DP), intent(in) :: xyz_VelSound(imin:imax,jmin:jmax,kmin:kmax)
    92:                real(DP), intent(in), optional :: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax,ncmax)
    93:                real(DP), intent(in), optional :: xyz_EffMolWt(imin:imax,jmin:jmax,kmin:kmax)
    94:                real(DP)             :: xyzf_QMixBZPerMolWt(imin:imax,jmin:jmax,kmin:kmax,GasNum)
    95:                integer              :: s
    96:            
    97:                ! ν
    98: W======  I     call basicset_array_init
    99:                
   100:                !ͤ
   101: **V---->       xyz_PressBZ    = xyz_Press
   102: |||            xyz_ExnerBZ    = xyz_Exner
   103: |||            xyz_TempBZ     = xyz_Temp
   104: |||            xyz_PTempBZ  = xyz_PTemp
   105: |||            xyz_DensBZ     = xyz_Dens
   106: **V----        xyz_VelSoundBZ = xyz_VelSound
   107: ++V====        if (present(xyz_EffMolWt)) xyz_EffMolWtBZ = xyz_EffMolWt
   108:            
   109:                if (present(xyzf_QMix)) then 
   110: +++V===          xyzf_QMixBZ = xyzf_QMix
   111: W***===          xyzf_QMixBZPerMolWt = 0.0d0
   112:            
   113: +------>         do s = 1, GasNum
   114: |++V===            xyzf_QMixBZPerMolWt(:,:,:,s) = &
   115: |                    & xyzf_QMixBZ(:,:,:,IdxG(s)) / MolWtWet(IdxG(s))
   116: +------          end do
   117:            
   118: +++V===          xyz_QMixBZPerMolWt = sum(xyzf_QMixBZPerMolWt, 4) 
   119: +++V===          xyr_QMixBZPerMolWt = xyr_avr_xyz( sum(xyzf_QMixBZPerMolWt, 4) )
   120: +++V===          xyz_QMixBZ         = sum(xyzf_QMixBZ, 4) 
   121: +++V===          xyr_QMixBZ         = xyr_avr_xyz( sum(xyzf_QMixBZ, 4) )     
   122:                end if
   123:            
   124: ++V====        xyz_VPTempBZ = xyz_PTempBZ / xyz_EffMolWtBZ
   125:            
   126:              end subroutine basicset_init
   127:            
   128:            
   129:              subroutine basicset_array_init
   130:                !
   131:                ! *BZ ν
   132:                !
   133:            
   134:                allocate( & 
   135:                  & xyz_DensBZ(imin:imax,jmin:jmax,kmin:kmax), &
   136:                  & xyz_PressBZ(imin:imax,jmin:jmax,kmin:kmax), &
   137:                  & xyz_ExnerBZ(imin:imax,jmin:jmax,kmin:kmax), &
   138:                  & xyz_TempBZ(imin:imax,jmin:jmax,kmin:kmax), &
   139:                  & xyz_PTempBZ (imin:imax,jmin:jmax,kmin:kmax), &
   140:                  & xyz_VPTempBZ (imin:imax,jmin:jmax,kmin:kmax), &
   141:                  & xyz_VelSoundBZ(imin:imax,jmin:jmax,kmin:kmax), &
   142:                  & xyzf_QMixBZ(imin:imax,jmin:jmax,kmin:kmax,ncmax), &
   143:                  & xyz_EffMolWtBZ(imin:imax,jmin:jmax,kmin:kmax)  &
   144:                  & )
   145:                allocate( &
   146:                  & xyr_QMixBZPerMolWt(imin:imax,jmin:jmax,kmin:kmax),           &
   147:                  & xyz_QMixBZPerMolWt(imin:imax,jmin:jmax,kmin:kmax),           &
   148:                  & xyr_QMixBZ(imin:imax,jmin:jmax,kmin:kmax),                   &
   149:                  & xyz_QMixBZ(imin:imax,jmin:jmax,kmin:kmax)                    &
   150:                  & )
   151:            
   152:                ! ͤγ
   153: WWW====        xyz_DensBZ     = 0.0d0
   154: WWW====        xyz_PressBZ    = 0.0d0   
   155: WWW====        xyz_ExnerBZ    = 0.0d0   
   156: WWW====        xyz_TempBZ     = 0.0d0   
   157: W**====        xyz_PTempBZ    = 0.0d0
   158: ***====        xyz_VPTempBZ   = 0.0d0
   159: ***====        xyz_VelSoundBZ = 0.0d0
   160: ****===        xyzf_QMixBZ    = 0.0d0
   161: ***====        xyz_EffMolWtBZ = 1.0d0 ! dry ξɬ 1.0
   162:            
   163: ***====        xyr_QMixBZPerMolWt = 0.0d0
   164: ***====        xyz_QMixBZPerMolWt = 0.0d0
   165: ***====        xyr_QMixBZ = 0.0d0
   166: ***====        xyz_QMixBZ = 0.0d0
   167:                
   168:              end subroutine basicset_array_init
   169:              
   170:            end module basicset
