Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:43 2011
FILE NAME: chemcalc.f90
PROGRAM NAME: chemcalc
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   135  opt  (  11): Fused array assignments. :line 135 - 148
   135  vec  (   4): Vectorized array expression.
   156  opt  (1222): Procedure "molwt" expanded inline.
   160  opt  (1222): Procedure "molwt" expanded inline.
   301  opt  (  11): Fused array assignments. :line 301 - 312
   301  vec  (   4): Vectorized array expression.
   301  vec  (   4): Vectorized array expression.
   342  opt  (  11): Fused array assignments. :line 342 - 357
   342  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   384  opt  (  11): Fused array assignments. :line 384 - 388
   384  vec  (   4): Vectorized array expression.
   384  vec  (   4): Vectorized array expression.
   417  opt  (  11): Fused array assignments. :line 417 - 431
   417  vec  (   4): Vectorized array expression.
   460  opt  (  11): Fused array assignments. :line 460 - 481
   460  vec  (   4): Vectorized array expression.
   509  opt  (  11): Fused array assignments. :line 509 - 516
   509  vec  (   4): Vectorized array expression.
   509  vec  (   4): Vectorized array expression.
   615  opt  (  11): Fused array assignments. :line 615 - 616
   615  vec  (   4): Vectorized array expression.
   615  vec  (   4): Vectorized array expression.
   618  opt  (1222): Procedure "xyz_dsvappressdtemp" expanded inline.
   618  vec  (   4): Vectorized array expression.
   618  vec  (   4): Vectorized array expression.
   618  vec  (   4): Vectorized array expression.
   658  opt  (  11): Fused array assignments. :line 658 - 665
   658  vec  (   4): Vectorized array expression.
   672  opt  (  11): Fused array assignments. :line 672 - 680
   672  vec  (   4): Vectorized array expression.
   672  vec  (   4): Vectorized array expression.
   672  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:43 2011
FILE NAME: chemcalc.f90
PROGRAM NAME: chemcalc
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module ChemCalc_3d
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro
     4  ! Version::   $Id: chemcalc.f90,v 1.3 2011-05-31 06:57:00 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !شϢν̤׻뤿Υ⥸塼.
    12  !AMP  Antoine ˰¾Ѥưʲ.
    13  !ǥեȤǤ AMP Ȥ褦ˤƤ.
    14  !  * ˰¾
    15  !  * ˰¾βʬ
    16  !  * Ǯ
    17  !
    18  !== Error Handling
    19  !
    20  !== Bugs
    21  !
    22  !== Note
    23  !
    24  !== Future Plans
    25  !
    26  !
    27  
    28  module ChemCalc
    29    !
    30    !شϢν̤׻뤿Υ⥸塼.
    31    !AMP  Antoine ˰¾Ѥưʲ.
    32    !ǥեȤǤ AMP Ȥ褦ˤƤ.
    33    !  * ˰¾
    34    !  * ˰¾βʬ
    35    !  * Ǯ
    36    !
    37  
    38    !⥸塼ƤӽФ
    39    use dc_types,       only : DP
    40  
    41    use dc_message, only: MessageNotify
    42  
    43    use ChemData, only: ChemData_init,                 & !
    44      &                 ChemData_SpcNum,               & !ǡ١βؼ
    45      &                 ChemData_SvapPress_AntoineA,   & !Antoine  A 
    46      &                 ChemData_SvapPress_AntoineB,   & !Antoine  B 
    47      &                 ChemData_SvapPress_AntoineC,   & !Antoine  C 
    48      &                 ChemData_SvapPress_AntoineUnit,& !ñѴѷ
    49      &                 ChemData_SvapPress_AMPA,       & !AMP  A 
    50      &                 ChemData_SvapPress_AMPB,       & !AMP  B 
    51      &                 ChemData_SvapPress_AMPC,       & !AMP  C 
    52      &                 ChemData_SvapPress_AMPD,       & !AMP  D 
    53      &                 ChemData_SvapPress_AMPE,       & !AMP  E 
    54      &                 GasRUniv,                      & !
    55      &                 ChemData_OneSpcID,             & !ؼ ID 
    56      &                 ChemData_CpRef,                & !ɸ֤Ǥñ̼Ǯ
    57      &                 ChemData_CpPerMolRef,          & !ɸ֤Ǥñ̥Ǯ
    58      &                 ChemData_CvRef,                & !ɸ֤Ǥñ̼Ǯ
    59      &                 ChemData_MolWt,                & !ʬ
    60      &                 ChemData_GasR                    ! [J/K kg]
    61    use gridset, only:  imin,                     &!  X β
    62      &                 imax,                        &!  X ξ
    63      &                 jmin,                        &!  Y β
    64      &                 jmax,                        &!  Y ξ
    65      &                 kmin,                        &!  Z β
    66      &                 kmax                          !  Z ξ
    67    use constants,only: PressBasis,         & !̤ɸవ         [Pa]
    68      &                 CpDry,              & !ʬʿ갵Ǯ [J/K kg]
    69      &                 MolWtDry,           & !ʬʿʬ   [kg/mol]
    70      &                 GasRDry               !ʬε     [J/K kg]
    71  
    72    !ۤηػ
    73    implicit none
    74  
    75    !ΤФ private °դ.
    76    private
    77  
    78    !Τˤ public °դ
    79    public ChemCalc_Init                            !롼
    80    public MolWt                                    !ʬ
    81    public GasR                                     !
    82    public CpRef, CpPerMolRef, CvRef                !갵Ǯ, Ǯ
    83    public SvapPress, xyz_SvapPress                 !˰¾ [Pa]
    84    public xyz_DSvapPressDTemp                      !˰¾βʬ [Pa/K]
    85    public xyz_LatentHeat                           !Ǯ [J/K kg]
    86    public LatentHeatPerMol                         !Ǯ [J/K mol]
    87    public ReactHeatNH4SH, ReactHeatNH4SHPerMol     !NH4SH ȿǮ
    88    public xyz_DQMixSatDPTemp
    89    public xyz_DelQMixNH4SH
    90    public DelMolFrNH4SH
    91  
    92    real(DP)            :: ReactHeatNH4SH           !NH4SH ȿǮ [J/K kg]
    93    real(DP)            :: ReactHeatNH4SHPerMol     !NH4SH ȿǮ [J/K mol]
    94    real(DP)            :: a_antA(ChemData_SpcNum)   !Antoine ξ A 
    95    real(DP)            :: a_antB(ChemData_SpcNum)   !Antoine ξ B 
    96    real(DP)            :: a_antC(ChemData_SpcNum)   !Antoine ξ C 
    97    real(DP)            :: a_antU(ChemData_SpcNum)   !Antoine ξñ̴Τη
    98    real(DP)            :: a_ampA(ChemData_SpcNum)   !AMP ξ A 
    99    real(DP)            :: a_ampB(ChemData_SpcNum)   !AMP ξ B 
   100    real(DP)            :: a_ampC(ChemData_SpcNum)   !AMP ξ C 
   101    real(DP)            :: a_ampD(ChemData_SpcNum)   !AMP ξ D 
   102    real(DP)            :: a_ampE(ChemData_SpcNum)   !AMP ξ E 
   103    real(DP)            :: a_MolWt(ChemData_SpcNum)  !ʬ
   104  
   105    save ReactHeatNH4SH, ReactHeatNH4SHPerMol
   106    save a_antA, a_antB, a_antC, a_antU, a_MolWt
   107    save a_ampA, a_ampB, a_ampC, a_ampD, a_ampE
   108  
   109  contains
   110  
   111  !!!
   112  !!! 롼
   113  !!!
   114  !!!==========================================================================
   115    subroutine ChemCalc_Init( )
   116      !
   117      !롼
   118      !
   119  
   120      !ۤηػ
   121      implicit none
   122  
   123      !ѿ
   124      character(20)      :: Name
   125      integer            :: id
   126  
   127      !-----------------------------------------------------------
   128      ! 
   129      !
   130  
   131      ! ǡ١ν
   132      call chemdata_init( )
   133  
   134      !Antoine ˰¾η
   135      a_antA = ChemData_SvapPress_AntoineA
   136      a_antB = ChemData_SvapPress_AntoineB
   137      a_antC = ChemData_SvapPress_AntoineC
   138      a_antU = ChemData_SvapPress_AntoineUnit
   139  
   140      !AMP ˰¾η
   141      a_ampA = ChemData_SvapPress_AMPA
   142      a_ampB = ChemData_SvapPress_AMPB
   143      a_ampC = ChemData_SvapPress_AMPC
   144      a_ampD = ChemData_SvapPress_AMPD
   145      a_ampE = ChemData_SvapPress_AMPE
   146  
   147      !ʬ
   148      a_MolWt = ChemData_MolWt
   149  
   150      !NH4SH ȿǮν
   151      !  NH4SH 1kg ФȿǮˤ.
   152      Name = 'NH4SH-s'
   153      id   = ChemData_OneSpcID( Name )
   154  
   155      ReactHeatNH4SHPerMol  = GasRUniv * 10834.0d0
   156      ReactHeatNH4SH = GasRUniv * 10834.0d0 / MolWt( id )
     .           molwt = chemdata_molwt(id)                                     
     .        t77 = molwt                                                       
     .  C*****  End of Code Expanded From Routine:  molwt                       
   157  
   158      call MessageNotify( "M", &
   159        & "ChemCalc_Init", "ReactHeatNH4SH = %f", d=(/ReactHeatNH4SH/) )
   160      call MessageNotify( "M", &
     .        molwt1 = chemdata_molwt(id)                                       
     .        t86 = molwt1                                                      
     .  C*****  End of Code Expanded From Routine:  molwt                       
   161        & "ChemCalc_Init", "NH4SH MolWt = %f", d=(/MolWt(id)/) )
   162  
   163    end subroutine ChemCalc_Init
   164  
   165  
   166  
   167  !!!
   168  !!! ˰¾, Ǯ, etc. δܴؿ.
   169  !!! ؼ ID Ȳ٤Ф֤ͤ
   170  !!!
   171  
   172  !!!==========================================================================
   173    function CpRef(ID)
   174      !
   175      !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
   176      !
   177  
   178      !ۤηػ
   179      implicit none
   180  
   181      !ѿ
   182      real(DP)            :: CpRef        !ɸ֤Ǥñ̼Ǯ
   183      integer, intent(in) :: ID           !ؼ ID
   184  
   185  
   186      !ǡ١
   187      CpRef = ChemData_CpRef(ID)
   188  
   189    end function CpRef
   190  
   191  
   192  !!!==========================================================================
   193    function CpPerMolRef(ID)
   194      !
   195      !Ϳ줿ؼФ, ɸ֤Ǥñ̥갵Ǯ׻
   196      !
   197  
   198      !ۤηػ
   199      implicit none
   200  
   201      !ѿ
   202      real(DP)            :: CpPerMolRef  !ɸ֤Ǥñ̥Ǯ
   203      integer, intent(in) :: ID           !ؼ ID
   204  
   205  
   206      !ǡ١
   207      CpPerMolRef = ChemData_CpPerMolRef(ID)
   208  
   209    end function CpPerMolRef
   210  
   211  
   212  !!!==========================================================================
   213    function CvRef(ID)
   214      !
   215      !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
   216      !
   217  
   218      !ۤηػ
   219      implicit none
   220  
   221      !ѿ
   222      real(DP)            :: CvRef       !ɸ֤Ǥñ̼Ǯ
   223      integer, intent(in) :: ID           !ؼ ID
   224  
   225  
   226      !ǡ١
   227      CvRef = ChemData_CvRef(ID)
   228  
   229    end function CvRef
   230  
   231  
   232  !!!==========================================================================
   233    function MolWt(ID)
   234      !
   235      !Ϳ줿ؼФ, ʬ̤׻
   236      !
   237  
   238      !ۤηػ
   239      implicit none
   240  
   241      !ѿ
   242      real(DP)            :: MolWt         !ʬ
   243      integer, intent(in) :: ID      !ؼ ID
   244  
   245  
   246      !ǡ١
   247      MolWt = ChemData_MolWt(ID)
   248  
   249    end function MolWt
   250  
   251  
   252  !!!==========================================================================
   253    function GasR(ID)
   254      !
   255      !Ϳ줿ؼФ, ׻
   256      !
   257  
   258      !ۤηػ
   259      implicit none
   260  
   261      !ѿ
   262      real(DP)            :: GasR          !ʬ
   263      integer, intent(in) :: ID      !ؼ ID
   264  
   265  
   266      !ǡ١
   267      GasR = ChemData_GasR(ID)
   268  
   269    end function GasR
   270  
   271  
   272  
   273  !!!
   274  !!!  3 δؿ
   275  !!!
   276  
   277  !!!==========================================================================
   278    function xyz_SvapPressAnt( ID, xyz_Temp )
   279      !
   280      !˰¾η׻. Antoine μ
   281      !
   282  
   283      !ۤηػ
   284      implicit none
   285  
   286      ! ѿ
   287      real(DP)            :: xyz_SvapPressAnt(imin:imax,jmin:jmax,kmin:kmax)
   288                                                            !˰¾
   289      real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   290                                                            !
   291      integer, intent(in) :: ID                             !ؼ ID
   292  
   293      !ѿ
   294      real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax)
   295      real(DP),parameter  :: Temp0C = 273.15d0
   296  
   297  
   298      !˰¾ log ׻
   299      !п礭ʤꤹʤ褦ˤ.
   300      ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   301      xyz_LogSvapPress =                                          &
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J1 = and(jmax + 1 - jmin,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t103 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t105 = 1, imax + 1 - imin                                
     .                 xyz_logsvappress(xyz_logsvappress.DSC.L1+t105-1,t103-1+  
     .       1            xyz_logsvappress.DSC.L2,t101+xyz_logsvappress.DSC.L3) 
     .       2             = min((a_anta(id)-a_antb(id)/(a_antc(id)+xyz_temp(t31
     .       3            +t105-1,t103-1+t33,t101+t35)-2.73149999999999e+002))* 
     .       4            dlog(1.00000000000000e+001)+a_antu(id),               
     .       5            7.00000000000000e+002)                                
     .                 xyz_svappressant(xyz_svappressant.DESCRIPT.RETVAL.DSC.L1+
     .       1            t105-1,t103-1+xyz_svappressant.DESCRIPT.RETVAL.DSC.L2,
     .       2            t101+xyz_svappressant.DESCRIPT.RETVAL.DSC.L3) = dexp( 
     .       3            xyz_logsvappress(xyz_logsvappress.DSC.L1+t105-1,t103-1
     .       4            +xyz_logsvappress.DSC.L2,t101+xyz_logsvappress.DSC.L3)
     .       5            )                                                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t103 = J1 + 1, jmax + 1 - jmin, 2                           
     .              D4 = a_antu(id)                                             
     .              D3 = a_antc(id)                                             
     .              D2 = a_antb(id)                                             
     .              D1 = a_anta(id)                                             
     .  !CDIR       NODEP                                                       
     .              do t105 = 1, imax + 1 - imin                                
     .                 xyz_logsvappress(xyz_logsvappress.DSC.L1+t105-1,t103-1+  
     .       1            xyz_logsvappress.DSC.L2,t101+xyz_logsvappress.DSC.L3) 
     .       2             = min((D1 - D2/(D3 + xyz_temp(t31+t105-1,t103-1+t33, 
     .       3            t101+t35)-2.73149999999999e+002))*dlog(               
     .       4            1.00000000000000e+001)+D4,7.00000000000000e+002)      
     .                 xyz_logsvappress(xyz_logsvappress.DSC.L1+t105-1,t103+    
     .       1            xyz_logsvappress.DSC.L2,t101+xyz_logsvappress.DSC.L3) 
     .       2             = min((D1 - D2/(D3 + xyz_temp(t31+t105-1,t103+t33,   
     .       3            t101+t35)-2.73149999999999e+002))*dlog(               
     .       4            1.00000000000000e+001)+D4,7.00000000000000e+002)      
     .                 xyz_svappressant(xyz_svappressant.DESCRIPT.RETVAL.DSC.L1+
     .       1            t105-1,t103-1+xyz_svappressant.DESCRIPT.RETVAL.DSC.L2,
     .       2            t101+xyz_svappressant.DESCRIPT.RETVAL.DSC.L3) = dexp( 
     .       3            xyz_logsvappress(xyz_logsvappress.DSC.L1+t105-1,t103-1
     .       4            +xyz_logsvappress.DSC.L2,t101+xyz_logsvappress.DSC.L3)
     .       5            )                                                     
     .                 xyz_svappressant(xyz_svappressant.DESCRIPT.RETVAL.DSC.L1+
     .       1            t105-1,t103+xyz_svappressant.DESCRIPT.RETVAL.DSC.L2,  
     .       2            t101+xyz_svappressant.DESCRIPT.RETVAL.DSC.L3) = dexp( 
     .       3            xyz_logsvappress(xyz_logsvappress.DSC.L1+t105-1,t103+ 
     .       4            xyz_logsvappress.DSC.L2,t101+xyz_logsvappress.DSC.L3))
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   302        & min(                                                   &
   303        &       (                                                &
   304        &         a_antA(ID)                                     &
   305        &         - a_antB(ID) / (a_antC(ID) + xyz_Temp - Temp0C) &
   306        &        ) * dlog(10.0d0)                                &
   307        &        + a_antU(ID),                                   &
   308        &      7.0d2                                             &
   309        &    )
   310  
   311      !˰¾׻
   312      xyz_SvapPressAnt =  dexp( xyz_LogSvapPress )
   313  
   314    end function xyz_SvapPressAnt
   315  
   316  
   317  !!!==========================================================================
   318    function xyz_DSvapPressDTempAnt(ID, xyz_Temp)
   319      !
   320      !˰¾βʬη׻. Antoine μ
   321      !
   322  
   323      !ۤηػ
   324      implicit none
   325  
   326      !ѿ
   327      real(DP)            :: xyz_DSvapPressDTempAnt(imin:imax,jmin:jmax,kmin:kmax)
   328                                                    !˰¾βʬ [Pa/K]
   329      real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   330                                                    ! [K]
   331      integer, intent(in) :: ID                     !ؼ ID
   332  
   333      !ѿ
   334      real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax)
   335      real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   336      real(DP),parameter  :: Temp0C = 273.15d0
   337  
   338  
   339      !˰¾ log ׻
   340      !п礭ʤꤹʤ褦ˤ.
   341      ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   342      xyz_LogSvapPress =                                          &
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J1 = and(jmax + 1 - jmin,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t136 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t138 = 1, imax + 1 - imin                                
     .                 xyz_logsvappress(xyz_logsvappress.DSC.L1+t138-1,t136-1+  
     .       1            xyz_logsvappress.DSC.L2,t134+xyz_logsvappress.DSC.L3) 
     .       2             = min((a_anta(id)-a_antb(id)/(a_antc(id)+xyz_temp(t41
     .       3            +t138-1,t136-1+t43,t134+t45)-2.73149999999999e+002))* 
     .       4            dlog(1.00000000000000e+001)+a_antu(id),               
     .       5            7.00000000000000e+002)                                
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t138
     .       1            -1,t136-1+xyz_dlogsvappressdtemp.DSC.L2,t134+         
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = a_antb(id)*dlog(     
     .       3            1.00000000000000e+001)/(a_antc(id)+xyz_temp(t41+t138-1
     .       4            ,t136-1+t43,t134+t45)-2.73149999999999e+002)**        
     .       5            2.00000000000000e+000                                 
     .                 xyz_dsvappressdtempant(                                  
     .       1            xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L1+t138-1, 
     .       2            t136-1+xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L2, 
     .       3            t134+xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       5            t138-1,t136-1+xyz_dlogsvappressdtemp.DSC.L2,t134+     
     .       6            xyz_dlogsvappressdtemp.DSC.L3)*dexp(xyz_logsvappress( 
     .       7            xyz_logsvappress.DSC.L1+t138-1,t136-1+                
     .       8            xyz_logsvappress.DSC.L2,t134+xyz_logsvappress.DSC.L3))
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t136 = J1 + 1, jmax + 1 - jmin, 2                           
     .              D4 = a_antu(id)                                             
     .              D3 = a_antc(id)                                             
     .              D2 = a_antb(id)                                             
     .              D1 = a_anta(id)                                             
     .  !CDIR       NODEP                                                       
     .              do t138 = 1, imax + 1 - imin                                
     .                 xyz_logsvappress(xyz_logsvappress.DSC.L1+t138-1,t136-1+  
     .       1            xyz_logsvappress.DSC.L2,t134+xyz_logsvappress.DSC.L3) 
     .       2             = min((D1 - D2/(D3 + xyz_temp(t41+t138-1,t136-1+t43, 
     .       3            t134+t45)-2.73149999999999e+002))*dlog(               
     .       4            1.00000000000000e+001)+D4,7.00000000000000e+002)      
     .                 xyz_logsvappress(xyz_logsvappress.DSC.L1+t138-1,t136+    
     .       1            xyz_logsvappress.DSC.L2,t134+xyz_logsvappress.DSC.L3) 
     .       2             = min((D1 - D2/(D3 + xyz_temp(t41+t138-1,t136+t43,   
     .       3            t134+t45)-2.73149999999999e+002))*dlog(               
     .       4            1.00000000000000e+001)+D4,7.00000000000000e+002)      
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t138
     .       1            -1,t136-1+xyz_dlogsvappressdtemp.DSC.L2,t134+         
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = D2*dlog(             
     .       3            1.00000000000000e+001)/(D3 + xyz_temp(t41+t138-1,t136-
     .       4            1+t43,t134+t45)-2.73149999999999e+002)**              
     .       5            2.00000000000000e+000                                 
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t138
     .       1            -1,t136+xyz_dlogsvappressdtemp.DSC.L2,t134+           
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = D2*dlog(             
     .       3            1.00000000000000e+001)/(D3 + xyz_temp(t41+t138-1,t136+
     .       4            t43,t134+t45)-2.73149999999999e+002)**                
     .       5            2.00000000000000e+000                                 
     .                 xyz_dsvappressdtempant(                                  
     .       1            xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L1+t138-1, 
     .       2            t136-1+xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L2, 
     .       3            t134+xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       5            t138-1,t136-1+xyz_dlogsvappressdtemp.DSC.L2,t134+     
     .       6            xyz_dlogsvappressdtemp.DSC.L3)*dexp(xyz_logsvappress( 
     .       7            xyz_logsvappress.DSC.L1+t138-1,t136-1+                
     .       8            xyz_logsvappress.DSC.L2,t134+xyz_logsvappress.DSC.L3))
     .                 xyz_dsvappressdtempant(                                  
     .       1            xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L1+t138-1, 
     .       2            t136+xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L2,   
     .       3            t134+xyz_dsvappressdtempant.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       5            t138-1,t136+xyz_dlogsvappressdtemp.DSC.L2,t134+       
     .       6            xyz_dlogsvappressdtemp.DSC.L3)*dexp(xyz_logsvappress( 
     .       7            xyz_logsvappress.DSC.L1+t138-1,t136+                  
     .       8            xyz_logsvappress.DSC.L2,t134+xyz_logsvappress.DSC.L3))
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   343        & min(                                                   &
   344        &      (                                                 &
   345        &          a_antA(ID)                                    &
   346        &        - a_antB(ID) / (a_antC(ID) + xyz_Temp - Temp0C)  &
   347        &       ) * dlog(10.0d0)                                 &
   348        &       + a_antU(ID),                                    &
   349        &     7.0d2                                              &
   350        &    )
   351  
   352      xyz_DLogSvapPressDTemp =                                &
   353        & a_antB(ID) * dlog(10.0d0)                          &
   354        &  / ( (a_antC(ID) + xyz_Temp - Temp0C) ** 2.0d0 )
   355  
   356      !˰¾βʬ׻
   357      xyz_DSvapPressDTempAnt = xyz_DLogSvapPressDTemp * dexp( xyz_LogSvapPress )
   358  
   359    end function xyz_DSvapPressDTempAnt
   360  
   361  
   362  !!!==========================================================================
   363    function xyz_LatentHeatAnt(ID, xyz_Temp)
   364      !
   365      !˰¾Ǯ׻. Antoine μ
   366      !
   367  
   368      !ۤηػ
   369      implicit none
   370  
   371      !ѿ
   372      real(DP)            :: xyz_LatentHeatAnt(imin:imax,jmin:jmax,kmin:kmax)
   373                                                              !Ǯ[J/K kg]
   374      real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   375                                                      ![K]
   376      integer, intent(in) :: ID                       !ؼ ID
   377  
   378      !ؿ
   379      real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   380      real(DP),parameter  :: GasRUniv = 8.314d0
   381      real(DP),parameter  :: Temp0C = 273.15d0
   382  
   383      !˰¾ log ׻, Ǯ׻.
   384      xyz_DLogSvapPressDTemp =                                   &
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J1 = and(jmax + 1 - jmin,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t97 = 1, J1                                                 
     .              D4 = 1.D0/a_molwt(id)                                       
     .  !CDIR       NODEP                                                       
     .              do t99 = 1, imax + 1 - imin                                 
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t99-
     .       1            1,t97-1+xyz_dlogsvappressdtemp.DSC.L2,t95+            
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = a_antb(id)*dlog(     
     .       3            1.00000000000000e+001)/(a_antc(id)+xyz_temp(t29+t99-1,
     .       4            t97-1+t31,t95+t33)-2.73149999999999e+002)**           
     .       5            2.00000000000000e+000                                 
     .                 xyz_latentheatant(                                       
     .       1            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L1+t99-1,t97-1+ 
     .       2            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L2,t95+         
     .       3            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L3) =           
     .       4            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       5            t99-1,t97-1+xyz_dlogsvappressdtemp.DSC.L2,t95+        
     .       6            xyz_dlogsvappressdtemp.DSC.L3)*8.31400000000000e+000* 
     .       7            xyz_temp(t29+t99-1,t97-1+t31,t95+t33)**               
     .       8            2.00000000000000e+000*D4                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t97 = J1 + 1, jmax + 1 - jmin, 2                            
     .              D2 = a_antc(id)                                             
     .              D1 = a_antb(id)                                             
     .  !CDIR       NODEP                                                       
     .              do t99 = 1, imax + 1 - imin                                 
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t99-
     .       1            1,t97-1+xyz_dlogsvappressdtemp.DSC.L2,t95+            
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = D1*dlog(             
     .       3            1.00000000000000e+001)/(D2 + xyz_temp(t29+t99-1,t97-1+
     .       4            t31,t95+t33)-2.73149999999999e+002)**                 
     .       5            2.00000000000000e+000                                 
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t99-
     .       1            1,t97+xyz_dlogsvappressdtemp.DSC.L2,t95+              
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = D1*dlog(             
     .       3            1.00000000000000e+001)/(D2 + xyz_temp(t29+t99-1,t97+  
     .       4            t31,t95+t33)-2.73149999999999e+002)**                 
     .       5            2.00000000000000e+000                                 
     .                 D3 = a_molwt(id)                                         
     .                 xyz_latentheatant(                                       
     .       1            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L1+t99-1,t97-1+ 
     .       2            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L2,t95+         
     .       3            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L3) =           
     .       4            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       5            t99-1,t97-1+xyz_dlogsvappressdtemp.DSC.L2,t95+        
     .       6            xyz_dlogsvappressdtemp.DSC.L3)*8.31400000000000e+000* 
     .       7            xyz_temp(t29+t99-1,t97-1+t31,t95+t33)**               
     .       8            2.00000000000000e+000/D3                              
     .                 xyz_latentheatant(                                       
     .       1            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L1+t99-1,t97+   
     .       2            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L2,t95+         
     .       3            xyz_latentheatant.DESCRIPT.RETVAL.DSC.L3) =           
     .       4            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       5            t99-1,t97+xyz_dlogsvappressdtemp.DSC.L2,t95+          
     .       6            xyz_dlogsvappressdtemp.DSC.L3)*8.31400000000000e+000* 
     .       7            xyz_temp(t29+t99-1,t97+t31,t95+t33)**                 
     .       8            2.00000000000000e+000/D3                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   385        & a_antB(ID) * dlog(10.0d0)                             &
   386        &  / ( (a_antC(ID) + xyz_Temp - Temp0C) ** 2.0d0 )
   387  
   388      xyz_LatentHeatAnt =                                        &
   389        & xyz_DLogSvapPressDTemp * GasRUniv * (xyz_Temp ** 2.0d0) &
   390        &  / a_MolWt(ID)
   391  
   392    end function xyz_LatentHeatAnt
   393  
   394  
   395  !!!==========================================================================
   396    function xyz_SvapPress(ID, xyz_Temp)
   397      !
   398      !Ϳ줿ؼȲ٤Ф, ˰¾׻. AMP 
   399      !
   400  
   401      !ۤηػ
   402      implicit none
   403  
   404      !ѿ
   405      real(DP)            :: xyz_SvapPress(imin:imax,jmin:jmax,kmin:kmax)
   406                                                           !˰¾
   407      real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   408                                                           ! [K]
   409      integer, intent(in) :: ID                            !ؼ ID
   410  
   411      !ѿ
   412      real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax)
   413  
   414      !˰¾п׻
   415      !п礭ʤꤹʤ褦ˤ.
   416      ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   417      xyz_LogSvapPress =                            &
     .  !CDIR NODEP                                                             
     .        do t115 = 1, imax + 1 - imin                                      
     .           xyz_logsvappress(xyz_logsvappress.DSC.L1+t115-1,t113+          
     .       1      xyz_logsvappress.DSC.L2,t111+xyz_logsvappress.DSC.L3) = min(
     .       2      a_ampa(id)/xyz_temp(t33+t115-1,t113+t35,t111+t37)+a_ampb(id)
     .       3      +a_ampc(id)*dlog(xyz_temp(t33+t115-1,t113+t35,t111+t37))+   
     .       4      a_ampd(id)*xyz_temp(t33+t115-1,t113+t35,t111+t37)+a_ampe(id)
     .       5      *xyz_temp(t33+t115-1,t113+t35,t111+t37)**2+dlog(            
     .       6      1.00000000000000e-001),7.00000000000000e+002)               
     .           xyz_svappress(xyz_svappress.DESCRIPT.RETVAL.DSC.L1+t115-1,t113+
     .       1      xyz_svappress.DESCRIPT.RETVAL.DSC.L2,t111+                  
     .       2      xyz_svappress.DESCRIPT.RETVAL.DSC.L3) = dexp(               
     .       3      xyz_logsvappress(xyz_logsvappress.DSC.L1+t115-1,t113+       
     .       4      xyz_logsvappress.DSC.L2,t111+xyz_logsvappress.DSC.L3))      
     .        end do                                                            
   418        & min(                                     &
   419        &      (                                   &
   420        &          a_ampA(ID) / xyz_Temp            &
   421        &        + a_ampB(ID)                      &
   422        &        + a_ampC(ID) * dlog( xyz_Temp )    &
   423        &        + a_ampD(ID) * xyz_Temp            &
   424        &        + a_ampE(ID) * ( xyz_temp ** 2 )   &
   425        &        + dlog(1.0d-1)                    &
   426        &      ),                                  &
   427        &    7.0d2                                 &
   428        &   )
   429  
   430      !˰¾׻
   431      xyz_SvapPress =  dexp( xyz_LogSvapPress )
   432  
   433    end function xyz_SvapPress
   434  
   435  
   436  !!!==========================================================================
   437    function xyz_DSvapPressDTemp(ID, xyz_Temp)
   438      !
   439      !Ϳ줿ؼȲ٤Ф, ˰¾βʬ׻
   440      !
   441  
   442      !ۤηػ
   443      implicit none
   444  
   445      !ѿ
   446      real(DP)            :: xyz_DSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   447                                                           !˰¾βʬ [Pa/K]
   448      real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   449                                                           ! [K]
   450      integer, intent(in) :: ID                            !ؼ̾
   451  
   452      !ѿ
   453      real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax)
   454      real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   455  
   456  
   457      !˰¾п׻
   458      !п礭ʤꤹʤ褦ˤ.
   459      ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   460      xyz_LogSvapPress =                        &
     .  !CDIR NODEP                                                             
     .        do t157 = 1, imax + 1 - imin                                      
     .           xyz_logsvappress(xyz_logsvappress.DSC.L1+t157-1,t155+          
     .       1      xyz_logsvappress.DSC.L2,t153+xyz_logsvappress.DSC.L3) = min(
     .       2      a_ampa(id)/xyz_temp(t43+t157-1,t155+t45,t153+t47)+a_ampb(id)
     .       3      +a_ampc(id)*dlog(xyz_temp(t43+t157-1,t155+t45,t153+t47))+   
     .       4      a_ampd(id)*xyz_temp(t43+t157-1,t155+t45,t153+t47)+a_ampe(id)
     .       5      *xyz_temp(t43+t157-1,t155+t45,t153+t47)**2+dlog(            
     .       6      1.00000000000000e-001),7.00000000000000e+002)               
     .           xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t157-1,   
     .       1      t155+xyz_dlogsvappressdtemp.DSC.L2,t153+                    
     .       2      xyz_dlogsvappressdtemp.DSC.L3) = a_ampc(id)/xyz_temp(t43+   
     .       3      t157-1,t155+t45,t153+t47) - a_ampa(id)/xyz_temp(t43+t157-1, 
     .       4      t155+t45,t153+t47)**2.00000000000000e+000 + a_ampd(id) +    
     .       5      a_ampe(id)*2.00000000000000e+000*xyz_temp(t43+t157-1,t155+  
     .       6      t45,t153+t47)                                               
     .           xyz_dsvappressdtemp(xyz_dsvappressdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1      t157-1,t155+xyz_dsvappressdtemp.DESCRIPT.RETVAL.DSC.L2,t153+
     .       2      xyz_dsvappressdtemp.DESCRIPT.RETVAL.DSC.L3) =               
     .       3      xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t157-1,
     .       4      t155+xyz_dlogsvappressdtemp.DSC.L2,t153+                    
     .       5      xyz_dlogsvappressdtemp.DSC.L3)*dexp(xyz_logsvappress(       
     .       6      xyz_logsvappress.DSC.L1+t157-1,t155+xyz_logsvappress.DSC.L2,
     .       7      t153+xyz_logsvappress.DSC.L3))                              
     .        end do                                                            
   461        & min(                               &
   462        &      (                             &
   463        &          a_ampA(ID) / xyz_Temp            &
   464        &        + a_ampB(ID)                      &
   465        &        + a_ampC(ID) * dlog( xyz_Temp )    &
   466        &        + a_ampD(ID) * xyz_Temp            &
   467        &        + a_ampE(ID) * ( xyz_temp ** 2 )   &
   468        &        + dlog(1.0d-1)                    &
   469        &      ),                                  &
   470        &    7.0d2                                 &
   471        &   )
   472  
   473      !˰¾βʬ
   474      xyz_DLogSvapPressDTemp =                   &
   475        & - a_ampA(ID) / (xyz_Temp ** 2.0d0)        &
   476        & + a_ampC(ID) / xyz_Temp                   &
   477        & + a_ampD(ID)                             &
   478        & + a_ampE(ID) * 2.0d0 * xyz_Temp
   479  
   480      !˰¾βʬ
   481      xyz_DSvapPressDTemp =                          &
   482        & xyz_DLogSvapPressDTemp * dexp( xyz_LogSvapPress )
   483  
   484    end function xyz_DSvapPressDTemp
   485  
   486  
   487  !!!==========================================================================
   488    function xyz_LatentHeat(ID, xyz_Temp)
   489      !
   490      !Ϳ줿ؼȲ٤Ф, Ǯ׻
   491      !
   492  
   493      !ۤηػ
   494      implicit none
   495  
   496      !ѿ
   497      real(DP)            :: xyz_LatentHeat(imin:imax,jmin:jmax,kmin:kmax)
   498                                                           !Ǯ
   499      real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   500                                                           !
   501      integer, intent(in) :: ID                            !ؼ̾
   502  
   503      !ѿ
   504      real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   505      real(DP),parameter  :: GasRUniv = 8.314d0  !׵
   506  
   507  
   508      !˰¾βʬ
   509      xyz_DLogSvapPressDTemp =                      &
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J1 = and(jmax + 1 - jmin,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t110 = 1, J1                                                
     .              D6 = 1.D0/a_molwt(id)                                       
     .  !CDIR       NODEP                                                       
     .              do t112 = 1, imax + 1 - imin                                
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t112
     .       1            -1,t110-1+xyz_dlogsvappressdtemp.DSC.L2,t108+         
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = a_ampc(id)/xyz_temp( 
     .       3            t33+t112-1,t110-1+t35,t108+t37) - a_ampa(id)/xyz_temp(
     .       4            t33+t112-1,t110-1+t35,t108+t37)**2.00000000000000e+000
     .       5             + a_ampd(id) + a_ampe(id)*2.00000000000000e+000*     
     .       6            xyz_temp(t33+t112-1,t110-1+t35,t108+t37)              
     .                 xyz_latentheat(xyz_latentheat.DESCRIPT.RETVAL.DSC.L1+t112
     .       1            -1,t110-1+xyz_latentheat.DESCRIPT.RETVAL.DSC.L2,t108+ 
     .       2            xyz_latentheat.DESCRIPT.RETVAL.DSC.L3) =              
     .       3            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       4            t112-1,t110-1+xyz_dlogsvappressdtemp.DSC.L2,t108+     
     .       5            xyz_dlogsvappressdtemp.DSC.L3)*8.31400000000000e+000* 
     .       6            xyz_temp(t33+t112-1,t110-1+t35,t108+t37)**            
     .       7            2.00000000000000e+000*D6                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t110 = J1 + 1, jmax + 1 - jmin, 2                           
     .              D4 = a_ampe(id)                                             
     .              D3 = a_ampd(id)                                             
     .              D2 = a_ampa(id)                                             
     .              D1 = a_ampc(id)                                             
     .  !CDIR       NODEP                                                       
     .              do t112 = 1, imax + 1 - imin                                
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t112
     .       1            -1,t110-1+xyz_dlogsvappressdtemp.DSC.L2,t108+         
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = D1/xyz_temp(t33+t112-
     .       3            1,t110-1+t35,t108+t37) - D2/xyz_temp(t33+t112-1,t110-1
     .       4            +t35,t108+t37)**2.00000000000000e+000 + D3 + D4*      
     .       5            2.00000000000000e+000*xyz_temp(t33+t112-1,t110-1+t35, 
     .       6            t108+t37)                                             
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t112
     .       1            -1,t110+xyz_dlogsvappressdtemp.DSC.L2,t108+           
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = D1/xyz_temp(t33+t112-
     .       3            1,t110+t35,t108+t37) - D2/xyz_temp(t33+t112-1,t110+t35
     .       4            ,t108+t37)**2.00000000000000e+000 + D3 + D4*          
     .       5            2.00000000000000e+000*xyz_temp(t33+t112-1,t110+t35,   
     .       6            t108+t37)                                             
     .                 D5 = a_molwt(id)                                         
     .                 xyz_latentheat(xyz_latentheat.DESCRIPT.RETVAL.DSC.L1+t112
     .       1            -1,t110-1+xyz_latentheat.DESCRIPT.RETVAL.DSC.L2,t108+ 
     .       2            xyz_latentheat.DESCRIPT.RETVAL.DSC.L3) =              
     .       3            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       4            t112-1,t110-1+xyz_dlogsvappressdtemp.DSC.L2,t108+     
     .       5            xyz_dlogsvappressdtemp.DSC.L3)*8.31400000000000e+000* 
     .       6            xyz_temp(t33+t112-1,t110-1+t35,t108+t37)**            
     .       7            2.00000000000000e+000/D5                              
     .                 xyz_latentheat(xyz_latentheat.DESCRIPT.RETVAL.DSC.L1+t112
     .       1            -1,t110+xyz_latentheat.DESCRIPT.RETVAL.DSC.L2,t108+   
     .       2            xyz_latentheat.DESCRIPT.RETVAL.DSC.L3) =              
     .       3            xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+ 
     .       4            t112-1,t110+xyz_dlogsvappressdtemp.DSC.L2,t108+       
     .       5            xyz_dlogsvappressdtemp.DSC.L3)*8.31400000000000e+000* 
     .       6            xyz_temp(t33+t112-1,t110+t35,t108+t37)**              
     .       7            2.00000000000000e+000/D5                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   510        & - a_ampA(ID) / (xyz_Temp ** 2.0d0)        &
   511        & + a_ampC(ID) / xyz_Temp                   &
   512        & + a_ampD(ID)                             &
   513        & + a_ampE(ID) * 2.0d0 * xyz_Temp
   514  
   515      !Ǯη׻
   516      xyz_LatentHeat =                                           &
   517        & xyz_DLogSvapPressDTemp * GasRUniv * (xyz_Temp ** 2.0d0) &
   518        & / a_MolWt(ID)
   519  
   520    end function xyz_LatentHeat
   521  
   522  
   523  !!!==========================================================================
   524    function SvapPress(ID, Temp)
   525      !
   526      !Ϳ줿ؼȲ٤Ф, ˰¾׻. AMP 
   527      !
   528  
   529      !ۤηػ
   530      implicit none
   531  
   532      !ѿ
   533      real(DP)            :: SvapPress   !˰¾
   534      real(DP),intent(in) :: Temp        ! [K]
   535      integer, intent(in) :: ID          !ؼ ID
   536  
   537      !ѿ
   538      real(DP)            :: LogSvapPress
   539  
   540      !˰¾п׻
   541      !п礭ʤꤹʤ褦ˤ.
   542      ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   543      LogSvapPress =                            &
   544        & min(                                     &
   545        &      (                                   &
   546        &          a_ampA(ID) / Temp            &
   547        &        + a_ampB(ID)                      &
   548        &        + a_ampC(ID) * dlog( Temp )    &
   549        &        + a_ampD(ID) * Temp            &
   550        &        + a_ampE(ID) * ( temp ** 2 )   &
   551        &        + dlog(1.0d-1)                    &
   552        &      ),                                  &
   553        &    7.0d2                                 &
   554        &   )
   555  
   556      !˰¾׻
   557      SvapPress =  dexp( LogSvapPress )
   558  
   559    end function SvapPress
   560  
   561  
   562  !!!==========================================================================
   563    function LatentHeatPerMol(ID, Temp)
   564      !
   565      !Ϳ줿ؼȲ٤Ф, Ǯ׻
   566      !
   567  
   568      !ۤηػ
   569      implicit none
   570  
   571      !ѿ
   572      real(DP)            :: LatentHeatPerMol   !Ǯ
   573      real(DP),intent(in) :: Temp            !
   574      integer, intent(in) :: ID                 !ؼ̾
   575  
   576      !ѿ
   577      real(DP)            :: DLogSvapPressDTemp
   578      real(DP),parameter  :: GasRUniv = 8.314d0  !׵
   579  
   580  
   581      !˰¾βʬ
   582      DLogSvapPressDTemp =                      &
   583        & - a_ampA(ID) / (Temp ** 2.0d0)        &
   584        & + a_ampC(ID) / Temp                   &
   585        & + a_ampD(ID)                          &
   586        & + a_ampE(ID) * 2.0d0 * Temp
   587  
   588      !Ǯη׻
   589      LatentHeatPerMol =                                     &
   590        & DLogSvapPressDTemp * GasRUniv * (Temp ** 2.0d0)
   591  
   592    end function LatentHeatPerMol
   593  
   594  !!!-----------------------------------------------------------------------!!!
   595    function xyz_DQMixSatDPTemp(SpcID, MolWt, xyz_TempAll, xyz_ExnerAll)
   596      !
   597      !˰¾  ʬԤ
   598      !ºݤˤ, dq/dp * dp/dT * dT/d ¹. (â p ˰¾)
   599      !
   600  
   601      !ۤηػ
   602      implicit none
   603  
   604      !ѿ
   605      integer, intent(in) :: SpcID
   606      real(DP),intent(in) :: MolWt
   607      real(DP),intent(in) :: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
   608                                              !( + ܾ)
   609      real(DP),intent(in) :: xyz_ExnerAll(imin:imax,jmin:jmax,kmin:kmax)
   610                                              !ʡؿ( + ܾ)
   611      real(DP)            :: xyz_PressAll(imin:imax,jmin:jmax,kmin:kmax)
   612                                              !( + ܾ)
   613      real(DP)            :: xyz_DQMixSatDPTemp(imin:imax,jmin:jmax,kmin:kmax)
   614  
   615      xyz_DQMixSatDPTemp   = 0.0d0
     .        if (xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.U2 + 1 -               
     .       1   xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2 .gt. 0) then         
     .           J1 = and(xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.U2 + 1 -       
     .       1      xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,1)                
     .  !CDIR    NODEP                                                          
     .           do t127 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t129 = 1, xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.U1 + 1  
     .       1          - xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1             
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t129-1,t127-
     .       2            1+xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t125+     
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) =          
     .       4            0.0000000000000000e+000                               
     .                 xyz_pressall(xyz_pressall.DSC.L1+t129-1,t127-1+          
     .       1            xyz_pressall.DSC.L2,t125+xyz_pressall.DSC.L3) =       
     .       2            pressbasis*xyz_exnerall(t44+t129-1,t127-1+t46,t125+t48
     .       3            )**(cpdry/gasrdry)                                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t127 = J1 + 1, xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.U2 + 1
     .       1       - xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2, 2             
     .  !CDIR       NODEP                                                       
     .              do t129 = 1, xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.U1 + 1  
     .       1          - xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1             
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t129-1,t127-
     .       2            1+xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t125+     
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) =          
     .       4            0.0000000000000000e+000                               
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t129-1,t127+
     .       2            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t125+       
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) =          
     .       4            0.0000000000000000e+000                               
     .                 xyz_pressall(xyz_pressall.DSC.L1+t129-1,t127-1+          
     .       1            xyz_pressall.DSC.L2,t125+xyz_pressall.DSC.L3) =       
     .       2            pressbasis*xyz_exnerall(t44+t129-1,t127-1+t46,t125+t48
     .       3            )**(cpdry/gasrdry)                                    
     .                 xyz_pressall(xyz_pressall.DSC.L1+t129-1,t127+            
     .       1            xyz_pressall.DSC.L2,t125+xyz_pressall.DSC.L3) =       
     .       2            pressbasis*xyz_exnerall(t44+t129-1,t127+t46,t125+t48) 
     .       3            **(cpdry/gasrdry)                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   616      xyz_PressAll = PressBasis * (xyz_ExnerAll ** (CpDry / GasRDry))
   617  
   618      xyz_DQMixSatDPTemp =                            &
     .        %000425.DSC.L1 = imin                                             
     .        %000425.DSC.U1 = imax                                             
     .        %000425.DSC.L2 = jmin                                             
     .        %000425.DSC.U2 = jmax                                             
     .        %000425.DSC.L3 = kmin                                             
     .        %000425.DSC.U3 = kmax                                             
     .        if (0 .ne. loc(%000425)) go to 31051                              
     .        allocate (%000425(%000425.DSC.L1:%000425.DSC.U1,%000425.DSC.L2:   
     .       1   %000425.DSC.U2,%000425.DSC.L3:%000425.DSC.U3))                 
     .  31051 continue                                                          
     .        t431 = imin                                                       
     .        t451 = jmin                                                       
     .        t471 = kmin                                                       
     .        xyz_logsvappress.DSC.L1 = imin                                    
     .        xyz_logsvappress.DSC.U1 = imax                                    
     .        xyz_logsvappress.DSC.L2 = jmin                                    
     .        xyz_logsvappress.DSC.U2 = jmax                                    
     .        xyz_logsvappress.DSC.L3 = kmin                                    
     .        xyz_logsvappress.DSC.U3 = kmax                                    
     .        allocate (xyz_logsvappress(imin:imax,jmin:jmax,kmin:kmax))        
     .        xyz_dlogsvappressdtemp.DSC.L1 = imin                              
     .        xyz_dlogsvappressdtemp.DSC.U1 = imax                              
     .        xyz_dlogsvappressdtemp.DSC.L2 = jmin                              
     .        xyz_dlogsvappressdtemp.DSC.U2 = jmax                              
     .        xyz_dlogsvappressdtemp.DSC.L3 = kmin                              
     .        xyz_dlogsvappressdtemp.DSC.U3 = kmax                              
     .        allocate (xyz_dlogsvappressdtemp(imin:imax,jmin:jmax,kmin:kmax))  
     .        %000425.DSC.S2 = (%000425.DSC.U1 - %000425.DSC.L1 + 1)*8          
     .        %000425.DSC.S3 = (%000425.DSC.U2 - %000425.DSC.L2 + 1)*(          
     .       1   %000425.DSC.U1 - %000425.DSC.L1 + 1)*8                         
     .        xyz_logsvappress.DSC.S2 = (xyz_logsvappress.DSC.U1 -              
     .       1   xyz_logsvappress.DSC.L1 + 1)*8                                 
     .        xyz_logsvappress.DSC.S3 = (xyz_logsvappress.DSC.U2 -              
     .       1   xyz_logsvappress.DSC.L2 + 1)*(xyz_logsvappress.DSC.U1 -        
     .       2   xyz_logsvappress.DSC.L1 + 1)*8                                 
     .        xyz_dlogsvappressdtemp.DSC.S2 = (xyz_dlogsvappressdtemp.DSC.U1 -  
     .       1   xyz_dlogsvappressdtemp.DSC.L1 + 1)*8                           
     .        xyz_dlogsvappressdtemp.DSC.S3 = (xyz_dlogsvappressdtemp.DSC.U2 -  
     .       1   xyz_dlogsvappressdtemp.DSC.L2 + 1)*(                           
     .       2   xyz_dlogsvappressdtemp.DSC.U1 - xyz_dlogsvappressdtemp.DSC.L1  
     .       3    + 1)*8                                                        
     .  !CDIR NODEP                                                             
     .        do t1531 = 0, kmax - kmin                                         
     .  !CDIR    NODEP                                                          
     .           do t1551 = 0, jmax - jmin                                      
     .  !CDIR       NODEP                                                       
     .              do t157 = 1, imax + 1 - imin                                
     .                 xyz_logsvappress(xyz_logsvappress.DSC.L1+t157-1,t1551+   
     .       1            xyz_logsvappress.DSC.L2,t1531+xyz_logsvappress.DSC.L3)
     .       2             = min(a_ampa(spcid)/xyz_tempall(((t1531+t471-kmin)*( 
     .       3            jmax-jmin+1)+t1551+t451-jmin)*(imax-imin+1)+t431+t157-
     .       4            1,jmin,kmin)+a_ampb(spcid)+a_ampc(spcid)*dlog(        
     .       5            xyz_tempall(((t1531+t471-kmin)*(jmax-jmin+1)+t1551+   
     .       6            t451-jmin)*(imax-imin+1)+t431+t157-1,jmin,kmin))+     
     .       7            a_ampd(spcid)*xyz_tempall(((t1531+t471-kmin)*(jmax-   
     .       8            jmin+1)+t1551+t451-jmin)*(imax-imin+1)+t431+t157-1,   
     .       9            jmin,kmin)+a_ampe(spcid)*xyz_tempall(((t1531+t471-kmin
     .       .            )*(jmax-jmin+1)+t1551+t451-jmin)*(imax-imin+1)+t431+  
     .       1            t157-1,jmin,kmin)**2+dlog(1.00000000000000e-001),     
     .       2            7.00000000000000e+002)                                
     .                 xyz_dlogsvappressdtemp(xyz_dlogsvappressdtemp.DSC.L1+t157
     .       1            -1,t1551+xyz_dlogsvappressdtemp.DSC.L2,t1531+         
     .       2            xyz_dlogsvappressdtemp.DSC.L3) = a_ampc(spcid)/       
     .       3            xyz_tempall(((t1531+t471-kmin)*(jmax-jmin+1)+t1551+   
     .       4            t451-jmin)*(imax-imin+1)+t431+t157-1,jmin,kmin) -     
     .       5            a_ampa(spcid)/xyz_tempall(((t1531+t471-kmin)*(jmax-   
     .       6            jmin+1)+t1551+t451-jmin)*(imax-imin+1)+t431+t157-1,   
     .       7            jmin,kmin)**2.00000000000000e+000 + a_ampd(spcid) +   
     .       8            a_ampe(spcid)*2.00000000000000e+000*xyz_tempall(((    
     .       9            t1531+t471-kmin)*(jmax-jmin+1)+t1551+t451-jmin)*(imax-
     .       .            imin+1)+t431+t157-1,jmin,kmin)                        
     .                 %000425(%000425.DSC.L1+t157-1,t1551+%000425.DSC.L2,t1531+
     .       1            %000425.DSC.L3) = xyz_dlogsvappressdtemp(             
     .       2            xyz_dlogsvappressdtemp.DSC.L1+t157-1,t1551+           
     .       3            xyz_dlogsvappressdtemp.DSC.L2,t1531+                  
     .       4            xyz_dlogsvappressdtemp.DSC.L3)*dexp(xyz_logsvappress( 
     .       5            xyz_logsvappress.DSC.L1+t157-1,t1551+                 
     .       6            xyz_logsvappress.DSC.L2,t1531+xyz_logsvappress.DSC.L3)
     .       7            )                                                     
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
     .  31052 continue                                                          
     .        deallocate (xyz_dlogsvappressdtemp)                               
     .        deallocate (xyz_logsvappress)                                     
     .  C*****  End of Code Expanded From Routine:  xyz_dsvappressdtemp         
     .        if (xyz_pressall.DSC.U2 + 1 - xyz_pressall.DSC.L2 .gt. 0) then    
     .           J2 = and(xyz_pressall.DSC.U2 + 1 - xyz_pressall.DSC.L2,3)      
     .  !CDIR    NODEP                                                          
     .           do t142 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t144 = 1, xyz_pressall.DSC.U1 + 1 - xyz_pressall.DSC.L1  
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t144-1,t142-
     .       2            1+xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t140+     
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) = molwt/(  
     .       4            molwtdry*xyz_pressall(xyz_pressall.DSC.L1+t144-1,t142-
     .       5            1+xyz_pressall.DSC.L2,t140+xyz_pressall.DSC.L3))*     
     .       6            %000425(%000425.DSC.L1+t144-1,t142-1+%000425.DSC.L2,  
     .       7            t140+%000425.DSC.L3)*xyz_exnerall(t44+t144-1,t142-1+  
     .       8            t46,t140+t48)                                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t142=J2+1,xyz_pressall.DSC.U2+1-xyz_pressall.DSC.L2,4       
     .  !CDIR       NODEP                                                       
     .              do t144 = 1, xyz_pressall.DSC.U1 + 1 - xyz_pressall.DSC.L1  
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t144-1,t142-
     .       2            1+xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t140+     
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) = molwt/(  
     .       4            molwtdry*xyz_pressall(xyz_pressall.DSC.L1+t144-1,t142-
     .       5            1+xyz_pressall.DSC.L2,t140+xyz_pressall.DSC.L3))*     
     .       6            %000425(%000425.DSC.L1+t144-1,t142-1+%000425.DSC.L2,  
     .       7            t140+%000425.DSC.L3)*xyz_exnerall(t44+t144-1,t142-1+  
     .       8            t46,t140+t48)                                         
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t144-1,t142+
     .       2            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t140+       
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) = molwt/(  
     .       4            molwtdry*xyz_pressall(xyz_pressall.DSC.L1+t144-1,t142+
     .       5            xyz_pressall.DSC.L2,t140+xyz_pressall.DSC.L3))*%000425
     .       6            (%000425.DSC.L1+t144-1,t142+%000425.DSC.L2,t140+      
     .       7            %000425.DSC.L3)*xyz_exnerall(t44+t144-1,t142+t46,t140+
     .       8            t48)                                                  
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t144-1,t142+
     .       2            1+xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t140+     
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) = molwt/(  
     .       4            molwtdry*xyz_pressall(xyz_pressall.DSC.L1+t144-1,t142+
     .       5            1+xyz_pressall.DSC.L2,t140+xyz_pressall.DSC.L3))*     
     .       6            %000425(%000425.DSC.L1+t144-1,t142+1+%000425.DSC.L2,  
     .       7            t140+%000425.DSC.L3)*xyz_exnerall(t44+t144-1,t142+1+  
     .       8            t46,t140+t48)                                         
     .                 xyz_dqmixsatdptemp(                                      
     .       1            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L1+t144-1,t142+
     .       2            2+xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L2,t140+     
     .       3            xyz_dqmixsatdptemp.DESCRIPT.RETVAL.DSC.L3) = molwt/(  
     .       4            molwtdry*xyz_pressall(xyz_pressall.DSC.L1+t144-1,t142+
     .       5            2+xyz_pressall.DSC.L2,t140+xyz_pressall.DSC.L3))*     
     .       6            %000425(%000425.DSC.L1+t144-1,t142+2+%000425.DSC.L2,  
     .       7            t140+%000425.DSC.L3)*xyz_exnerall(t44+t144-1,t142+2+  
     .       8            t46,t140+t48)                                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   619        &   MolWt / ( MolWtDry * xyz_PressAll )          &
   620        & * xyz_DSvapPressDTemp(SpcID, xyz_TempAll)       &
   621        & * xyz_ExnerAll
   622  
   623    end function xyz_DQMixSatDPTemp
   624  
   625  
   626  !!!-----------------------------------------------------------------------!!!
   627    function xyz_DelQMixNH4SH(xyz_TempAll, xyz_PressAll, xyz_QMixNH3, xyz_QMixH2S, &
   628      &                    MolWtNH3, MolWtH2S)
   629      !
   630      ! NH4SH ȿȼ, NH4SH ()
   631      !
   632  
   633      !ۤηػ
   634      implicit none
   635  
   636      !ѿ
   637      real(DP),intent(in) :: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
   638                                           !
   639      real(DP),intent(in) :: xyz_PressAll(imin:imax,jmin:jmax,kmin:kmax)
   640                                           !
   641      real(DP),intent(in) :: xyz_QMixNH3(imin:imax,jmin:jmax,kmin:kmax)
   642                                           !NH3 κ
   643      real(DP),intent(in) :: xyz_QMixH2S(imin:imax,jmin:jmax,kmin:kmax)
   644                                           !H2S κ
   645      real(DP),intent(in) :: MolWtNH3      !NH3 ʬ
   646      real(DP),intent(in) :: MolWtH2S      !H2S ʬ
   647  
   648      real(DP) :: xyz_DelQMixNH4SH(imin:imax,jmin:jmax,kmin:kmax)
   649                                           !NH4SH κ
   650      real(DP) :: xyz_EquivConst(imin:imax,jmin:jmax,kmin:kmax)
   651                                           !ʿ
   652      real(DP) :: xyzf_PartialPress(imin:imax,jmin:jmax,kmin:kmax,2)
   653                                           !(ʬ)
   654      real(DP) :: xyz_Solution(imin:imax,jmin:jmax,kmin:kmax)
   655                                           !(β)
   656  
   657      !
   658      xyz_DelQMixNH4SH = 0.0d0
     .        D1 = molwtdry/molwtnh3                                            
     .        D2 = molwtdry/molwth2s                                            
     .  !CDIR NODEP                                                             
     .        do t249 = 1, xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.U1 + 1 -        
     .       1   xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L1                        
     .           xyz_delqmixnh4sh(xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L1+t249-1
     .       1      ,t247+xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L2,t245+         
     .       2      xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L3) =                  
     .       3      0.0000000000000000e+000                                     
     .           xyzf_partialpress(xyzf_partialpress.DSC.L1+t249-1,t247+        
     .       1      xyzf_partialpress.DSC.L2,t245+xyzf_partialpress.DSC.L3,1) = 
     .       2      xyz_qmixnh3(t70+t249-1,t247+t72,t245+t74)*xyz_pressall(t60+ 
     .       3      t249-1,t247+t62,t245+t64)*D1                                
     .           xyzf_partialpress(xyzf_partialpress.DSC.L1+t249-1,t247+        
     .       1      xyzf_partialpress.DSC.L2,t245+xyzf_partialpress.DSC.L3,2) = 
     .       2      xyz_qmixh2s(t80+t249-1,t247+t82,t245+t84)*xyz_pressall(t60+ 
     .       3      t249-1,t247+t62,t245+t64)*D2                                
     .           xyz_equivconst(xyz_equivconst.DSC.L1+t249-1,t247+              
     .       1      xyz_equivconst.DSC.L2,t245+xyz_equivconst.DSC.L3) =         
     .       2      6.17809999999999e+001 - 1.08340000000000e+004/xyz_tempall(  
     .       3      t50+t249-1,t247+t52,t245+t54) - dlog(1.00000000000000e+002) 
     .        end do                                                            
   659  
   660      !˥βǤʬ.
   661      xyzf_PartialPress(:,:,:,1) = xyz_QMixNH3 * xyz_PressAll * MolWtDry / MolWtNH3
   662      xyzf_PartialPress(:,:,:,2) = xyz_QMixH2S * xyz_PressAll * MolWtDry / MolWtH2S
   663  
   664      !ʿ
   665      xyz_EquivConst = 61.781d0 - 10834.0d0 / xyz_TempAll - dlog(1.0d2)
   666  
   667      !Ѳ.
   668      !  (P_NH3 - X) * (P_H2S - X) = exp(Kp)
   669      !  DelX^2 - (P_NH3 + P_H2S) * DelX + P_NH3 * P_H2S * exp( Kp ) = 0
   670      !  Ȥɬפ뤬, P_NH3 > P_H2S  X < P_H2S 
   671      !  θ, θΤ򤵤.
   672      xyz_Solution  =                                                   &
     .  !CDIR NODEP                                                             
     .        do t204 = 1, 1 + xyzf_partialpress.DSC.U3 -                       
     .       1   xyzf_partialpress.DSC.L3                                       
     .           t206 = xyzf_partialpress.DSC.L2                                
     .  !CDIR    NODEP                                                          
     .           do t207 = 1, 1 + xyzf_partialpress.DSC.U2 -                    
     .       1      xyzf_partialpress.DSC.L2                                    
     .              t209 = xyzf_partialpress.DSC.L1                             
     .              t2111 = 0.0000000000000000e+000                             
     .  !CDIR       NODEP                                                       
     .              do t210 = 1, xyzf_partialpress.DSC.U1 + 1 -                 
     .       1         xyzf_partialpress.DSC.L1                                 
     .                 t211 = t2111 + xyzf_partialpress(t209+t210-1,t206,t203,1)
     .                 t211 = t211 + xyzf_partialpress(t209+t210-1,t206,t203,2) 
     .                 %00045c(t210,t207,t204) = t211                           
     .              end do                                                      
     .              t206 = t206 + 1                                             
     .           end do                                                         
     .           t203 = t203 + 1                                                
     .        end do                                                            
     .        if(xyzf_partialpress.DSC.U2+1-xyzf_partialpress.DSC.L2.gt.0)then  
     .           J1 = and(xyzf_partialpress.DSC.U2 + 1 -                        
     .       1      xyzf_partialpress.DSC.L2,1)                                 
     .  !CDIR    NODEP                                                          
     .           do t280 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t282 = 1, xyzf_partialpress.DSC.U1 + 1 -                 
     .       1         xyzf_partialpress.DSC.L1                                 
     .                 xyz_solution(xyz_solution.DSC.L1+t282-1,t280-1+          
     .       1            xyz_solution.DSC.L2,t278+xyz_solution.DSC.L3) = (     
     .       2            %00045c(t282,t280,t278+1)-dsqrt((xyzf_partialpress(   
     .       3            xyzf_partialpress.DSC.L1+t282-1,t280-1+               
     .       4            xyzf_partialpress.DSC.L2,t278+xyzf_partialpress.DSC.L3
     .       5            ,1)-xyzf_partialpress(xyzf_partialpress.DSC.L1+t282-1,
     .       6            t280-1+xyzf_partialpress.DSC.L2,t278+                 
     .       7            xyzf_partialpress.DSC.L3,2))**2.00000000000000e+000+  
     .       8            4.00000000000000e+000*dexp(min(7.00000000000000e+002, 
     .       9            xyz_equivconst(xyz_equivconst.DSC.L1+t282-1,t280-1+   
     .       .            xyz_equivconst.DSC.L2,t278+xyz_equivconst.DSC.L3)))))*
     .       1            5.00000000000000e-001                                 
     .                 xyz_delqmixnh4sh(xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L1+
     .       1            t282-1,t280-1+xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L2,
     .       2            t278+xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L3) =       
     .       3            xyz_solution(xyz_solution.DSC.L1+t282-1,t280-1+       
     .       4            xyz_solution.DSC.L2,t278+xyz_solution.DSC.L3)*(       
     .       5            molwtnh3 + molwth2s)/(xyz_pressall(t60+t282-1,t280-1+ 
     .       6            t62,t278+t64)*molwtdry)                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t280 = J1 + 1, xyzf_partialpress.DSC.U2 + 1 -               
     .       1      xyzf_partialpress.DSC.L2, 2                                 
     .  !CDIR       NODEP                                                       
     .              do t282 = 1, xyzf_partialpress.DSC.U1 + 1 -                 
     .       1         xyzf_partialpress.DSC.L1                                 
     .                 xyz_solution(xyz_solution.DSC.L1+t282-1,t280-1+          
     .       1            xyz_solution.DSC.L2,t278+xyz_solution.DSC.L3) = (     
     .       2            %00045c(t282,t280,t278+1)-dsqrt((xyzf_partialpress(   
     .       3            xyzf_partialpress.DSC.L1+t282-1,t280-1+               
     .       4            xyzf_partialpress.DSC.L2,t278+xyzf_partialpress.DSC.L3
     .       5            ,1)-xyzf_partialpress(xyzf_partialpress.DSC.L1+t282-1,
     .       6            t280-1+xyzf_partialpress.DSC.L2,t278+                 
     .       7            xyzf_partialpress.DSC.L3,2))**2.00000000000000e+000+  
     .       8            4.00000000000000e+000*dexp(min(7.00000000000000e+002, 
     .       9            xyz_equivconst(xyz_equivconst.DSC.L1+t282-1,t280-1+   
     .       .            xyz_equivconst.DSC.L2,t278+xyz_equivconst.DSC.L3)))))*
     .       1            5.00000000000000e-001                                 
     .                 xyz_solution(xyz_solution.DSC.L1+t282-1,t280+            
     .       1            xyz_solution.DSC.L2,t278+xyz_solution.DSC.L3) = (     
     .       2            %00045c(t282,t280+1,t278+1)-dsqrt((xyzf_partialpress( 
     .       3            xyzf_partialpress.DSC.L1+t282-1,t280+                 
     .       4            xyzf_partialpress.DSC.L2,t278+xyzf_partialpress.DSC.L3
     .       5            ,1)-xyzf_partialpress(xyzf_partialpress.DSC.L1+t282-1,
     .       6            t280+xyzf_partialpress.DSC.L2,t278+                   
     .       7            xyzf_partialpress.DSC.L3,2))**2.00000000000000e+000+  
     .       8            4.00000000000000e+000*dexp(min(7.00000000000000e+002, 
     .       9            xyz_equivconst(xyz_equivconst.DSC.L1+t282-1,t280+     
     .       .            xyz_equivconst.DSC.L2,t278+xyz_equivconst.DSC.L3)))))*
     .       1            5.00000000000000e-001                                 
     .                 xyz_delqmixnh4sh(xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L1+
     .       1            t282-1,t280-1+xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L2,
     .       2            t278+xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L3) =       
     .       3            xyz_solution(xyz_solution.DSC.L1+t282-1,t280-1+       
     .       4            xyz_solution.DSC.L2,t278+xyz_solution.DSC.L3)*(       
     .       5            molwtnh3 + molwth2s)/(xyz_pressall(t60+t282-1,t280-1+ 
     .       6            t62,t278+t64)*molwtdry)                               
     .                 xyz_delqmixnh4sh(xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L1+
     .       1            t282-1,t280+xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L2,  
     .       2            t278+xyz_delqmixnh4sh.DESCRIPT.RETVAL.DSC.L3) =       
     .       3            xyz_solution(xyz_solution.DSC.L1+t282-1,t280+         
     .       4            xyz_solution.DSC.L2,t278+xyz_solution.DSC.L3)*(       
     .       5            molwtnh3 + molwth2s)/(xyz_pressall(t60+t282-1,t280+t62
     .       6            ,t278+t64)*molwtdry)                                  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   673        & (                                                            &
   674        &     sum(xyzf_PartialPress, 4)                                        &
   675        &   - dsqrt( (xyzf_PartialPress(:,:,:,1) - xyzf_PartialPress(:,:,:,2)) ** 2.0d0 &
   676        &            + 4.0d0 * dexp( min( 700.0d0, xyz_EquivConst ) ) ) &
   677        &  ) * 5.0d-1
   678  
   679      !̤
   680      xyz_DelQMixNH4SH = xyz_Solution * ( MolWtNH3 + MolWtH2S ) &
   681        &                   / ( xyz_PressAll * MolWtDry )
   682  
   683    end function xyz_DelQMixNH4SH
   684  
   685  
   686  !!!-----------------------------------------------------------------------!!!
   687    function DelMolFrNH4SH(TempAll, PressAll, MolFrNH3, MolFrH2S, Humidity)
   688      !
   689      ! NH4SH ȿȼ H2S  NH3 Υθʬ
   690      !
   691  
   692      !ۤηػ
   693      implicit none
   694  
   695      !ѿ
   696      real(DP),intent(in) :: TempAll       !
   697      real(DP),intent(in) :: PressAll      !
   698      real(DP),intent(in) :: MolFrNH3      !NH3 Υ
   699      real(DP),intent(in) :: MolFrH2S      !H2S Υ
   700      real(DP),intent(in) :: Humidity      !˰
   701      real(DP)            :: DelMolFrNH4SH !NH4SH ȼѲ
   702      real(DP)            :: EquivConst    !ʿ
   703      real(DP)            :: PPress(2)     !(ʬ)
   704      real(DP)            :: Solution      !(β)
   705  
   706      !------------------------------------------------------------
   707      !NH4SH ʿվ
   708      !------------------------------------------------------------
   709      !˥βǤʬ
   710      PPress(1) = MolFrNH3 * PressAll
   711      PPress(2) = MolFrH2S * PressAll
   712  
   713      !ʿ
   714      EquivConst = 61.781d0 - 10834.0d0 / TempAll - dlog(1.0d2) - 2.0d0 * dlog( Humidity )
   715  
   716      !ѲβȤƵ.
   717      Solution = 5.0d-1 * (sum(PPress) &
     .        t22 = t22 + ppress(1)                                             
     .        t22 = t22 + ppress(2)                                             
   718        &        - dsqrt( (PPress(1) - PPress(2))**2.0d0 &
   719        &                    + 4.0d0 * dexp( min( 700.0d0, EquivConst ))) )
   720  
   721      !NH4SH .
   722      DelMolFrNH4SH = Solution / PressAll
   723  
   724    end function DelMolFrNH4SH
   725  
   726  end module ChemCalc
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:43 2011
FILE NAME: chemcalc.f90
PROGRAM NAME: 
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   727  warn (   6): Only comment lines in program.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:43 2011
FILE NAME: chemcalc.f90
PROGRAM NAME: 
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

   727  
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:43 2011
FILE NAME: chemcalc.f90
PROGRAM NAME: chemcalc
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module ChemCalc_3d
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro
     4:            ! Version::   $Id: chemcalc.f90,v 1.3 2011-05-31 06:57:00 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview
    10:            !
    11:            !شϢν̤׻뤿Υ⥸塼. 
    12:            !AMP  Antoine ˰¾Ѥưʲ. 
    13:            !ǥեȤǤ AMP Ȥ褦ˤƤ. 
    14:            !  * ˰¾
    15:            !  * ˰¾βʬ
    16:            !  * Ǯ
    17:            ! 
    18:            !== Error Handling
    19:            !
    20:            !== Bugs
    21:            !
    22:            !== Note
    23:            !
    24:            !== Future Plans
    25:            !
    26:            !
    27:            
    28:            module ChemCalc
    29:              !
    30:              !شϢν̤׻뤿Υ⥸塼. 
    31:              !AMP  Antoine ˰¾Ѥưʲ. 
    32:              !ǥեȤǤ AMP Ȥ褦ˤƤ. 
    33:              !  * ˰¾
    34:              !  * ˰¾βʬ
    35:              !  * Ǯ
    36:              !
    37:            
    38:              !⥸塼ƤӽФ
    39:              use dc_types,       only : DP
    40:            
    41:              use dc_message, only: MessageNotify
    42:            
    43:              use ChemData, only: ChemData_init,                 & !
    44:                &                 ChemData_SpcNum,               & !ǡ١βؼ
    45:                &                 ChemData_SvapPress_AntoineA,   & !Antoine  A 
    46:                &                 ChemData_SvapPress_AntoineB,   & !Antoine  B 
    47:                &                 ChemData_SvapPress_AntoineC,   & !Antoine  C 
    48:                &                 ChemData_SvapPress_AntoineUnit,& !ñѴѷ
    49:                &                 ChemData_SvapPress_AMPA,       & !AMP  A 
    50:                &                 ChemData_SvapPress_AMPB,       & !AMP  B 
    51:                &                 ChemData_SvapPress_AMPC,       & !AMP  C 
    52:                &                 ChemData_SvapPress_AMPD,       & !AMP  D 
    53:                &                 ChemData_SvapPress_AMPE,       & !AMP  E 
    54:                &                 GasRUniv,                      & !
    55:                &                 ChemData_OneSpcID,             & !ؼ ID      
    56:                &                 ChemData_CpRef,                & !ɸ֤Ǥñ̼Ǯ
    57:                &                 ChemData_CpPerMolRef,          & !ɸ֤Ǥñ̥Ǯ
    58:                &                 ChemData_CvRef,                & !ɸ֤Ǥñ̼Ǯ
    59:                &                 ChemData_MolWt,                & !ʬ
    60:                &                 ChemData_GasR                    ! [J/K kg]
    61:              use gridset, only:  imin,                     &!  X β
    62:                &                 imax,                        &!  X ξ
    63:                &                 jmin,                        &!  Y β
    64:                &                 jmax,                        &!  Y ξ
    65:                &                 kmin,                        &!  Z β
    66:                &                 kmax                          !  Z ξ
    67:              use constants,only: PressBasis,         & !̤ɸవ         [Pa]
    68:                &                 CpDry,              & !ʬʿ갵Ǯ [J/K kg]
    69:                &                 MolWtDry,           & !ʬʿʬ   [kg/mol]
    70:                &                 GasRDry               !ʬε     [J/K kg]
    71:            
    72:              !ۤηػ
    73:              implicit none
    74:            
    75:              !ΤФ private °դ. 
    76:              private
    77:              
    78:              !Τˤ public °դ
    79:              public ChemCalc_Init                            !롼
    80:              public MolWt                                    !ʬ
    81:              public GasR                                     !
    82:              public CpRef, CpPerMolRef, CvRef                !갵Ǯ, Ǯ
    83:              public SvapPress, xyz_SvapPress                 !˰¾ [Pa]
    84:              public xyz_DSvapPressDTemp                      !˰¾βʬ [Pa/K]
    85:              public xyz_LatentHeat                           !Ǯ [J/K kg]
    86:              public LatentHeatPerMol                         !Ǯ [J/K mol]
    87:              public ReactHeatNH4SH, ReactHeatNH4SHPerMol     !NH4SH ȿǮ
    88:              public xyz_DQMixSatDPTemp
    89:              public xyz_DelQMixNH4SH
    90:              public DelMolFrNH4SH
    91:            
    92:              real(DP)            :: ReactHeatNH4SH           !NH4SH ȿǮ [J/K kg]
    93:              real(DP)            :: ReactHeatNH4SHPerMol     !NH4SH ȿǮ [J/K mol]
    94:              real(DP)            :: a_antA(ChemData_SpcNum)   !Antoine ξ A 
    95:              real(DP)            :: a_antB(ChemData_SpcNum)   !Antoine ξ B 
    96:              real(DP)            :: a_antC(ChemData_SpcNum)   !Antoine ξ C 
    97:              real(DP)            :: a_antU(ChemData_SpcNum)   !Antoine ξñ̴Τη
    98:              real(DP)            :: a_ampA(ChemData_SpcNum)   !AMP ξ A 
    99:              real(DP)            :: a_ampB(ChemData_SpcNum)   !AMP ξ B 
   100:              real(DP)            :: a_ampC(ChemData_SpcNum)   !AMP ξ C 
   101:              real(DP)            :: a_ampD(ChemData_SpcNum)   !AMP ξ D 
   102:              real(DP)            :: a_ampE(ChemData_SpcNum)   !AMP ξ E 
   103:              real(DP)            :: a_MolWt(ChemData_SpcNum)  !ʬ
   104:             
   105:              save ReactHeatNH4SH, ReactHeatNH4SHPerMol
   106:              save a_antA, a_antB, a_antC, a_antU, a_MolWt
   107:              save a_ampA, a_ampB, a_ampC, a_ampD, a_ampE
   108:            
   109:            contains
   110:              
   111:            !!!
   112:            !!! 롼
   113:            !!!
   114:            !!!==========================================================================
   115:              subroutine ChemCalc_Init( )
   116:                !
   117:                !롼
   118:                !
   119:            
   120:                !ۤηػ
   121:                implicit none
   122:            
   123:                !ѿ
   124:                character(20)      :: Name
   125:                integer            :: id
   126:            
   127:                !-----------------------------------------------------------
   128:                ! 
   129:                !
   130:            
   131:                ! ǡ١ν
   132:                call chemdata_init( )
   133:            
   134:                !Antoine ˰¾η
   135: V------>       a_antA = ChemData_SvapPress_AntoineA
   136: |              a_antB = ChemData_SvapPress_AntoineB
   137: |              a_antC = ChemData_SvapPress_AntoineC
   138: |              a_antU = ChemData_SvapPress_AntoineUnit
   139: |          
   140: |              !AMP ˰¾η
   141: |              a_ampA = ChemData_SvapPress_AMPA
   142: |              a_ampB = ChemData_SvapPress_AMPB
   143: |              a_ampC = ChemData_SvapPress_AMPC
   144: |              a_ampD = ChemData_SvapPress_AMPD
   145: |              a_ampE = ChemData_SvapPress_AMPE
   146: |          
   147: |              !ʬ
   148: V------        a_MolWt = ChemData_MolWt
   149:                
   150:                !NH4SH ȿǮν
   151:                !  NH4SH 1kg ФȿǮˤ.
   152:                Name = 'NH4SH-s'
   153:                id   = ChemData_OneSpcID( Name )  
   154:                
   155:                ReactHeatNH4SHPerMol  = GasRUniv * 10834.0d0
   156:          I     ReactHeatNH4SH = GasRUniv * 10834.0d0 / MolWt( id )
   157:            
   158:                call MessageNotify( "M", &
   159:                  & "ChemCalc_Init", "ReactHeatNH4SH = %f", d=(/ReactHeatNH4SH/) )
   160:          I     call MessageNotify( "M", &
   161:                  & "ChemCalc_Init", "NH4SH MolWt = %f", d=(/MolWt(id)/) )
   162:            
   163:              end subroutine ChemCalc_Init
   164:            
   165:            
   166:            
   167:            !!!
   168:            !!! ˰¾, Ǯ, etc. δܴؿ. 
   169:            !!! ؼ ID Ȳ٤Ф֤ͤ
   170:            !!!  
   171:            
   172:            !!!==========================================================================
   173:              function CpRef(ID)
   174:                !
   175:                !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
   176:                !
   177:            
   178:                !ۤηػ
   179:                implicit none
   180:                
   181:                !ѿ  
   182:                real(DP)            :: CpRef        !ɸ֤Ǥñ̼Ǯ
   183:                integer, intent(in) :: ID           !ؼ ID
   184:            
   185:                
   186:                !ǡ١
   187:                CpRef = ChemData_CpRef(ID)
   188:            
   189:              end function CpRef
   190:            
   191:            
   192:            !!!==========================================================================
   193:              function CpPerMolRef(ID)
   194:                !
   195:                !Ϳ줿ؼФ, ɸ֤Ǥñ̥갵Ǯ׻
   196:                !
   197:            
   198:                !ۤηػ
   199:                implicit none
   200:                
   201:                !ѿ  
   202:                real(DP)            :: CpPerMolRef  !ɸ֤Ǥñ̥Ǯ
   203:                integer, intent(in) :: ID           !ؼ ID
   204:            
   205:                
   206:                !ǡ١
   207:                CpPerMolRef = ChemData_CpPerMolRef(ID)
   208:            
   209:              end function CpPerMolRef
   210:            
   211:            
   212:            !!!==========================================================================
   213:              function CvRef(ID)
   214:                !
   215:                !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
   216:                !
   217:            
   218:                !ۤηػ
   219:                implicit none
   220:                
   221:                !ѿ  
   222:                real(DP)            :: CvRef       !ɸ֤Ǥñ̼Ǯ
   223:                integer, intent(in) :: ID           !ؼ ID
   224:            
   225:                
   226:                !ǡ١
   227:                CvRef = ChemData_CvRef(ID)
   228:            
   229:              end function CvRef
   230:            
   231:            
   232:            !!!==========================================================================
   233:              function MolWt(ID)
   234:                !
   235:                !Ϳ줿ؼФ, ʬ̤׻
   236:                !
   237:            
   238:                !ۤηػ
   239:                implicit none
   240:                
   241:                !ѿ  
   242:                real(DP)            :: MolWt         !ʬ
   243:                integer, intent(in) :: ID      !ؼ ID
   244:            
   245:                
   246:                !ǡ١
   247:                MolWt = ChemData_MolWt(ID)
   248:            
   249:              end function MolWt
   250:            
   251:            
   252:            !!!==========================================================================
   253:              function GasR(ID)
   254:                !
   255:                !Ϳ줿ؼФ, ׻
   256:                !
   257:            
   258:                !ۤηػ
   259:                implicit none
   260:                
   261:                !ѿ  
   262:                real(DP)            :: GasR          !ʬ
   263:                integer, intent(in) :: ID      !ؼ ID
   264:                
   265:                
   266:                !ǡ١
   267:                GasR = ChemData_GasR(ID)
   268:            
   269:              end function GasR
   270:            
   271:            
   272:            
   273:            !!!
   274:            !!!  3 δؿ
   275:            !!!
   276:            
   277:            !!!==========================================================================
   278:              function xyz_SvapPressAnt( ID, xyz_Temp )
   279:                !
   280:                !˰¾η׻. Antoine μ
   281:                !
   282:            
   283:                !ۤηػ
   284:                implicit none
   285:                
   286:                ! ѿ  
   287:                real(DP)            :: xyz_SvapPressAnt(imin:imax,jmin:jmax,kmin:kmax) 
   288:                                                                      !˰¾
   289:                real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)  
   290:                                                                      !
   291:                integer, intent(in) :: ID                             !ؼ ID
   292:              
   293:                !ѿ
   294:                real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax) 
   295:                real(DP),parameter  :: Temp0C = 273.15d0
   296:            
   297:            
   298:                !˰¾ log ׻
   299:                !п礭ʤꤹʤ褦ˤ. 
   300:                ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   301: **V---->       xyz_LogSvapPress =                                          &
   302: |||              & min(                                                   & 
   303: |||              &       (                                                &
   304: |||              &         a_antA(ID)                                     &
   305: |||              &         - a_antB(ID) / (a_antC(ID) + xyz_Temp - Temp0C) &
   306: |||              &        ) * dlog(10.0d0)                                &
   307: |||              &        + a_antU(ID),                                   &
   308: |||              &      7.0d2                                             &
   309: |||              &    )
   310: |||            
   311: |||            !˰¾׻
   312: **V----        xyz_SvapPressAnt =  dexp( xyz_LogSvapPress )
   313:            
   314:              end function xyz_SvapPressAnt
   315:            
   316:            
   317:            !!!==========================================================================
   318:              function xyz_DSvapPressDTempAnt(ID, xyz_Temp)
   319:                !
   320:                !˰¾βʬη׻. Antoine μ
   321:                !
   322:                
   323:                !ۤηػ
   324:                implicit none
   325:                
   326:                !ѿ
   327:                real(DP)            :: xyz_DSvapPressDTempAnt(imin:imax,jmin:jmax,kmin:kmax)
   328:                                                              !˰¾βʬ [Pa/K]
   329:                real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   330:                                                              ! [K]
   331:                integer, intent(in) :: ID                     !ؼ ID
   332:              
   333:                !ѿ
   334:                real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax)
   335:                real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   336:                real(DP),parameter  :: Temp0C = 273.15d0
   337:            
   338:            
   339:                !˰¾ log ׻
   340:                !п礭ʤꤹʤ褦ˤ. 
   341:                ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   342: **V---->       xyz_LogSvapPress =                                          &
   343: |||              & min(                                                   &
   344: |||              &      (                                                 &
   345: |||              &          a_antA(ID)                                    &
   346: |||              &        - a_antB(ID) / (a_antC(ID) + xyz_Temp - Temp0C)  &
   347: |||              &       ) * dlog(10.0d0)                                 &
   348: |||              &       + a_antU(ID),                                    &
   349: |||              &     7.0d2                                              &
   350: |||              &    )
   351: |||            
   352: |||            xyz_DLogSvapPressDTemp =                                &
   353: |||              & a_antB(ID) * dlog(10.0d0)                          &
   354: |||              &  / ( (a_antC(ID) + xyz_Temp - Temp0C) ** 2.0d0 )
   355: |||            
   356: |||            !˰¾βʬ׻
   357: **V----        xyz_DSvapPressDTempAnt = xyz_DLogSvapPressDTemp * dexp( xyz_LogSvapPress ) 
   358:                
   359:              end function xyz_DSvapPressDTempAnt
   360:              
   361:            
   362:            !!!==========================================================================
   363:              function xyz_LatentHeatAnt(ID, xyz_Temp)
   364:                !
   365:                !˰¾Ǯ׻. Antoine μ
   366:                !
   367:                
   368:                !ۤηػ
   369:                implicit none
   370:            
   371:                !ѿ
   372:                real(DP)            :: xyz_LatentHeatAnt(imin:imax,jmin:jmax,kmin:kmax)
   373:                                                                        !Ǯ[J/K kg]
   374:                real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax)
   375:                                                                ![K]
   376:                integer, intent(in) :: ID                       !ؼ ID
   377:            
   378:                !ؿ
   379:                real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   380:                real(DP),parameter  :: GasRUniv = 8.314d0
   381:                real(DP),parameter  :: Temp0C = 273.15d0
   382:            
   383:                !˰¾ log ׻, Ǯ׻. 
   384: **V---->       xyz_DLogSvapPressDTemp =                                   &
   385: |||              & a_antB(ID) * dlog(10.0d0)                             &
   386: |||              &  / ( (a_antC(ID) + xyz_Temp - Temp0C) ** 2.0d0 )
   387: |||            
   388: **V----        xyz_LatentHeatAnt =                                        &
   389:                  & xyz_DLogSvapPressDTemp * GasRUniv * (xyz_Temp ** 2.0d0) &
   390:                  &  / a_MolWt(ID)
   391:            
   392:              end function xyz_LatentHeatAnt
   393:            
   394:            
   395:            !!!==========================================================================
   396:              function xyz_SvapPress(ID, xyz_Temp)
   397:                !
   398:                !Ϳ줿ؼȲ٤Ф, ˰¾׻. AMP 
   399:                !
   400:            
   401:                !ۤηػ
   402:                implicit none
   403:                
   404:                !ѿ  
   405:                real(DP)            :: xyz_SvapPress(imin:imax,jmin:jmax,kmin:kmax)
   406:                                                                     !˰¾
   407:                real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax) 
   408:                                                                     ! [K]
   409:                integer, intent(in) :: ID                            !ؼ ID
   410:            
   411:                !ѿ
   412:                real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax)
   413:                
   414:                !˰¾п׻
   415:                !п礭ʤꤹʤ褦ˤ. 
   416:                ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   417: **V---->       xyz_LogSvapPress =                            &
   418: |||              & min(                                     &
   419: |||              &      (                                   &
   420: |||              &          a_ampA(ID) / xyz_Temp            &
   421: |||              &        + a_ampB(ID)                      &
   422: |||              &        + a_ampC(ID) * dlog( xyz_Temp )    &
   423: |||              &        + a_ampD(ID) * xyz_Temp            &
   424: |||              &        + a_ampE(ID) * ( xyz_temp ** 2 )   &
   425: |||              &        + dlog(1.0d-1)                    &
   426: |||              &      ),                                  &
   427: |||              &    7.0d2                                 &
   428: |||              &   )
   429: |||        
   430: |||            !˰¾׻
   431: **V----        xyz_SvapPress =  dexp( xyz_LogSvapPress )
   432:                
   433:              end function xyz_SvapPress
   434:            
   435:            
   436:            !!!==========================================================================
   437:              function xyz_DSvapPressDTemp(ID, xyz_Temp)
   438:                !
   439:                !Ϳ줿ؼȲ٤Ф, ˰¾βʬ׻
   440:                !
   441:                
   442:                !ۤηػ
   443:                implicit none
   444:              
   445:                !ѿ    
   446:                real(DP)            :: xyz_DSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   447:                                                                     !˰¾βʬ [Pa/K]
   448:                real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax) 
   449:                                                                     ! [K]
   450:                integer, intent(in) :: ID                            !ؼ̾
   451:            
   452:                !ѿ
   453:                real(DP)            :: xyz_LogSvapPress(imin:imax,jmin:jmax,kmin:kmax)
   454:                real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   455:                
   456:            
   457:                !˰¾п׻
   458:                !п礭ʤꤹʤ褦ˤ. 
   459:                ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   460: **V---->       xyz_LogSvapPress =                        &
   461: |||              & min(                               &
   462: |||              &      (                             &
   463: |||              &          a_ampA(ID) / xyz_Temp            &
   464: |||              &        + a_ampB(ID)                      &
   465: |||              &        + a_ampC(ID) * dlog( xyz_Temp )    &
   466: |||              &        + a_ampD(ID) * xyz_Temp            &
   467: |||              &        + a_ampE(ID) * ( xyz_temp ** 2 )   &
   468: |||              &        + dlog(1.0d-1)                    &
   469: |||              &      ),                                  &
   470: |||              &    7.0d2                                 &
   471: |||              &   )
   472: |||        
   473: |||            !˰¾βʬ
   474: |||            xyz_DLogSvapPressDTemp =                   &
   475: |||              & - a_ampA(ID) / (xyz_Temp ** 2.0d0)        &
   476: |||              & + a_ampC(ID) / xyz_Temp                   &
   477: |||              & + a_ampD(ID)                             &
   478: |||              & + a_ampE(ID) * 2.0d0 * xyz_Temp
   479: |||            
   480: |||            !˰¾βʬ
   481: **V----        xyz_DSvapPressDTemp =                          &
   482:                  & xyz_DLogSvapPressDTemp * dexp( xyz_LogSvapPress ) 
   483:                
   484:              end function xyz_DSvapPressDTemp
   485:              
   486:            
   487:            !!!==========================================================================
   488:              function xyz_LatentHeat(ID, xyz_Temp)
   489:                !
   490:                !Ϳ줿ؼȲ٤Ф, Ǯ׻
   491:                !
   492:            
   493:                !ۤηػ
   494:                implicit none
   495:            
   496:                !ѿ
   497:                real(DP)            :: xyz_LatentHeat(imin:imax,jmin:jmax,kmin:kmax)
   498:                                                                     !Ǯ
   499:                real(DP),intent(in) :: xyz_Temp(imin:imax,jmin:jmax,kmin:kmax) 
   500:                                                                     !
   501:                integer, intent(in) :: ID                            !ؼ̾
   502:                
   503:                !ѿ
   504:                real(DP)            :: xyz_DLogSvapPressDTemp(imin:imax,jmin:jmax,kmin:kmax)
   505:                real(DP),parameter  :: GasRUniv = 8.314d0  !׵
   506:                
   507:            
   508:                !˰¾βʬ
   509: **V---->       xyz_DLogSvapPressDTemp =                      &
   510: |||              & - a_ampA(ID) / (xyz_Temp ** 2.0d0)        &
   511: |||              & + a_ampC(ID) / xyz_Temp                   &
   512: |||              & + a_ampD(ID)                             &
   513: |||              & + a_ampE(ID) * 2.0d0 * xyz_Temp
   514: |||                
   515: |||            !Ǯη׻
   516: **V----        xyz_LatentHeat =                                           &
   517:                  & xyz_DLogSvapPressDTemp * GasRUniv * (xyz_Temp ** 2.0d0) &
   518:                  & / a_MolWt(ID)
   519:            
   520:              end function xyz_LatentHeat
   521:            
   522:            
   523:            !!!==========================================================================
   524:              function SvapPress(ID, Temp)
   525:                !
   526:                !Ϳ줿ؼȲ٤Ф, ˰¾׻. AMP 
   527:                !
   528:            
   529:                !ۤηػ
   530:                implicit none
   531:                
   532:                !ѿ  
   533:                real(DP)            :: SvapPress   !˰¾
   534:                real(DP),intent(in) :: Temp        ! [K]
   535:                integer, intent(in) :: ID          !ؼ ID
   536:            
   537:                !ѿ
   538:                real(DP)            :: LogSvapPress
   539:                
   540:                !˰¾п׻
   541:                !п礭ʤꤹʤ褦ˤ. 
   542:                ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
   543:                LogSvapPress =                            &
   544:                  & min(                                     &
   545:                  &      (                                   &
   546:                  &          a_ampA(ID) / Temp            &
   547:                  &        + a_ampB(ID)                      &
   548:                  &        + a_ampC(ID) * dlog( Temp )    &
   549:                  &        + a_ampD(ID) * Temp            &
   550:                  &        + a_ampE(ID) * ( temp ** 2 )   &
   551:                  &        + dlog(1.0d-1)                    &
   552:                  &      ),                                  &
   553:                  &    7.0d2                                 &
   554:                  &   )
   555:            
   556:                !˰¾׻
   557:                SvapPress =  dexp( LogSvapPress )
   558:                
   559:              end function SvapPress
   560:            
   561:            
   562:            !!!==========================================================================
   563:              function LatentHeatPerMol(ID, Temp)
   564:                !
   565:                !Ϳ줿ؼȲ٤Ф, Ǯ׻
   566:                !
   567:            
   568:                !ۤηػ
   569:                implicit none
   570:            
   571:                !ѿ
   572:                real(DP)            :: LatentHeatPerMol   !Ǯ
   573:                real(DP),intent(in) :: Temp            !
   574:                integer, intent(in) :: ID                 !ؼ̾
   575:                
   576:                !ѿ
   577:                real(DP)            :: DLogSvapPressDTemp
   578:                real(DP),parameter  :: GasRUniv = 8.314d0  !׵
   579:                
   580:            
   581:                !˰¾βʬ
   582:                DLogSvapPressDTemp =                      &
   583:                  & - a_ampA(ID) / (Temp ** 2.0d0)        &
   584:                  & + a_ampC(ID) / Temp                   &
   585:                  & + a_ampD(ID)                          &
   586:                  & + a_ampE(ID) * 2.0d0 * Temp
   587:                    
   588:                !Ǯη׻
   589:                LatentHeatPerMol =                                     &
   590:                  & DLogSvapPressDTemp * GasRUniv * (Temp ** 2.0d0) 
   591:            
   592:              end function LatentHeatPerMol
   593:            
   594:            !!!-----------------------------------------------------------------------!!!
   595:              function xyz_DQMixSatDPTemp(SpcID, MolWt, xyz_TempAll, xyz_ExnerAll)
   596:                !
   597:                !˰¾  ʬԤ
   598:                !ºݤˤ, dq/dp * dp/dT * dT/d ¹. (â p ˰¾)
   599:                !
   600:            
   601:                !ۤηػ
   602:                implicit none 
   603:                
   604:                !ѿ
   605:                integer, intent(in) :: SpcID
   606:                real(DP),intent(in) :: MolWt
   607:                real(DP),intent(in) :: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
   608:                                                        !( + ܾ)
   609:                real(DP),intent(in) :: xyz_ExnerAll(imin:imax,jmin:jmax,kmin:kmax)
   610:                                                        !ʡؿ( + ܾ)
   611:                real(DP)            :: xyz_PressAll(imin:imax,jmin:jmax,kmin:kmax)
   612:                                                        !( + ܾ)
   613:                real(DP)            :: xyz_DQMixSatDPTemp(imin:imax,jmin:jmax,kmin:kmax)
   614:                                       
   615: **V---->       xyz_DQMixSatDPTemp   = 0.0d0
   616: **V----        xyz_PressAll = PressBasis * (xyz_ExnerAll ** (CpDry / GasRDry))
   617:                
   618: ++V====  I     xyz_DQMixSatDPTemp =                            &
   619:                  &   MolWt / ( MolWtDry * xyz_PressAll )          &
   620:                  & * xyz_DSvapPressDTemp(SpcID, xyz_TempAll)       &
   621:                  & * xyz_ExnerAll
   622:                
   623:              end function xyz_DQMixSatDPTemp
   624:            
   625:            
   626:            !!!-----------------------------------------------------------------------!!!
   627:              function xyz_DelQMixNH4SH(xyz_TempAll, xyz_PressAll, xyz_QMixNH3, xyz_QMixH2S, &
   628:                &                    MolWtNH3, MolWtH2S)
   629:                !
   630:                ! NH4SH ȿȼ, NH4SH ()
   631:                !
   632:                
   633:                !ۤηػ
   634:                implicit none
   635:            
   636:                !ѿ
   637:                real(DP),intent(in) :: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
   638:                                                     !
   639:                real(DP),intent(in) :: xyz_PressAll(imin:imax,jmin:jmax,kmin:kmax)
   640:                                                     !
   641:                real(DP),intent(in) :: xyz_QMixNH3(imin:imax,jmin:jmax,kmin:kmax)
   642:                                                     !NH3 κ
   643:                real(DP),intent(in) :: xyz_QMixH2S(imin:imax,jmin:jmax,kmin:kmax)
   644:                                                     !H2S κ
   645:                real(DP),intent(in) :: MolWtNH3      !NH3 ʬ
   646:                real(DP),intent(in) :: MolWtH2S      !H2S ʬ
   647:            
   648:                real(DP) :: xyz_DelQMixNH4SH(imin:imax,jmin:jmax,kmin:kmax)
   649:                                                     !NH4SH κ
   650:                real(DP) :: xyz_EquivConst(imin:imax,jmin:jmax,kmin:kmax)
   651:                                                     !ʿ
   652:                real(DP) :: xyzf_PartialPress(imin:imax,jmin:jmax,kmin:kmax,2)
   653:                                                     !(ʬ)
   654:                real(DP) :: xyz_Solution(imin:imax,jmin:jmax,kmin:kmax)
   655:                                                     !(β)
   656:            
   657:                !
   658: **V---->       xyz_DelQMixNH4SH = 0.0d0
   659: |||            
   660: |||            !˥βǤʬ. 
   661: |||            xyzf_PartialPress(:,:,:,1) = xyz_QMixNH3 * xyz_PressAll * MolWtDry / MolWtNH3 
   662: |||            xyzf_PartialPress(:,:,:,2) = xyz_QMixH2S * xyz_PressAll * MolWtDry / MolWtH2S 
   663: |||        
   664: |||            !ʿ
   665: **V----        xyz_EquivConst = 61.781d0 - 10834.0d0 / xyz_TempAll - dlog(1.0d2)
   666:            
   667:                !Ѳ. 
   668:                !  (P_NH3 - X) * (P_H2S - X) = exp(Kp)
   669:                !  DelX^2 - (P_NH3 + P_H2S) * DelX + P_NH3 * P_H2S * exp( Kp ) = 0
   670:                !  Ȥɬפ뤬, P_NH3 > P_H2S  X < P_H2S 
   671:                !  θ, θΤ򤵤.
   672: +++V--->       xyz_Solution  =                                                   &
   673: |||              & (                                                            &
   674: |||              &     sum(xyzf_PartialPress, 4)                                        &
   675: |||              &   - dsqrt( (xyzf_PartialPress(:,:,:,1) - xyzf_PartialPress(:,:,:,2)) ** 2.0d0 &
   676: |||              &            + 4.0d0 * dexp( min( 700.0d0, xyz_EquivConst ) ) ) &
   677: |||              &  ) * 5.0d-1
   678: |||        
   679: |||            !̤
   680: +++----        xyz_DelQMixNH4SH = xyz_Solution * ( MolWtNH3 + MolWtH2S ) &
   681:                  &                   / ( xyz_PressAll * MolWtDry )
   682:            
   683:              end function xyz_DelQMixNH4SH
   684:              
   685:            
   686:            !!!-----------------------------------------------------------------------!!!
   687:              function DelMolFrNH4SH(TempAll, PressAll, MolFrNH3, MolFrH2S, Humidity)
   688:                !
   689:                ! NH4SH ȿȼ H2S  NH3 Υθʬ
   690:                !
   691:                
   692:                !ۤηػ
   693:                implicit none
   694:            
   695:                !ѿ
   696:                real(DP),intent(in) :: TempAll       !
   697:                real(DP),intent(in) :: PressAll      !
   698:                real(DP),intent(in) :: MolFrNH3      !NH3 Υ
   699:                real(DP),intent(in) :: MolFrH2S      !H2S Υ
   700:                real(DP),intent(in) :: Humidity      !˰
   701:                real(DP)            :: DelMolFrNH4SH !NH4SH ȼѲ
   702:                real(DP)            :: EquivConst    !ʿ
   703:                real(DP)            :: PPress(2)     !(ʬ)
   704:                real(DP)            :: Solution      !(β)
   705:            
   706:                !------------------------------------------------------------
   707:                !NH4SH ʿվ
   708:                !------------------------------------------------------------
   709:                !˥βǤʬ
   710:                PPress(1) = MolFrNH3 * PressAll
   711:                PPress(2) = MolFrH2S * PressAll
   712:            
   713:                !ʿ
   714:                EquivConst = 61.781d0 - 10834.0d0 / TempAll - dlog(1.0d2) - 2.0d0 * dlog( Humidity )
   715:                
   716:                !ѲβȤƵ. 
   717: *======        Solution = 5.0d-1 * (sum(PPress) &
   718:                  &        - dsqrt( (PPress(1) - PPress(2))**2.0d0 &
   719:                  &                    + 4.0d0 * dexp( min( 700.0d0, EquivConst ))) )
   720:                
   721:                !NH4SH . 
   722:                DelMolFrNH4SH = Solution / PressAll
   723:            
   724:              end function DelMolFrNH4SH
   725:            
   726:            end module ChemCalc
