Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:04 2011
FILE NAME: fillnegative.f90
PROGRAM NAME: fillnegative
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    78  vec  (   4): Vectorized array expression.
    78  vec  (   4): Vectorized array expression.
    79  vec  (   4): Vectorized array expression.
    79  vec  (   4): Vectorized array expression.
    81  vec  (   4): Vectorized array expression.
    81  vec  (   4): Vectorized array expression.
    82  vec  (   4): Vectorized array expression.
    82  vec  (   4): Vectorized array expression.
    90  vec  (   3): Unvectorized loop.
   120  opt  (  11): Fused array assignments. :line 120 - 125
   120  vec  (   4): Vectorized array expression.
   120  vec  (   4): Vectorized array expression.
   131  opt  (  11): Fused array assignments. :line 131 - 137
   131  vec  (   4): Vectorized array expression.
   131  vec  (   4): Vectorized array expression.
   140  vec  (   3): Unvectorized loop.
   141  vec  (   4): Vectorized array expression.
   141  vec  (   4): Vectorized array expression.
   159  opt  (  11): Fused array assignments. :line 159 - 164
   159  vec  (   4): Vectorized array expression.
   159  vec  (   4): Vectorized array expression.
   170  opt  (  11): Fused array assignments. :line 170 - 176
   170  vec  (   4): Vectorized array expression.
   170  vec  (   4): Vectorized array expression.
   179  vec  (   4): Vectorized array expression.
   179  vec  (   4): Vectorized array expression.
   202  opt  (  11): Fused array assignments. :line 202 - 203
   202  vec  (   4): Vectorized array expression.
   202  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   208  vec  (   1): Vectorized loop.
   235  vec  (   1): Vectorized loop.
   271  vec  (   4): Vectorized array expression.
   271  vec  (   4): Vectorized array expression.
   276  opt  (  11): Fused array assignments. :line 276 - 277
   276  vec  (   4): Vectorized array expression.
   276  vec  (   4): Vectorized array expression.
   282  vec  (   1): Vectorized loop.
   319  vec  (   1): Vectorized loop.
   368  vec  (   4): Vectorized array expression.
   368  vec  (   4): Vectorized array expression.
   395  opt  (  11): Fused array assignments. :line 395 - 397
   395  vec  (   4): Vectorized array expression.
   395  vec  (   4): Vectorized array expression.
   400  vec  (   1): Vectorized loop.
   417  vec  (   1): Vectorized loop.
   435  vec  (   4): Vectorized array expression.
   435  vec  (   4): Vectorized array expression.
   440  opt  (  11): Fused array assignments. :line 440 - 441
   440  vec  (   4): Vectorized array expression.
   440  vec  (   4): Vectorized array expression.
   445  vec  (   1): Vectorized loop.
   468  vec  (   1): Vectorized loop.
   492  vec  (   4): Vectorized array expression.
   492  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:04 2011
FILE NAME: fillnegative.f90
PROGRAM NAME: fillnegative
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module FillNegative
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4  ! Version::   $Id: fillnegative.f90,v 1.10 2011-07-15 08:43:30 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !α̤ʤɤ᤹뤿Υ롼
    12  !  * Ȥʤäˤ, Ϥ 8 ʻͤäƷ᤹.
    13  !
    14  !== Error Handling
    15  !
    16  !== Bugs
    17  !
    18  !== Note
    19  !
    20  !  *  deepconv  QFILL.f 
    21  !
    22  !== Future Plans
    23  !
    24  !
    25  
    26  module FillNegative
    27    !
    28    !α̤ʤɤ᤹뤿Υ롼
    29    !  * Ȥʤäˤ, Ϥ 8 ʻͤäƷ᤹.
    30    !
    31  
    32    !⥸塼ɤ߹
    33    use dc_types,   only: DP
    34    use dc_message, only: MessageNotify
    35    use gtool_historyauto, only: HistoryAutoAddVariable, HistoryAutoPut
    36    use timeset, only:  DelTimeLong, DelTimeShort, TimeN
    37    use gridset, only: imin,  &!  X β
    38      &                imax,  &!  X ξ
    39      &                jmin,  &!  Y β
    40      &                jmax,  &!  Y ξ
    41      &                kmin,  &!  Z β
    42      &                kmax,  &!  Z ξ
    43      &                nx,ny,nz,ncmax
    44    use basicset, only: xyzf_QMixBZ, xyz_DensBZ
    45    use composition, only: SpcWetSymbol
    46  
    47    implicit none
    48  
    49    public FillNegative_Init
    50    public FillNegativeQMix
    51    public FillNegativeDensity
    52  
    53    real(DP), save, allocatable  :: xyza_Basic(:,:,:,:)
    54    real(DP), save, allocatable  :: xyz_Dens(:,:,:)
    55    real(DP), save, allocatable  :: xza_Basic(:,:,:)
    56    real(DP), save, allocatable  :: xz_Dens(:,:)
    57  
    58  contains
    59  
    60    subroutine FillNegative_Init( )
    61      !
    62      ! ͤ.
    63      ! ܾȾʬ¤⾮ʤ뤳ȤϵƤʤ
    64      !
    65  
    66      implicit none
    67  
    68      !ѿ
    69      integer  :: l
    70  
    71      !
    72      allocate( xyza_Basic(imin:imax,jmin:jmax,kmin:kmax, ncmax) )
    73      allocate( xyz_Dens  (imin:imax,jmin:jmax,kmin:kmax) )
    74      allocate( xza_Basic(imin:imax,kmin:kmax, ncmax) )
    75      allocate( xz_Dens(imin:imax,kmin:kmax ) )
    76  
    77      !ͤ
    78      xyza_Basic = xyzf_QMixBZ
     .        if (t115 .gt. 0) then                                             
     .           J1 = and(t115,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t245 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t247 = 1, t117                                           
     .                 xyza_basic(t38+t247-1,t245-1+t40,t243+t42,t241+t44) =    
     .       1            xyzf_qmixbz(t13+t247-1,t245-1+xyzf_qmixbz.DSC.L2,t243+
     .       2            t17,t241+t19)                                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t245 = J1 + 1, t115, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t247 = 1, t117                                           
     .                 xyza_basic(t38+t247-1,t245-1+t40,t243+t42,t241+t44) =    
     .       1            xyzf_qmixbz(t13+t247-1,t245-1+xyzf_qmixbz.DSC.L2,t243+
     .       2            t17,t241+t19)                                         
     .                 xyza_basic(t38+t247-1,t245+t40,t243+t42,t241+t44) =      
     .       1            xyzf_qmixbz(t13+t247-1,t245+xyzf_qmixbz.DSC.L2,t243+  
     .       2            t17,t241+t19)                                         
     .                 xyza_basic(t38+t247-1,t245+1+t40,t243+t42,t241+t44) =    
     .       1            xyzf_qmixbz(t13+t247-1,t245+1+xyzf_qmixbz.DSC.L2,t243+
     .       2            t17,t241+t19)                                         
     .                 xyza_basic(t38+t247-1,t245+2+t40,t243+t42,t241+t44) =    
     .       1            xyzf_qmixbz(t13+t247-1,t245+2+xyzf_qmixbz.DSC.L2,t243+
     .       2            t17,t241+t19)                                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    79      xyz_Dens   = xyz_DensBZ
     .        if (xyz_dens.DSC.U2 - xyz_dens.DSC.L2 + 1 .gt. 0) then            
     .           J2 = and(xyz_dens.DSC.U2 - xyz_dens.DSC.L2 + 1,3)              
     .  !CDIR    NODEP                                                          
     .           do t259 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t261 = 1, xyz_dens.DSC.U1 - xyz_dens.DSC.L1 + 1          
     .                 xyz_dens(xyz_dens.DSC.L1+t261-1,t259-1+xyz_dens.DSC.L2,  
     .       1            t257+xyz_dens.DSC.L3) = xyz_densbz(t2+t261-1,t259-1+  
     .       2            xyz_densbz.DSC.L2,t257+t6)                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t259 = J2 + 1, xyz_dens.DSC.U2 - xyz_dens.DSC.L2 + 1, 4     
     .  !CDIR       NODEP                                                       
     .              do t261 = 1, xyz_dens.DSC.U1 - xyz_dens.DSC.L1 + 1          
     .                 xyz_dens(xyz_dens.DSC.L1+t261-1,t259-1+xyz_dens.DSC.L2,  
     .       1            t257+xyz_dens.DSC.L3) = xyz_densbz(t2+t261-1,t259-1+  
     .       2            xyz_densbz.DSC.L2,t257+t6)                            
     .                 xyz_dens(xyz_dens.DSC.L1+t261-1,t259+xyz_dens.DSC.L2,t257
     .       1            +xyz_dens.DSC.L3) = xyz_densbz(t2+t261-1,t259+        
     .       2            xyz_densbz.DSC.L2,t257+t6)                            
     .                 xyz_dens(xyz_dens.DSC.L1+t261-1,t259+1+xyz_dens.DSC.L2,  
     .       1            t257+xyz_dens.DSC.L3) = xyz_densbz(t2+t261-1,t259+1+  
     .       2            xyz_densbz.DSC.L2,t257+t6)                            
     .                 xyz_dens(xyz_dens.DSC.L1+t261-1,t259+2+xyz_dens.DSC.L2,  
     .       1            t257+xyz_dens.DSC.L3) = xyz_densbz(t2+t261-1,t259+2+  
     .       2            xyz_densbz.DSC.L2,t257+t6)                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    80  
    81      xza_Basic = xyzf_QMixBZ(:,1,:,:)
     .        if (t141 .gt. 0) then                                             
     .           J3 = and(t141,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t271 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t273 = 1, t143                                           
     .                 xza_basic(t60+t273-1,t271-1+t62,t269+t64) = xyzf_qmixbz( 
     .       1            t13+t273-1,1,t271-1+t17,t269+t19)                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t271 = J3 + 1, t141, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t273 = 1, t143                                           
     .                 xza_basic(t60+t273-1,t271-1+t62,t269+t64) = xyzf_qmixbz( 
     .       1            t13+t273-1,1,t271-1+t17,t269+t19)                     
     .                 xza_basic(t60+t273-1,t271+t62,t269+t64) = xyzf_qmixbz(t13
     .       1            +t273-1,1,t271+t17,t269+t19)                          
     .                 xza_basic(t60+t273-1,t271+1+t62,t269+t64) = xyzf_qmixbz( 
     .       1            t13+t273-1,1,t271+1+t17,t269+t19)                     
     .                 xza_basic(t60+t273-1,t271+2+t62,t269+t64) = xyzf_qmixbz( 
     .       1            t13+t273-1,1,t271+2+t17,t269+t19)                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    82      xz_Dens   = xyz_DensBZ(:,1,:)
     .        if (xz_dens.DSC.U2 - xz_dens.DSC.L2 + 1 .gt. 0) then              
     .           J4 = and(xz_dens.DSC.U2 - xz_dens.DSC.L2 + 1,3)                
     .  !CDIR    NODEP                                                          
     .           do t281 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t283 = 1, xz_dens.DSC.U1 - xz_dens.DSC.L1 + 1            
     .                 xz_dens(xz_dens.DSC.L1+t283-1,t281-1+xz_dens.DSC.L2) =   
     .       1            xyz_densbz(t2+t283-1,1,t281-1+t6)                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t281 = J4 + 1, xz_dens.DSC.U2 - xz_dens.DSC.L2 + 1, 4       
     .  !CDIR       NODEP                                                       
     .              do t283 = 1, xz_dens.DSC.U1 - xz_dens.DSC.L1 + 1            
     .                 xz_dens(xz_dens.DSC.L1+t283-1,t281-1+xz_dens.DSC.L2) =   
     .       1            xyz_densbz(t2+t283-1,1,t281-1+t6)                     
     .                 xz_dens(xz_dens.DSC.L1+t283-1,t281+xz_dens.DSC.L2) =     
     .       1            xyz_densbz(t2+t283-1,1,t281+t6)                       
     .                 xz_dens(xz_dens.DSC.L1+t283-1,t281+1+xz_dens.DSC.L2) =   
     .       1            xyz_densbz(t2+t283-1,1,t281+1+t6)                     
     .                 xz_dens(xz_dens.DSC.L1+t283-1,t281+2+xz_dens.DSC.L2) =   
     .       1            xyz_densbz(t2+t283-1,1,t281+2+t6)                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    83  
    84      call HistoryAutoAddVariable(  &
    85        & varname="CDensFill", &
    86        & dims=(/'x','y','z','t'/),     &
    87        & longname='Filling Negative term of cloud density ',  &
    88        & units='kg.m-3.s-1',    &
    89        & xtype='float')
    90      do l = 1, ncmax
    91        call HistoryAutoAddVariable(  &
    92          & varname=trim(SpcWetSymbol(l))//'_Fill', &
    93          & dims=(/'x','y','z','t'/),     &
    94          & longname='Filling Negative term of '          &
    95          &           //trim(SpcWetSymbol(l))//' mixing ratio',  &
    96          & units='kg.kg-1.s-1',    &
    97          & xtype='float')
    98      end do
    99  
   100    end subroutine FillNegative_Init
   101  
   102  
   103    subroutine FillNegativeQMix(xyzf_QMixAl)
   104  
   105      implicit none
   106  
   107      real(DP), intent(inout)  :: xyzf_QMixAl(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   108      real(DP)                 :: xyzf_QMixOrig(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   109      real(DP)                 :: xyzf_QMixWork(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   110      real(DP)                 :: xyza_Del(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   111      real(DP)                 :: DelTime
   112      integer                  :: l
   113  
   114      ! ֹ
   115      !
   116      DelTime = 2.0d0 * DelTimeLong
   117  
   118      ! ͤݴ Store Initial Value
   119      !
   120      xyzf_QMixOrig = xyzf_QMixAl
     .        if (xyzf_qmixorig.DSC.U2 + 1 - xyzf_qmixorig.DSC.L2 .gt. 0) then  
     .           J1 = and(xyzf_qmixorig.DSC.U2 + 1 - xyzf_qmixorig.DSC.L2,1)    
     .  !CDIR    NODEP                                                          
     .           do t217 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t219 = 1, xyzf_qmixorig.DSC.U1 + 1 - xyzf_qmixorig.DSC.L1
     .                 xyzf_qmixorig(xyzf_qmixorig.DSC.L1+t219-1,t217-1+        
     .       1            xyzf_qmixorig.DSC.L2,t215+xyzf_qmixorig.DSC.L3,t213+1)
     .       2             = xyzf_qmixal(xyzf_qmixal.DSC.L1+t219-1,t217-1+      
     .       3            xyzf_qmixal.DSC.L2,t215+xyzf_qmixal.DSC.L3,t213+1)    
     .                 xyzf_qmixwork(xyzf_qmixwork.DSC.L1+t219-1,t217-1+        
     .       1            xyzf_qmixwork.DSC.L2,t215+xyzf_qmixwork.DSC.L3,t213+1)
     .       2             = xyzf_qmixal(xyzf_qmixal.DSC.L1+t219-1,t217-1+      
     .       3            xyzf_qmixal.DSC.L2,t215+xyzf_qmixal.DSC.L3,t213+1)    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t217 = J1 + 1, xyzf_qmixorig.DSC.U2 + 1 -                   
     .       1      xyzf_qmixorig.DSC.L2, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t219 = 1, xyzf_qmixorig.DSC.U1 + 1 - xyzf_qmixorig.DSC.L1
     .                 xyzf_qmixorig(xyzf_qmixorig.DSC.L1+t219-1,t217-1+        
     .       1            xyzf_qmixorig.DSC.L2,t215+xyzf_qmixorig.DSC.L3,t213+1)
     .       2             = xyzf_qmixal(xyzf_qmixal.DSC.L1+t219-1,t217-1+      
     .       3            xyzf_qmixal.DSC.L2,t215+xyzf_qmixal.DSC.L3,t213+1)    
     .                 xyzf_qmixorig(xyzf_qmixorig.DSC.L1+t219-1,t217+          
     .       1            xyzf_qmixorig.DSC.L2,t215+xyzf_qmixorig.DSC.L3,t213+1)
     .       2             = xyzf_qmixal(xyzf_qmixal.DSC.L1+t219-1,t217+        
     .       3            xyzf_qmixal.DSC.L2,t215+xyzf_qmixal.DSC.L3,t213+1)    
     .                 xyzf_qmixwork(xyzf_qmixwork.DSC.L1+t219-1,t217-1+        
     .       1            xyzf_qmixwork.DSC.L2,t215+xyzf_qmixwork.DSC.L3,t213+1)
     .       2             = xyzf_qmixal(xyzf_qmixal.DSC.L1+t219-1,t217-1+      
     .       3            xyzf_qmixal.DSC.L2,t215+xyzf_qmixal.DSC.L3,t213+1)    
     .                 xyzf_qmixwork(xyzf_qmixwork.DSC.L1+t219-1,t217+          
     .       1            xyzf_qmixwork.DSC.L2,t215+xyzf_qmixwork.DSC.L3,t213+1)
     .       2             = xyzf_qmixal(xyzf_qmixal.DSC.L1+t219-1,t217+        
     .       3            xyzf_qmixal.DSC.L2,t215+xyzf_qmixal.DSC.L3,t213+1)    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   121  
   122      ! ήˤäˤʤäʬ
   123      ! Negative values due to advection are corrected.
   124      !
   125      xyzf_QMixWork = xyzf_QMixAl
   126      xyzf_QMixAl   = xyza_FillNegative_xyza( xyzf_QMixWork )
   127  
   128      ! ڤʤäʬ򥼥ˤ.
   129      ! Negative values mixing ratios are corrected.
   130      !
   131      xyzf_QMixWork = xyzf_QMixAl
     .        if (xyzf_qmixwork.DSC.U2 + 1 - xyzf_qmixwork.DSC.L2 .gt. 0) then  
     .           J2 = and(xyzf_qmixwork.DSC.U2 + 1 - xyzf_qmixwork.DSC.L2,1)    
     .  !CDIR    NODEP                                                          
     .           do t241 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t243 = 1, xyzf_qmixwork.DSC.U1 + 1 - xyzf_qmixwork.DSC.L1
     .                 xyzf_qmixwork(xyzf_qmixwork.DSC.L1+t243-1,t241-1+        
     .       1            xyzf_qmixwork.DSC.L2,t239+xyzf_qmixwork.DSC.L3,t237+1)
     .       2             = xyzf_qmixal(t64+t243-1,t241-1+t66,t239+t68,t237+1) 
     .                 xyzf_qmixal(t64+t243-1,t241-1+t66,t239+t68,t237+1) = max(
     .       1            (-xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t243-1,t241-1+       
     .       2            xyzf_qmixbz.DSC.L2,t239+xyzf_qmixbz.DSC.L3,t237+      
     .       3            xyzf_qmixbz.DSC.L4)),xyzf_qmixwork(                   
     .       4            xyzf_qmixwork.DSC.L1+t243-1,t241-1+                   
     .       5            xyzf_qmixwork.DSC.L2,t239+xyzf_qmixwork.DSC.L3,t237+1)
     .       6            )                                                     
     .                 xyza_del(xyza_del.DSC.L1+t243-1,t241-1+xyza_del.DSC.L2,  
     .       1            t239+xyza_del.DSC.L3,t237+1) = xyzf_qmixal(t64+t243-1,
     .       2            t241-1+t66,t239+t68,t237+1) - xyzf_qmixorig(          
     .       3            xyzf_qmixorig.DSC.L1+t243-1,t241-1+                   
     .       4            xyzf_qmixorig.DSC.L2,t239+xyzf_qmixorig.DSC.L3,t237+1)
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t241 = J2 + 1, xyzf_qmixwork.DSC.U2 + 1 -                   
     .       1      xyzf_qmixwork.DSC.L2, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t243 = 1, xyzf_qmixwork.DSC.U1 + 1 - xyzf_qmixwork.DSC.L1
     .                 xyzf_qmixwork(xyzf_qmixwork.DSC.L1+t243-1,t241-1+        
     .       1            xyzf_qmixwork.DSC.L2,t239+xyzf_qmixwork.DSC.L3,t237+1)
     .       2             = xyzf_qmixal(t64+t243-1,t241-1+t66,t239+t68,t237+1) 
     .                 xyzf_qmixwork(xyzf_qmixwork.DSC.L1+t243-1,t241+          
     .       1            xyzf_qmixwork.DSC.L2,t239+xyzf_qmixwork.DSC.L3,t237+1)
     .       2             = xyzf_qmixal(t64+t243-1,t241+t66,t239+t68,t237+1)   
     .                 xyzf_qmixal(t64+t243-1,t241-1+t66,t239+t68,t237+1) = max(
     .       1            (-xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t243-1,t241-1+       
     .       2            xyzf_qmixbz.DSC.L2,t239+xyzf_qmixbz.DSC.L3,t237+      
     .       3            xyzf_qmixbz.DSC.L4)),xyzf_qmixwork(                   
     .       4            xyzf_qmixwork.DSC.L1+t243-1,t241-1+                   
     .       5            xyzf_qmixwork.DSC.L2,t239+xyzf_qmixwork.DSC.L3,t237+1)
     .       6            )                                                     
     .                 xyzf_qmixal(t64+t243-1,t241+t66,t239+t68,t237+1) = max((-
     .       1            xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t243-1,t241+           
     .       2            xyzf_qmixbz.DSC.L2,t239+xyzf_qmixbz.DSC.L3,t237+      
     .       3            xyzf_qmixbz.DSC.L4)),xyzf_qmixwork(                   
     .       4            xyzf_qmixwork.DSC.L1+t243-1,t241+xyzf_qmixwork.DSC.L2,
     .       5            t239+xyzf_qmixwork.DSC.L3,t237+1))                    
     .                 xyza_del(xyza_del.DSC.L1+t243-1,t241-1+xyza_del.DSC.L2,  
     .       1            t239+xyza_del.DSC.L3,t237+1) = xyzf_qmixal(t64+t243-1,
     .       2            t241-1+t66,t239+t68,t237+1) - xyzf_qmixorig(          
     .       3            xyzf_qmixorig.DSC.L1+t243-1,t241-1+                   
     .       4            xyzf_qmixorig.DSC.L2,t239+xyzf_qmixorig.DSC.L3,t237+1)
     .                 xyza_del(xyza_del.DSC.L1+t243-1,t241+xyza_del.DSC.L2,t239
     .       1            +xyza_del.DSC.L3,t237+1) = xyzf_qmixal(t64+t243-1,t241
     .       2            +t66,t239+t68,t237+1) - xyzf_qmixorig(                
     .       3            xyzf_qmixorig.DSC.L1+t243-1,t241+xyzf_qmixorig.DSC.L2,
     .       4            t239+xyzf_qmixorig.DSC.L3,t237+1)                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   132      xyzf_QMixAl = max( - xyzf_QMixBZ, xyzf_QMixWork )
   133  
   134      ! ᤿/ä̤ݴ
   135      ! Adjustion value is stored.
   136      !
   137      xyza_Del = xyzf_QMixAl - xyzf_QMixOrig
   138  
   139      ! Output
   140      do l = 1, ncmax
   141        call HistoryAutoPut(TimeN, trim(SpcWetSymbol(l))//'_Fill', xyza_Del(1:nx,1:ny,1:nz,l)/ DelTime)
     .        if (ny .gt. 0) then                                               
     .           J3 = and(ny,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t279 = 1, J3                                                
     .              D1 = 1.D0/deltime                                           
     .  !CDIR       NODEP                                                       
     .              do t281 = 1, nx                                             
     .                 %IG30(t281,t279,t277+1) = xyza_del(t281,t279,t277+1,l)*D1
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t279 = J3 + 1, ny, 4                                        
     .              D2 = 1.D0/deltime                                           
     .              D3 = 1.D0/deltime                                           
     .              D4 = 1.D0/deltime                                           
     .              D5 = 1.D0/deltime                                           
     .  !CDIR       NODEP                                                       
     .              do t281 = 1, nx                                             
     .                 %IG30(t281,t279,t277+1) = xyza_del(t281,t279,t277+1,l)*D2
     .                 %IG30(t281,t279+1,t277+1) = xyza_del(t281,t279+1,t277+1,l
     .       1            )*D3                                                  
     .                 %IG30(t281,t279+2,t277+1) = xyza_del(t281,t279+2,t277+1,l
     .       1            )*D4                                                  
     .                 %IG30(t281,t279+3,t277+1) = xyza_del(t281,t279+3,t277+1,l
     .       1            )*D5                                                  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   142      end do
   143  
   144    end subroutine FillNegativeQMix
   145  
   146  
   147    subroutine FillNegativeDensity(xyz_CDensAl)
   148  
   149      implicit none
   150  
   151      real(DP), intent(inout)  :: xyz_CDensAl(imin:imax, jmin:jmax, kmin:kmax)
   152      real(DP)                 :: xyz_CDensOrig(imin:imax, jmin:jmax, kmin:kmax)
   153      real(DP)                 :: xyz_CDensWork(imin:imax, jmin:jmax, kmin:kmax)
   154      real(DP)                 :: xyz_Del(imin:imax, jmin:jmax, kmin:kmax)
   155  
   156  
   157      ! ͤݴ Store Initial Value
   158      !
   159      xyz_CDensOrig = xyz_CDensAl
     .        if (xyz_cdensorig.DSC.U2 + 1 - xyz_cdensorig.DSC.L2 .gt. 0) then  
     .           J1 = and(xyz_cdensorig.DSC.U2 + 1 - xyz_cdensorig.DSC.L2,1)    
     .  !CDIR    NODEP                                                          
     .           do t139 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t141 = 1, xyz_cdensorig.DSC.U1 + 1 - xyz_cdensorig.DSC.L1
     .                 xyz_cdensorig(xyz_cdensorig.DSC.L1+t141-1,t139-1+        
     .       1            xyz_cdensorig.DSC.L2,t137+xyz_cdensorig.DSC.L3) =     
     .       2            xyz_cdensal(xyz_cdensal.DSC.L1+t141-1,t139-1+         
     .       3            xyz_cdensal.DSC.L2,t137+xyz_cdensal.DSC.L3)           
     .                 xyz_cdenswork(xyz_cdenswork.DSC.L1+t141-1,t139-1+        
     .       1            xyz_cdenswork.DSC.L2,t137+xyz_cdenswork.DSC.L3) =     
     .       2            xyz_cdensal(xyz_cdensal.DSC.L1+t141-1,t139-1+         
     .       3            xyz_cdensal.DSC.L2,t137+xyz_cdensal.DSC.L3)           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t139 = J1 + 1, xyz_cdensorig.DSC.U2 + 1 -                   
     .       1      xyz_cdensorig.DSC.L2, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t141 = 1, xyz_cdensorig.DSC.U1 + 1 - xyz_cdensorig.DSC.L1
     .                 xyz_cdensorig(xyz_cdensorig.DSC.L1+t141-1,t139-1+        
     .       1            xyz_cdensorig.DSC.L2,t137+xyz_cdensorig.DSC.L3) =     
     .       2            xyz_cdensal(xyz_cdensal.DSC.L1+t141-1,t139-1+         
     .       3            xyz_cdensal.DSC.L2,t137+xyz_cdensal.DSC.L3)           
     .                 xyz_cdensorig(xyz_cdensorig.DSC.L1+t141-1,t139+          
     .       1            xyz_cdensorig.DSC.L2,t137+xyz_cdensorig.DSC.L3) =     
     .       2            xyz_cdensal(xyz_cdensal.DSC.L1+t141-1,t139+           
     .       3            xyz_cdensal.DSC.L2,t137+xyz_cdensal.DSC.L3)           
     .                 xyz_cdenswork(xyz_cdenswork.DSC.L1+t141-1,t139-1+        
     .       1            xyz_cdenswork.DSC.L2,t137+xyz_cdenswork.DSC.L3) =     
     .       2            xyz_cdensal(xyz_cdensal.DSC.L1+t141-1,t139-1+         
     .       3            xyz_cdensal.DSC.L2,t137+xyz_cdensal.DSC.L3)           
     .                 xyz_cdenswork(xyz_cdenswork.DSC.L1+t141-1,t139+          
     .       1            xyz_cdenswork.DSC.L2,t137+xyz_cdenswork.DSC.L3) =     
     .       2            xyz_cdensal(xyz_cdensal.DSC.L1+t141-1,t139+           
     .       3            xyz_cdensal.DSC.L2,t137+xyz_cdensal.DSC.L3)           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   160  
   161      ! ήˤäˤʤäʬ
   162      ! Negative values due to advection are corrected.
   163      !
   164      xyz_CDensWork = xyz_CDensAl
   165      xyz_CDensAl   = xyz_FillNegativeDensity_xyz( xyz_CDensWork )
   166  
   167      ! ڤʤäʬ򥼥ˤ.
   168      ! Negative values mixing ratios are corrected.
   169      !
   170      xyz_CDensWork = xyz_CDensAl
     .        if (xyz_cdenswork.DSC.U2 + 1 - xyz_cdenswork.DSC.L2 .gt. 0) then  
     .           J2 = and(xyz_cdenswork.DSC.U2 + 1 - xyz_cdenswork.DSC.L2,1)    
     .  !CDIR    NODEP                                                          
     .           do t157 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t159 = 1, xyz_cdenswork.DSC.U1 + 1 - xyz_cdenswork.DSC.L1
     .                 xyz_cdenswork(xyz_cdenswork.DSC.L1+t159-1,t157-1+        
     .       1            xyz_cdenswork.DSC.L2,t155+xyz_cdenswork.DSC.L3) =     
     .       2            xyz_cdensal(t38+t159-1,t157-1+t40,t155+t42)           
     .                 xyz_cdensal(t38+t159-1,t157-1+t40,t155+t42) = max(       
     .       1            0.0000000000000000e+000,xyz_cdenswork(                
     .       2            xyz_cdenswork.DSC.L1+t159-1,t157-1+                   
     .       3            xyz_cdenswork.DSC.L2,t155+xyz_cdenswork.DSC.L3))      
     .                 xyz_del(xyz_del.DSC.L1+t159-1,t157-1+xyz_del.DSC.L2,t155+
     .       1            xyz_del.DSC.L3) = xyz_cdensal(t38+t159-1,t157-1+t40,  
     .       2            t155+t42) - xyz_cdensorig(xyz_cdensorig.DSC.L1+t159-1,
     .       3            t157-1+xyz_cdensorig.DSC.L2,t155+xyz_cdensorig.DSC.L3)
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t157 = J2 + 1, xyz_cdenswork.DSC.U2 + 1 -                   
     .       1      xyz_cdenswork.DSC.L2, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t159 = 1, xyz_cdenswork.DSC.U1 + 1 - xyz_cdenswork.DSC.L1
     .                 xyz_cdenswork(xyz_cdenswork.DSC.L1+t159-1,t157-1+        
     .       1            xyz_cdenswork.DSC.L2,t155+xyz_cdenswork.DSC.L3) =     
     .       2            xyz_cdensal(t38+t159-1,t157-1+t40,t155+t42)           
     .                 xyz_cdenswork(xyz_cdenswork.DSC.L1+t159-1,t157+          
     .       1            xyz_cdenswork.DSC.L2,t155+xyz_cdenswork.DSC.L3) =     
     .       2            xyz_cdensal(t38+t159-1,t157+t40,t155+t42)             
     .                 xyz_cdensal(t38+t159-1,t157-1+t40,t155+t42) = max(       
     .       1            0.0000000000000000e+000,xyz_cdenswork(                
     .       2            xyz_cdenswork.DSC.L1+t159-1,t157-1+                   
     .       3            xyz_cdenswork.DSC.L2,t155+xyz_cdenswork.DSC.L3))      
     .                 xyz_cdensal(t38+t159-1,t157+t40,t155+t42) = max(         
     .       1            0.0000000000000000e+000,xyz_cdenswork(                
     .       2            xyz_cdenswork.DSC.L1+t159-1,t157+xyz_cdenswork.DSC.L2,
     .       3            t155+xyz_cdenswork.DSC.L3))                           
     .                 xyz_del(xyz_del.DSC.L1+t159-1,t157-1+xyz_del.DSC.L2,t155+
     .       1            xyz_del.DSC.L3) = xyz_cdensal(t38+t159-1,t157-1+t40,  
     .       2            t155+t42) - xyz_cdensorig(xyz_cdensorig.DSC.L1+t159-1,
     .       3            t157-1+xyz_cdensorig.DSC.L2,t155+xyz_cdensorig.DSC.L3)
     .                 xyz_del(xyz_del.DSC.L1+t159-1,t157+xyz_del.DSC.L2,t155+  
     .       1            xyz_del.DSC.L3) = xyz_cdensal(t38+t159-1,t157+t40,t155
     .       2            +t42) - xyz_cdensorig(xyz_cdensorig.DSC.L1+t159-1,t157
     .       3            +xyz_cdensorig.DSC.L2,t155+xyz_cdensorig.DSC.L3)      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   171      xyz_CDensAl = max( 0.0d0, xyz_CDensWork )
   172  
   173      ! ᤿/ä̤ݴ
   174      ! Adjustion value is stored.
   175      !
   176      xyz_Del = xyz_CDensAl - xyz_CDensOrig
   177  
   178      ! Output
   179      call HistoryAutoPut(TimeN, 'CDensFill', xyz_Del(1:nx,1:ny,1:nz)/ DelTimeShort)
     .        if (ny .gt. 0) then                                               
     .           J3 = and(ny,3)                                                 
     .  !CDIR    NODEP                                                          
     .           do t184 = 1, J3                                                
     .              D1 = 1.D0/deltimeshort                                      
     .  !CDIR       NODEP                                                       
     .              do t186 = 1, nx                                             
     .                 %IG37(t186,t184,t182+1) = xyz_del(t186,t184,t182+1)*D1   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t184 = J3 + 1, ny, 4                                        
     .              D2 = 1.D0/deltimeshort                                      
     .              D3 = 1.D0/deltimeshort                                      
     .              D4 = 1.D0/deltimeshort                                      
     .              D5 = 1.D0/deltimeshort                                      
     .  !CDIR       NODEP                                                       
     .              do t186 = 1, nx                                             
     .                 %IG37(t186,t184,t182+1) = xyz_del(t186,t184,t182+1)*D2   
     .                 %IG37(t186,t184+1,t182+1) = xyz_del(t186,t184+1,t182+1)* 
     .       1            D3                                                    
     .                 %IG37(t186,t184+2,t182+1) = xyz_del(t186,t184+2,t182+1)* 
     .       1            D4                                                    
     .                 %IG37(t186,t184+3,t182+1) = xyz_del(t186,t184+3,t182+1)* 
     .       1            D5                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   180  
   181    end subroutine FillNegativeDensity
   182  
   183  
   184    function xyza_FillNegative_xyza( xyza_Var )
   185  
   186      implicit none
   187  
   188      real(DP), intent(in) :: xyza_Var(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   189      real(DP) :: xyza_FillNegative_xyza(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   190      real(DP) :: xyza_DQFILL(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   191      real(DP) :: xyza_QSUMPN(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   192      real(DP) :: xza_Var(imin:imax, kmin:kmax, ncmax)
   193      real(DP) :: xza_DQFILL(imin:imax, kmin:kmax, ncmax)
   194      real(DP) :: xza_QSUMPN(imin:imax, kmin:kmax, ncmax)
   195      real(DP), parameter     :: EPS = 1.0d-60  !Ǥγ껻ɤ
   196      integer                :: i, j, k, s
   197  
   198  
   199      if (jmin==jmax) then
   200  
   201        !
   202        xza_QSUMPN = 0.0d0
     .        if (xza_qsumpn.DSC.U2 + 1 - xza_qsumpn.DSC.L2 .gt. 0) then        
     .           J1 = and(xza_qsumpn.DSC.U2 + 1 - xza_qsumpn.DSC.L2,1)          
     .  !CDIR    NODEP                                                          
     .           do t1557 = 1, J1                                               
     .  !CDIR       NODEP                                                       
     .              do t1559 = 1, xza_qsumpn.DSC.U1 + 1 - xza_qsumpn.DSC.L1     
     .                 xza_qsumpn(xza_qsumpn.DSC.L1+t1559-1,t1557-1+            
     .       1            xza_qsumpn.DSC.L2,t1555+1) = 0.0000000000000000e+000  
     .                 xza_dqfill(xza_dqfill.DSC.L1+t1559-1,t1557-1+            
     .       1            xza_dqfill.DSC.L2,t1555+1) = 0.0000000000000000e+000  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1557 = J1 + 1, xza_qsumpn.DSC.U2 + 1 - xza_qsumpn.DSC.L2, 2
     .  !CDIR       NODEP                                                       
     .              do t1559 = 1, xza_qsumpn.DSC.U1 + 1 - xza_qsumpn.DSC.L1     
     .                 xza_qsumpn(xza_qsumpn.DSC.L1+t1559-1,t1557-1+            
     .       1            xza_qsumpn.DSC.L2,t1555+1) = 0.0000000000000000e+000  
     .                 xza_qsumpn(xza_qsumpn.DSC.L1+t1559-1,t1557+              
     .       1            xza_qsumpn.DSC.L2,t1555+1) = 0.0000000000000000e+000  
     .                 xza_dqfill(xza_dqfill.DSC.L1+t1559-1,t1557-1+            
     .       1            xza_dqfill.DSC.L2,t1555+1) = 0.0000000000000000e+000  
     .                 xza_dqfill(xza_dqfill.DSC.L1+t1559-1,t1557+              
     .       1            xza_dqfill.DSC.L2,t1555+1) = 0.0000000000000000e+000  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   203        xza_DQFILL = 0.0d0
   204        xza_Var(:,:,:) = xyza_Var(:,1,:,:)
     .        if (xza_var.DSC.U2 + 1 - xza_var.DSC.L2 .gt. 0) then              
     .           J2 = and(xza_var.DSC.U2 + 1 - xza_var.DSC.L2,3)                
     .  !CDIR    NODEP                                                          
     .           do t1569 = 1, J2                                               
     .  !CDIR       NODEP                                                       
     .              do t1571 = 1, xza_var.DSC.U1 + 1 - xza_var.DSC.L1           
     .                 xza_var(xza_var.DSC.L1+t1571-1,t1569-1+xza_var.DSC.L2,   
     .       1            t1567+1) = xyza_var(t109+t1571-1,1,t1569-1+t113,t1567+
     .       2            1)                                                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1569 = J2 + 1, xza_var.DSC.U2 + 1 - xza_var.DSC.L2, 4      
     .  !CDIR       NODEP                                                       
     .              do t1571 = 1, xza_var.DSC.U1 + 1 - xza_var.DSC.L1           
     .                 xza_var(xza_var.DSC.L1+t1571-1,t1569-1+xza_var.DSC.L2,   
     .       1            t1567+1) = xyza_var(t109+t1571-1,1,t1569-1+t113,t1567+
     .       2            1)                                                    
     .                 xza_var(xza_var.DSC.L1+t1571-1,t1569+xza_var.DSC.L2,t1567
     .       1            +1) = xyza_var(t109+t1571-1,1,t1569+t113,t1567+1)     
     .                 xza_var(xza_var.DSC.L1+t1571-1,t1569+1+xza_var.DSC.L2,   
     .       1            t1567+1) = xyza_var(t109+t1571-1,1,t1569+1+t113,t1567+
     .       2            1)                                                    
     .                 xza_var(xza_var.DSC.L1+t1571-1,t1569+2+xza_var.DSC.L2,   
     .       1            t1567+1) = xyza_var(t109+t1571-1,1,t1569+2+t113,t1567+
     .       2            1)                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   205  
   206        do s = 1, ncmax
   207          do k = kmin+2, kmax-2
   208            do i = imin+2, imax-2
   209              xza_QSUMPN(i,k,s) = 1.0d0 /                                     &
   210                & ( (    MAX( 0.0d0, xza_Basic(i-1,k,s) + xza_Var(i-1,k,s) )  &
   211                &         * xz_Dens(i-1,k)                                    &
   212                &      + MAX( 0.0d0, xza_Basic(i+1,k,s) + xza_Var(i+1,k,s) )  &
   213                &         * xz_Dens(i+1,k)                                    &
   214                &      + MAX( 0.0d0, xza_Basic(i,k-1,s) + xza_Var(i,k-1,s) )  &
   215                &         * xz_Dens(i,k-1)                                    &
   216                &      + MAX( 0.0d0, xza_Basic(i,k+1,s) + xza_Var(i,k+1,s) )  &
   217                &         * xz_Dens(i,k+1)                                    &
   218                &     ) * 0.75d0                                              &
   219                &  + (   MAX( 0.0d0, xza_Basic(i-2,k,s) + xza_Var(i-2,k,s) )  &
   220                &         * xz_Dens(i-2,k)                                    &
   221                &      + MAX( 0.0d0, xza_Basic(i+2,k,s) + xza_Var(i+2,k,s) )  &
   222                &         * xz_Dens(i+2,k)                                    &
   223                &      + MAX( 0.0d0, xza_Basic(i,k-2,s) + xza_Var(i,k-2,s) )  &
   224                &         * xz_Dens(i,k-2)                                    &
   225                &      + MAX( 0.0d0, xza_Basic(i,k+2,s) + xza_Var(i,k+2,s) )  &
   226                &         * xz_Dens(i,k+2)                                    &
   227                &     ) * 0.25d0                                              &
   228                &  + EPS )
   229            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xza_qsumpn(imin+1+i,k,s) = 1.00000000000000e+000/((max(        
     .       1      0.0000000000000000e+000,xza_basic(imin+i,k,s)+xza_var(imin+i
     .       2      ,k,s))*xz_dens(imin+i,k)+max(0.0000000000000000e+000,       
     .       3      xza_basic(imin+2+i,k,s)+xza_var(imin+2+i,k,s))*xz_dens(imin+
     .       4      2+i,k)+max(0.0000000000000000e+000,xza_basic(imin+1+i,k-1,s)
     .       5      +xza_var(imin+1+i,k-1,s))*xz_dens(imin+1+i,k-1)+max(        
     .       6      0.0000000000000000e+000,xza_basic(imin+1+i,k+1,s)+xza_var(  
     .       7      imin+1+i,k+1,s))*xz_dens(imin+1+i,k+1))*                    
     .       8      7.50000000000000e-001+(max(0.0000000000000000e+000,xza_basic
     .       9      (imin+i-1,k,s)+xza_var(imin+i-1,k,s))*xz_dens(imin+i-1,k)+  
     .       .      max(0.0000000000000000e+000,xza_basic(imin+3+i,k,s)+xza_var(
     .       1      imin+3+i,k,s))*xz_dens(imin+3+i,k)+max(                     
     .       2      0.0000000000000000e+000,xza_basic(imin+1+i,k-2,s)+xza_var(  
     .       3      imin+1+i,k-2,s))*xz_dens(imin+1+i,k-2)+max(                 
     .       4      0.0000000000000000e+000,xza_basic(imin+1+i,k+2,s)+xza_var(  
     .       5      imin+1+i,k+2,s))*xz_dens(imin+1+i,k+2))*                    
     .       6      2.50000000000000e-001+9.99999999999999e-061)                
     .        end do                                                            
   230          end do
   231        end do
   232  
   233        do s = 1, ncmax
   234          do k = kmin+2, kmax-2
   235            do i = imin+2, imax-2
   236              xza_DQFILL(i,k,s) =                                               &
   237                &  - MIN( 0.0d0, xza_Basic(i,k,s) + xza_Var(i,k,s) )            &
   238                &  + MAX( 0.0d0, xza_Basic(i,k,s) + xza_Var(i,k,s) )            &
   239                &    * ( ( MIN( 0.0d0, xza_Basic(i-1,k,s) + xza_Var(i-1,k,s) )  &
   240                &           * xza_QSUMPN(i-1,k,s)                               &
   241                &           * xz_Dens(i-1,k)                                    &
   242                &        + MIN( 0.0d0, xza_Basic(i+1,k,s) + xza_Var(i+1,k,s) )  &
   243                &           * xza_QSUMPN(i+1,k,s)                               &
   244                &           * xz_Dens(i+1,k)                                    &
   245                &        + MIN( 0.0d0, xza_Basic(i,k-1,s) + xza_Var(i,k-1,s) )  &
   246                &           * xza_QSUMPN(i,k-1,s)                               &
   247                &           * xz_Dens(i,k-1)                                    &
   248                &        + MIN( 0.0d0, xza_Basic(i,k+1,s) + xza_Var(i,k+1,s) )  &
   249                &           * xza_QSUMPN(i,k+1,s)                               &
   250                &           * xz_Dens(i,k+1)                                    &
   251                &       ) * 0.75d0                                              &
   252                &      + ( MIN( 0.0d0, xza_Basic(i-2,k,s) + xza_Var(i-2,k,s) )  &
   253                &           * xza_QSUMPN(i-2,k,s)                               &
   254                &           * xz_Dens(i-2,k)                                    &
   255                &        + MIN( 0.0d0, xza_Basic(i+2,k,s) + xza_Var(i+2,k,s) )  &
   256                &           * xza_QSUMPN(i+2,k,s)                               &
   257                &           * xz_Dens(i+2,k)                                    &
   258                &        + MIN( 0.0d0, xza_Basic(i,k-2,s) + xza_Var(i,k-2,s) )  &
   259                &           * xza_QSUMPN(i,k-2,s)                               &
   260                &           * xz_Dens(i,k-2)                                    &
   261                &        + MIN( 0.0d0, xza_Basic(i,k+2,s) + xza_Var(i,k+2,s) )  &
   262                &           * xza_QSUMPN(i,k+2,s)                               &
   263                &           * xz_Dens(i,k+2)                                    &
   264                &       ) * 0.25d0                                              &
   265                &     )
   266            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xza_dqfill(imin+1+i,k,s) = max(0.0000000000000000e+000,        
     .       1      xza_basic(imin+1+i,k,s)+xza_var(imin+1+i,k,s))*((min(       
     .       2      0.0000000000000000e+000,xza_basic(imin+i,k,s)+xza_var(imin+i
     .       3      ,k,s))*xza_qsumpn(imin+i,k,s)*xz_dens(imin+i,k)+min(        
     .       4      0.0000000000000000e+000,xza_basic(imin+2+i,k,s)+xza_var(imin
     .       5      +2+i,k,s))*xza_qsumpn(imin+2+i,k,s)*xz_dens(imin+2+i,k)+min(
     .       6      0.0000000000000000e+000,xza_basic(imin+1+i,k-1,s)+xza_var(  
     .       7      imin+1+i,k-1,s))*xza_qsumpn(imin+1+i,k-1,s)*xz_dens(imin+1+i
     .       8      ,k-1)+min(0.0000000000000000e+000,xza_basic(imin+1+i,k+1,s)+
     .       9      xza_var(imin+1+i,k+1,s))*xza_qsumpn(imin+1+i,k+1,s)*xz_dens(
     .       .      imin+1+i,k+1))*7.50000000000000e-001+(min(                  
     .       1      0.0000000000000000e+000,xza_basic(imin+i-1,k,s)+xza_var(imin
     .       2      +i-1,k,s))*xza_qsumpn(imin+i-1,k,s)*xz_dens(imin+i-1,k)+min(
     .       3      0.0000000000000000e+000,xza_basic(imin+3+i,k,s)+xza_var(imin
     .       4      +3+i,k,s))*xza_qsumpn(imin+3+i,k,s)*xz_dens(imin+3+i,k)+min(
     .       5      0.0000000000000000e+000,xza_basic(imin+1+i,k-2,s)+xza_var(  
     .       6      imin+1+i,k-2,s))*xza_qsumpn(imin+1+i,k-2,s)*xz_dens(imin+1+i
     .       7      ,k-2)+min(0.0000000000000000e+000,xza_basic(imin+1+i,k+2,s)+
     .       8      xza_var(imin+1+i,k+2,s))*xza_qsumpn(imin+1+i,k+2,s)*xz_dens(
     .       9      imin+1+i,k+2))*2.50000000000000e-001) - min(                
     .       9      0.0000000000000000e+000,xza_basic(imin+1+i,k,s)+xza_var(imin
     .       9      +1+i,k,s))                                                  
     .        end do                                                            
   267          end do
   268        end do
   269  
   270        !
   271        xyza_FillNegative_xyza(:,1,:,:) = xza_Var + xza_DQFILL
     .        if (xza_var.DSC.U2 - xza_var.DSC.L2 + 2 - min0(1,xza_var.DSC.U2 - 
     .       1   xza_var.DSC.L2 + 1) .gt. 0) then                               
     .           J3 = and(xza_var.DSC.U2 - xza_var.DSC.L2 + 2 - min0(1,         
     .       1      xza_var.DSC.U2 - xza_var.DSC.L2 + 1),3)                     
     .  !CDIR    NODEP                                                          
     .           do t1581 = 1, J3                                               
     .  !CDIR       NODEP                                                       
     .              do t1583 = 1, xza_var.DSC.U1 - xza_var.DSC.L1 + 2 - min0(1, 
     .       1         xza_var.DSC.U1 - xza_var.DSC.L1 + 1)                     
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1583-1,
     .       2            1,t1581-1+                                            
     .       3            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,t1579+1)
     .       4             = xza_var(xza_var.DSC.L1+t1583-1,t1581-1+            
     .       5            xza_var.DSC.L2,t1579+1) + xza_dqfill(xza_dqfill.DSC.L1
     .       6            +t1583-1,t1581-1+xza_dqfill.DSC.L2,t1579+1)           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1581 = J3 + 1, xza_var.DSC.U2 - xza_var.DSC.L2 + 2 - min0(1
     .       1      ,xza_var.DSC.U2 - xza_var.DSC.L2 + 1), 4                    
     .  !CDIR       NODEP                                                       
     .              do t1583 = 1, xza_var.DSC.U1 - xza_var.DSC.L1 + 2 - min0(1, 
     .       1         xza_var.DSC.U1 - xza_var.DSC.L1 + 1)                     
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1583-1,
     .       2            1,t1581-1+                                            
     .       3            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,t1579+1)
     .       4             = xza_var(xza_var.DSC.L1+t1583-1,t1581-1+            
     .       5            xza_var.DSC.L2,t1579+1) + xza_dqfill(xza_dqfill.DSC.L1
     .       6            +t1583-1,t1581-1+xza_dqfill.DSC.L2,t1579+1)           
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1583-1,
     .       2            1,t1581+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,
     .       3            t1579+1) = xza_var(xza_var.DSC.L1+t1583-1,t1581+      
     .       4            xza_var.DSC.L2,t1579+1) + xza_dqfill(xza_dqfill.DSC.L1
     .       5            +t1583-1,t1581+xza_dqfill.DSC.L2,t1579+1)             
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1583-1,
     .       2            1,t1581+1+                                            
     .       3            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,t1579+1)
     .       4             = xza_var(xza_var.DSC.L1+t1583-1,t1581+1+            
     .       5            xza_var.DSC.L2,t1579+1) + xza_dqfill(xza_dqfill.DSC.L1
     .       6            +t1583-1,t1581+1+xza_dqfill.DSC.L2,t1579+1)           
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1583-1,
     .       2            1,t1581+2+                                            
     .       3            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,t1579+1)
     .       4             = xza_var(xza_var.DSC.L1+t1583-1,t1581+2+            
     .       5            xza_var.DSC.L2,t1579+1) + xza_dqfill(xza_dqfill.DSC.L1
     .       6            +t1583-1,t1581+2+xza_dqfill.DSC.L2,t1579+1)           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   272  
   273      else
   274  
   275        !
   276        xyza_QSUMPN = 0.0d0
     .        if (xyza_qsumpn.DSC.U2 + 1 - xyza_qsumpn.DSC.L2 .gt. 0) then      
     .           J4 = and(xyza_qsumpn.DSC.U2 + 1 - xyza_qsumpn.DSC.L2,1)        
     .  !CDIR    NODEP                                                          
     .           do t1523 = 1, J4                                               
     .  !CDIR       NODEP                                                       
     .              do t1525 = 1, xyza_qsumpn.DSC.U1 + 1 - xyza_qsumpn.DSC.L1   
     .                 xyza_qsumpn(xyza_qsumpn.DSC.L1+t1525-1,t1523-1+          
     .       1            xyza_qsumpn.DSC.L2,t1521+xyza_qsumpn.DSC.L3,t1519+1)  
     .       2             = 0.0000000000000000e+000                            
     .                 xyza_dqfill(xyza_dqfill.DSC.L1+t1525-1,t1523-1+          
     .       1            xyza_dqfill.DSC.L2,t1521+xyza_dqfill.DSC.L3,t1519+1)  
     .       2             = 0.0000000000000000e+000                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1523=J4+1,xyza_qsumpn.DSC.U2+1-xyza_qsumpn.DSC.L2,2        
     .  !CDIR       NODEP                                                       
     .              do t1525 = 1, xyza_qsumpn.DSC.U1 + 1 - xyza_qsumpn.DSC.L1   
     .                 xyza_qsumpn(xyza_qsumpn.DSC.L1+t1525-1,t1523-1+          
     .       1            xyza_qsumpn.DSC.L2,t1521+xyza_qsumpn.DSC.L3,t1519+1)  
     .       2             = 0.0000000000000000e+000                            
     .                 xyza_qsumpn(xyza_qsumpn.DSC.L1+t1525-1,t1523+            
     .       1            xyza_qsumpn.DSC.L2,t1521+xyza_qsumpn.DSC.L3,t1519+1)  
     .       2             = 0.0000000000000000e+000                            
     .                 xyza_dqfill(xyza_dqfill.DSC.L1+t1525-1,t1523-1+          
     .       1            xyza_dqfill.DSC.L2,t1521+xyza_dqfill.DSC.L3,t1519+1)  
     .       2             = 0.0000000000000000e+000                            
     .                 xyza_dqfill(xyza_dqfill.DSC.L1+t1525-1,t1523+            
     .       1            xyza_dqfill.DSC.L2,t1521+xyza_dqfill.DSC.L3,t1519+1)  
     .       2             = 0.0000000000000000e+000                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   277        xyza_DQFILL = 0.0d0
   278  
   279        do s = 1, ncmax
   280          do k = kmin+2, kmax-2
   281            do j = jmin+2, jmax-2
   282              do i = imin+2, imax-2
   283                xyza_QSUMPN(i,j,k,s) = 1.0d0 /                                       &
   284                  & ( (    MAX( 0.0d0, xyza_Basic(i-1,j,k,s) + xyza_Var(i-1,j,k,s) ) &
   285                  &         * xyz_Dens(i-1,j,k)                                      &
   286                  &      + MAX( 0.0d0, xyza_Basic(i+1,j,k,s) + xyza_Var(i+1,j,k,s) ) &
   287                  &         * xyz_Dens(i+1,j,k)                                      &
   288                  &      + MAX( 0.0d0, xyza_Basic(i,j-1,k,s) + xyza_Var(i,j-1,k,s) ) &
   289                  &         * xyz_Dens(i,j-1,k)                                      &
   290                  &      + MAX( 0.0d0, xyza_Basic(i,j+1,k,s) + xyza_Var(i,j+1,k,s) ) &
   291                  &         * xyz_Dens(i,j+1,k)                                      &
   292                  &      + MAX( 0.0d0, xyza_Basic(i,j,k-1,s) + xyza_Var(i,j,k-1,s) ) &
   293                  &         * xyz_Dens(i,j,k-1)                                      &
   294                  &      + MAX( 0.0d0, xyza_Basic(i,j,k+1,s) + xyza_Var(i,j,k+1,s) ) &
   295                  &         * xyz_Dens(i,j,k+1)                                      &
   296                  &     ) * 0.75d0                                                   &
   297                  &  + (   MAX( 0.0d0, xyza_Basic(i-2,j,k,s) + xyza_Var(i-2,j,k,s) ) &
   298                  &         * xyz_Dens(i-2,j,k)                                      &
   299                  &      + MAX( 0.0d0, xyza_Basic(i+2,j,k,s) + xyza_Var(i+2,j,k,s) ) &
   300                  &         * xyz_Dens(i+2,j,k)                                      &
   301                  &      + MAX( 0.0d0, xyza_Basic(i,j-2,k,s) + xyza_Var(i,j-2,k,s) ) &
   302                  &         * xyz_Dens(i,j-2,k)                                      &
   303                  &      + MAX( 0.0d0, xyza_Basic(i,j+2,k,s) + xyza_Var(i,j+2,k,s) ) &
   304                  &         * xyz_Dens(i,j+2,k)                                      &
   305                  &      + MAX( 0.0d0, xyza_Basic(i,j,k-2,s) + xyza_Var(i,j,k-2,s) ) &
   306                  &         * xyz_Dens(i,j,k-2)                                      &
   307                  &      + MAX( 0.0d0, xyza_Basic(i,j,k+2,s) + xyza_Var(i,j,k+2,s) ) &
   308                  &         * xyz_Dens(i,j,k+2)                                      &
   309                  &     ) * 0.25d0                                              &
   310                  &  + EPS )
   311              end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xyza_qsumpn(imin+1+i,j,k,s) = 1.00000000000000e+000/((max(     
     .       1      0.0000000000000000e+000,xyza_basic(imin+i,j,k,s)+xyza_var(  
     .       2      imin+i,j,k,s))*xyz_dens(imin+i,j,k)+max(                    
     .       3      0.0000000000000000e+000,xyza_basic(imin+2+i,j,k,s)+xyza_var(
     .       4      imin+2+i,j,k,s))*xyz_dens(imin+2+i,j,k)+max(                
     .       5      0.0000000000000000e+000,xyza_basic(imin+1+i,j-1,k,s)+       
     .       6      xyza_var(imin+1+i,j-1,k,s))*xyz_dens(imin+1+i,j-1,k)+max(   
     .       7      0.0000000000000000e+000,xyza_basic(imin+1+i,j+1,k,s)+       
     .       8      xyza_var(imin+1+i,j+1,k,s))*xyz_dens(imin+1+i,j+1,k)+max(   
     .       9      0.0000000000000000e+000,xyza_basic(imin+1+i,j,k-1,s)+       
     .       .      xyza_var(imin+1+i,j,k-1,s))*xyz_dens(imin+1+i,j,k-1)+max(   
     .       1      0.0000000000000000e+000,xyza_basic(imin+1+i,j,k+1,s)+       
     .       2      xyza_var(imin+1+i,j,k+1,s))*xyz_dens(imin+1+i,j,k+1))*      
     .       3      7.50000000000000e-001+(max(0.0000000000000000e+000,         
     .       4      xyza_basic(imin+i-1,j,k,s)+xyza_var(imin+i-1,j,k,s))*       
     .       5      xyz_dens(imin+i-1,j,k)+max(0.0000000000000000e+000,         
     .       6      xyza_basic(imin+3+i,j,k,s)+xyza_var(imin+3+i,j,k,s))*       
     .       7      xyz_dens(imin+3+i,j,k)+max(0.0000000000000000e+000,         
     .       8      xyza_basic(imin+1+i,j-2,k,s)+xyza_var(imin+1+i,j-2,k,s))*   
     .       9      xyz_dens(imin+1+i,j-2,k)+max(0.0000000000000000e+000,       
     .       9      xyza_basic(imin+1+i,j+2,k,s)+xyza_var(imin+1+i,j+2,k,s))*   
     .       9      xyz_dens(imin+1+i,j+2,k)+max(0.0000000000000000e+000,       
     .       9      xyza_basic(imin+1+i,j,k-2,s)+xyza_var(imin+1+i,j,k-2,s))*   
     .       9      xyz_dens(imin+1+i,j,k-2)+max(0.0000000000000000e+000,       
     .       9      xyza_basic(imin+1+i,j,k+2,s)+xyza_var(imin+1+i,j,k+2,s))*   
     .       9      xyz_dens(imin+1+i,j,k+2))*2.50000000000000e-001+            
     .       9      9.99999999999999e-061)                                      
     .        end do                                                            
   312            end do
   313          end do
   314        end do
   315  
   316        do s = 1, ncmax
   317          do k = kmin+2, kmax-2
   318            do j = jmin+2, jmax-2
   319              do i = imin+2, imax-2
   320                xyza_DQFILL(i,j,k,s) =                                              &
   321                  &  - MIN( 0.0d0, xyza_Basic(i,j,k,s) + xyza_Var(i,j,k,s) )        &
   322                  &  + MAX( 0.0d0, xyza_Basic(i,j,k,s) + xyza_Var(i,j,k,s) )        &
   323                  &    * ( ( MIN( 0.0d0, xyza_Basic(i-1,j,k,s) + xyza_Var(i-1,j,k,s) ) &
   324                  &           * xyza_QSUMPN(i-1,j,k,s)                               &
   325                  &           * xyz_Dens(i-1,j,k)                                    &
   326                  &        + MIN( 0.0d0, xyza_Basic(i+1,j,k,s) + xyza_Var(i+1,j,k,s) ) &
   327                  &           * xyza_QSUMPN(i+1,j,k,s)                               &
   328                  &           * xyz_Dens(i+1,j,k)                                    &
   329                  &        + MIN( 0.0d0, xyza_Basic(i,j-1,k,s) + xyza_Var(i,j-1,k,s) ) &
   330                  &           * xyza_QSUMPN(i,j-1,k,s)                               &
   331                  &           * xyz_Dens(i,j-1,k)                                    &
   332                  &        + MIN( 0.0d0, xyza_Basic(i,j+1,k,s) + xyza_Var(i,j+1,k,s) ) &
   333                  &           * xyza_QSUMPN(i,j+1,k,s)                               &
   334                  &           * xyz_Dens(i,j+1,k)                                    &
   335                  &        + MIN( 0.0d0, xyza_Basic(i,j,k-1,s) + xyza_Var(i,j,k-1,s) ) &
   336                  &           * xyza_QSUMPN(i,j,k-1,s)                               &
   337                  &           * xyz_Dens(i,j,k-1)                                    &
   338                  &        + MIN( 0.0d0, xyza_Basic(i,j,k+1,s) + xyza_Var(i,j,k+1,s) ) &
   339                  &           * xyza_QSUMPN(i,j,k+1,s)                               &
   340                  &           * xyz_Dens(i,j,k+1)                                    &
   341                  &       ) * 0.75d0                                                 &
   342                  &      + ( MIN( 0.0d0, xyza_Basic(i-2,j,k,s) + xyza_Var(i-2,j,k,s) ) &
   343                  &           * xyza_QSUMPN(i-2,j,k,s)                               &
   344                  &           * xyz_Dens(i-2,j,k)                                    &
   345                  &        + MIN( 0.0d0, xyza_Basic(i+2,j,k,s) + xyza_Var(i+2,j,k,s) ) &
   346                  &           * xyza_QSUMPN(i+2,j,k,s)                               &
   347                  &           * xyz_Dens(i+2,j,k)                                    &
   348                  &        + MIN( 0.0d0, xyza_Basic(i,j-2,k,s) + xyza_Var(i,j-2,k,s) ) &
   349                  &           * xyza_QSUMPN(i,j-2,k,s)                               &
   350                  &           * xyz_Dens(i,j-2,k)                                    &
   351                  &        + MIN( 0.0d0, xyza_Basic(i,j+2,k,s) + xyza_Var(i,j+2,k,s) ) &
   352                  &           * xyza_QSUMPN(i,j+2,k,s)                               &
   353                  &           * xyz_Dens(i,j+2,k)                                    &
   354                  &        + MIN( 0.0d0, xyza_Basic(i,j,k-2,s) + xyza_Var(i,j,k-2,s) ) &
   355                  &           * xyza_QSUMPN(i,j,k-2,s)                               &
   356                  &           * xyz_Dens(i,j,k-2)                                    &
   357                  &        + MIN( 0.0d0, xyza_Basic(i,j,k+2,s) + xyza_Var(i,j,k+2,s) ) &
   358                  &           * xyza_QSUMPN(i,j,k+2,s)                                &
   359                  &           * xyz_Dens(i,j,k+2)                                    &
   360                  &       ) * 0.25d0                                                 &
   361                  &     )
   362              end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xyza_dqfill(imin+1+i,j,k,s) = max(0.0000000000000000e+000,     
     .       1      xyza_basic(imin+1+i,j,k,s)+xyza_var(imin+1+i,j,k,s))*((min( 
     .       2      0.0000000000000000e+000,xyza_basic(imin+i,j,k,s)+xyza_var(  
     .       3      imin+i,j,k,s))*xyza_qsumpn(imin+i,j,k,s)*xyz_dens(imin+i,j,k
     .       4      )+min(0.0000000000000000e+000,xyza_basic(imin+2+i,j,k,s)+   
     .       5      xyza_var(imin+2+i,j,k,s))*xyza_qsumpn(imin+2+i,j,k,s)*      
     .       6      xyz_dens(imin+2+i,j,k)+min(0.0000000000000000e+000,         
     .       7      xyza_basic(imin+1+i,j-1,k,s)+xyza_var(imin+1+i,j-1,k,s))*   
     .       8      xyza_qsumpn(imin+1+i,j-1,k,s)*xyz_dens(imin+1+i,j-1,k)+min( 
     .       9      0.0000000000000000e+000,xyza_basic(imin+1+i,j+1,k,s)+       
     .       .      xyza_var(imin+1+i,j+1,k,s))*xyza_qsumpn(imin+1+i,j+1,k,s)*  
     .       1      xyz_dens(imin+1+i,j+1,k)+min(0.0000000000000000e+000,       
     .       2      xyza_basic(imin+1+i,j,k-1,s)+xyza_var(imin+1+i,j,k-1,s))*   
     .       3      xyza_qsumpn(imin+1+i,j,k-1,s)*xyz_dens(imin+1+i,j,k-1)+min( 
     .       4      0.0000000000000000e+000,xyza_basic(imin+1+i,j,k+1,s)+       
     .       5      xyza_var(imin+1+i,j,k+1,s))*xyza_qsumpn(imin+1+i,j,k+1,s)*  
     .       6      xyz_dens(imin+1+i,j,k+1))*7.50000000000000e-001+(min(       
     .       7      0.0000000000000000e+000,xyza_basic(imin+i-1,j,k,s)+xyza_var(
     .       8      imin+i-1,j,k,s))*xyza_qsumpn(imin+i-1,j,k,s)*xyz_dens(imin+i
     .       9      -1,j,k)+min(0.0000000000000000e+000,xyza_basic(imin+3+i,j,k,
     .       9      s)+xyza_var(imin+3+i,j,k,s))*xyza_qsumpn(imin+3+i,j,k,s)*   
     .       9      xyz_dens(imin+3+i,j,k)+min(0.0000000000000000e+000,         
     .       9      xyza_basic(imin+1+i,j-2,k,s)+xyza_var(imin+1+i,j-2,k,s))*   
     .       9      xyza_qsumpn(imin+1+i,j-2,k,s)*xyz_dens(imin+1+i,j-2,k)+min( 
     .       9      0.0000000000000000e+000,xyza_basic(imin+1+i,j+2,k,s)+       
     .       9      xyza_var(imin+1+i,j+2,k,s))*xyza_qsumpn(imin+1+i,j+2,k,s)*  
     .       9      xyz_dens(imin+1+i,j+2,k)+min(0.0000000000000000e+000,       
     .       9      xyza_basic(imin+1+i,j,k-2,s)+xyza_var(imin+1+i,j,k-2,s))*   
     .       9      xyza_qsumpn(imin+1+i,j,k-2,s)*xyz_dens(imin+1+i,j,k-2)+min( 
     .       9      0.0000000000000000e+000,xyza_basic(imin+1+i,j,k+2,s)+       
     .       9      xyza_var(imin+1+i,j,k+2,s))*xyza_qsumpn(imin+1+i,j,k+2,s)*  
     .       9      xyz_dens(imin+1+i,j,k+2))*2.50000000000000e-001) - min(     
     .       9      0.0000000000000000e+000,xyza_basic(imin+1+i,j,k,s)+xyza_var(
     .       9      imin+1+i,j,k,s))                                            
     .        end do                                                            
   363            end do
   364          end do
   365        end do
   366  
   367        !
   368        xyza_FillNegative_xyza = xyza_Var + xyza_DQFILL
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J5 = and(jmax + 1 - jmin,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t1539 = 1, J5                                               
     .  !CDIR       NODEP                                                       
     .              do t1541 = 1, imax + 1 - imin                               
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1541-1,
     .       2            t1539-1+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L2,
     .       3            t1537+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,  
     .       4            t1535+1) = xyza_var(t109+t1541-1,t1539-1+t111,t1537+  
     .       5            t113,t1535+1) + xyza_dqfill(xyza_dqfill.DSC.L1+t1541-1
     .       6            ,t1539-1+xyza_dqfill.DSC.L2,t1537+xyza_dqfill.DSC.L3, 
     .       7            t1535+1)                                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1539 = J5 + 1, jmax + 1 - jmin, 4                          
     .  !CDIR       NODEP                                                       
     .              do t1541 = 1, imax + 1 - imin                               
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1541-1,
     .       2            t1539-1+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L2,
     .       3            t1537+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,  
     .       4            t1535+1) = xyza_var(t109+t1541-1,t1539-1+t111,t1537+  
     .       5            t113,t1535+1) + xyza_dqfill(xyza_dqfill.DSC.L1+t1541-1
     .       6            ,t1539-1+xyza_dqfill.DSC.L2,t1537+xyza_dqfill.DSC.L3, 
     .       7            t1535+1)                                              
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1541-1,
     .       2            t1539+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L2,  
     .       3            t1537+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,  
     .       4            t1535+1) = xyza_var(t109+t1541-1,t1539+t111,t1537+t113
     .       5            ,t1535+1) + xyza_dqfill(xyza_dqfill.DSC.L1+t1541-1,   
     .       6            t1539+xyza_dqfill.DSC.L2,t1537+xyza_dqfill.DSC.L3,    
     .       7            t1535+1)                                              
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1541-1,
     .       2            t1539+1+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L2,
     .       3            t1537+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,  
     .       4            t1535+1) = xyza_var(t109+t1541-1,t1539+1+t111,t1537+  
     .       5            t113,t1535+1) + xyza_dqfill(xyza_dqfill.DSC.L1+t1541-1
     .       6            ,t1539+1+xyza_dqfill.DSC.L2,t1537+xyza_dqfill.DSC.L3, 
     .       7            t1535+1)                                              
     .                 xyza_fillnegative_xyza(                                  
     .       1            xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L1+t1541-1,
     .       2            t1539+2+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L2,
     .       3            t1537+xyza_fillnegative_xyza.DESCRIPT.RETVAL.DSC.L3,  
     .       4            t1535+1) = xyza_var(t109+t1541-1,t1539+2+t111,t1537+  
     .       5            t113,t1535+1) + xyza_dqfill(xyza_dqfill.DSC.L1+t1541-1
     .       6            ,t1539+2+xyza_dqfill.DSC.L2,t1537+xyza_dqfill.DSC.L3, 
     .       7            t1535+1)                                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   369  
   370      end if
   371  
   372    end function xyza_FillNegative_xyza
   373  
   374  !!!-----------------------------------------------------------
   375    function xyz_FillNegativeDensity_xyz( xyz_Var )
   376      ! ʬŷή.
   377      ! ̩٤ФƤΤŬѲǽ.
   378      ! ԤʤäƤ뤳ȤǤƱ.
   379  
   380      implicit none
   381  
   382      real(8), intent(inout) :: xyz_Var(imin:imax, jmin:jmax, kmin:kmax)
   383      real(8)                :: xyz_FillNegativeDensity_xyz(imin:imax, jmin:jmax, kmin:kmax)
   384      real(8)                :: xyz_DQFILL(imin:imax, jmin:jmax, kmin:kmax)
   385      real(8)                :: xyz_QSUMPN(imin:imax, jmin:jmax, kmin:kmax)
   386      real(8)                :: xz_Var(imin:imax, kmin:kmax)
   387      real(8)                :: xz_DQFILL(imin:imax, kmin:kmax)
   388      real(8)                :: xz_QSUMPN(imin:imax, kmin:kmax)
   389      real(8), parameter     :: EPS = 1.0d-60  !Ǥγ껻ɤ
   390      integer                :: i, j, k
   391  
   392      if (jmin==jmax) then
   393  
   394        !
   395        xz_QSUMPN = 0.0d0
     .        if (xz_qsumpn.DSC.U2 + 1 - xz_qsumpn.DSC.L2 .gt. 0) then          
     .           J1 = and(xz_qsumpn.DSC.U2 + 1 - xz_qsumpn.DSC.L2,1)            
     .  !CDIR    NODEP                                                          
     .           do t702 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t704 = 1, xz_qsumpn.DSC.U1 + 1 - xz_qsumpn.DSC.L1        
     .                 xz_qsumpn(xz_qsumpn.DSC.L1+t704-1,t702-1+xz_qsumpn.DSC.L2
     .       1            ) = 0.0000000000000000e+000                           
     .                 xz_dqfill(xz_dqfill.DSC.L1+t704-1,t702-1+xz_dqfill.DSC.L2
     .       1            ) = 0.0000000000000000e+000                           
     .                 xz_var(xz_var.DSC.L1+t704-1,t702-1+xz_var.DSC.L2) =      
     .       1            xyz_var(t53+t704-1,1,t702-1+t57)                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t702 = J1 + 1, xz_qsumpn.DSC.U2 + 1 - xz_qsumpn.DSC.L2, 2   
     .  !CDIR       NODEP                                                       
     .              do t704 = 1, xz_qsumpn.DSC.U1 + 1 - xz_qsumpn.DSC.L1        
     .                 xz_qsumpn(xz_qsumpn.DSC.L1+t704-1,t702-1+xz_qsumpn.DSC.L2
     .       1            ) = 0.0000000000000000e+000                           
     .                 xz_qsumpn(xz_qsumpn.DSC.L1+t704-1,t702+xz_qsumpn.DSC.L2) 
     .       1             = 0.0000000000000000e+000                            
     .                 xz_dqfill(xz_dqfill.DSC.L1+t704-1,t702-1+xz_dqfill.DSC.L2
     .       1            ) = 0.0000000000000000e+000                           
     .                 xz_dqfill(xz_dqfill.DSC.L1+t704-1,t702+xz_dqfill.DSC.L2) 
     .       1             = 0.0000000000000000e+000                            
     .                 xz_var(xz_var.DSC.L1+t704-1,t702-1+xz_var.DSC.L2) =      
     .       1            xyz_var(t53+t704-1,1,t702-1+t57)                      
     .                 xz_var(xz_var.DSC.L1+t704-1,t702+xz_var.DSC.L2) = xyz_var
     .       1            (t53+t704-1,1,t702+t57)                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   396        xz_DQFILL = 0.0d0
   397        xz_Var = xyz_Var(:,1,:)
   398  
   399        do k = kmin+2, kmax-2
   400          do i = imin+2, imax-2
   401            xz_QSUMPN(i,k) = 1.0d0 /                &
   402              & ( (    MAX( 0.0d0, xz_Var(i-1,k) )  &
   403              &      + MAX( 0.0d0, xz_Var(i+1,k) )  &
   404              &      + MAX( 0.0d0, xz_Var(i,k-1) )  &
   405              &      + MAX( 0.0d0, xz_Var(i,k+1) )  &
   406              &     ) * 0.75d0                      &
   407              &  + (   MAX( 0.0d0, xz_Var(i-2,k) )  &
   408              &      + MAX( 0.0d0, xz_Var(i+2,k) )  &
   409              &      + MAX( 0.0d0, xz_Var(i,k-2) )  &
   410              &      + MAX( 0.0d0, xz_Var(i,k+2) )  &
   411              &     ) * 0.25d0                      &
   412              &  + EPS )
   413          end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xz_qsumpn(imin+1+i,k) = 1.00000000000000e+000/((max(           
     .       1      0.0000000000000000e+000,xz_var(imin+i,k))+max(              
     .       2      0.0000000000000000e+000,xz_var(imin+2+i,k))+max(            
     .       3      0.0000000000000000e+000,xz_var(imin+1+i,k-1))+max(          
     .       4      0.0000000000000000e+000,xz_var(imin+1+i,k+1)))*             
     .       5      7.50000000000000e-001+(max(0.0000000000000000e+000,xz_var(  
     .       6      imin+i-1,k))+max(0.0000000000000000e+000,xz_var(imin+3+i,k))
     .       7      +max(0.0000000000000000e+000,xz_var(imin+1+i,k-2))+max(     
     .       8      0.0000000000000000e+000,xz_var(imin+1+i,k+2)))*             
     .       9      2.50000000000000e-001+9.99999999999999e-061)                
     .        end do                                                            
   414        end do
   415  
   416        do k = kmin+2, kmax-2
   417          do i = imin+2, imax-2
   418            xz_DQFILL(i,k) =                            &
   419              &  - MIN( 0.0d0, xz_Var(i,k) )            &
   420              &  + MAX( 0.0d0, xz_Var(i,k) )            &
   421              &    * ( ( MIN( 0.0d0, xz_Var(i-1,k) ) * xz_QSUMPN(i-1,k) &
   422              &        + MIN( 0.0d0, xz_Var(i+1,k) ) * xz_QSUMPN(i+1,k) &
   423              &        + MIN( 0.0d0, xz_Var(i,k-1) ) * xz_QSUMPN(i,k-1) &
   424              &        + MIN( 0.0d0, xz_Var(i,k+1) ) * xz_QSUMPN(i,k+1) &
   425              &       ) * 0.75d0                                        &
   426              &      + ( MIN( 0.0d0, xz_Var(i-2,k) ) * xz_QSUMPN(i-2,k) &
   427              &        + MIN( 0.0d0, xz_Var(i+2,k) ) * xz_QSUMPN(i+2,k) &
   428              &        + MIN( 0.0d0, xz_Var(i,k-2) ) * xz_QSUMPN(i,k-2) &
   429              &        + MIN( 0.0d0, xz_Var(i,k+2) ) * xz_QSUMPN(i,k+2) &
   430              &       ) * 0.25d0                                        &
   431              &     )
   432          end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xz_dqfill(imin+1+i,k) = max(0.0000000000000000e+000,xz_var(imin
     .       1      +1+i,k))*((min(0.0000000000000000e+000,xz_var(imin+i,k))*   
     .       2      xz_qsumpn(imin+i,k)+min(0.0000000000000000e+000,xz_var(imin+
     .       3      2+i,k))*xz_qsumpn(imin+2+i,k)+min(0.0000000000000000e+000,  
     .       4      xz_var(imin+1+i,k-1))*xz_qsumpn(imin+1+i,k-1)+min(          
     .       5      0.0000000000000000e+000,xz_var(imin+1+i,k+1))*xz_qsumpn(imin
     .       6      +1+i,k+1))*7.50000000000000e-001+(min(                      
     .       7      0.0000000000000000e+000,xz_var(imin+i-1,k))*xz_qsumpn(imin+i
     .       8      -1,k)+min(0.0000000000000000e+000,xz_var(imin+3+i,k))*      
     .       9      xz_qsumpn(imin+3+i,k)+min(0.0000000000000000e+000,xz_var(   
     .       .      imin+1+i,k-2))*xz_qsumpn(imin+1+i,k-2)+min(                 
     .       1      0.0000000000000000e+000,xz_var(imin+1+i,k+2))*xz_qsumpn(imin
     .       2      +1+i,k+2))*2.50000000000000e-001) - min(                    
     .       3      0.0000000000000000e+000,xz_var(imin+1+i,k))                 
     .        end do                                                            
   433        end do
   434        !
   435        xyz_FillNegativeDensity_xyz(:,1,:) = xz_Var + xz_DQFILL
     .        if (xz_var.DSC.U2 + 1 - xz_var.DSC.L2 .gt. 0) then                
     .           J2 = and(xz_var.DSC.U2 + 1 - xz_var.DSC.L2,3)                  
     .  !CDIR    NODEP                                                          
     .           do t714 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t716 = 1, xz_var.DSC.U1 - xz_var.DSC.L1 + 2 - min0(1,    
     .       1         xz_var.DSC.U1 - xz_var.DSC.L1 + 1)                       
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t716-1,1,t714-1+                                      
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xz_var(xz_var.DSC.L1+t716-1,t714-1+xz_var.DSC.L2) +   
     .       5            xz_dqfill(xz_dqfill.DSC.L1+t716-1,t714-1+             
     .       6            xz_dqfill.DSC.L2)                                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t714 = J2 + 1, xz_var.DSC.U2 + 1 - xz_var.DSC.L2, 4         
     .  !CDIR       NODEP                                                       
     .              do t716 = 1, xz_var.DSC.U1 - xz_var.DSC.L1 + 2 - min0(1,    
     .       1         xz_var.DSC.U1 - xz_var.DSC.L1 + 1)                       
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t716-1,1,t714-1+                                      
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xz_var(xz_var.DSC.L1+t716-1,t714-1+xz_var.DSC.L2) +   
     .       5            xz_dqfill(xz_dqfill.DSC.L1+t716-1,t714-1+             
     .       6            xz_dqfill.DSC.L2)                                     
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t716-1,1,t714+                                        
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xz_var(xz_var.DSC.L1+t716-1,t714+xz_var.DSC.L2) +     
     .       5            xz_dqfill(xz_dqfill.DSC.L1+t716-1,t714+               
     .       6            xz_dqfill.DSC.L2)                                     
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t716-1,1,t714+1+                                      
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xz_var(xz_var.DSC.L1+t716-1,t714+1+xz_var.DSC.L2) +   
     .       5            xz_dqfill(xz_dqfill.DSC.L1+t716-1,t714+1+             
     .       6            xz_dqfill.DSC.L2)                                     
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t716-1,1,t714+2+                                      
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       4            xz_var(xz_var.DSC.L1+t716-1,t714+2+xz_var.DSC.L2) +   
     .       5            xz_dqfill(xz_dqfill.DSC.L1+t716-1,t714+2+             
     .       6            xz_dqfill.DSC.L2)                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10032                                                       
   436  
   437      else
   438  
   439        !
   440        xyz_QSUMPN = 0.0d0
     .        if (xyz_qsumpn.DSC.U2 + 1 - xyz_qsumpn.DSC.L2 .gt. 0) then        
     .           J3 = and(xyz_qsumpn.DSC.U2 + 1 - xyz_qsumpn.DSC.L2,1)          
     .  !CDIR    NODEP                                                          
     .           do t677 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t679 = 1, xyz_qsumpn.DSC.U1 + 1 - xyz_qsumpn.DSC.L1      
     .                 xyz_qsumpn(xyz_qsumpn.DSC.L1+t679-1,t677-1+              
     .       1            xyz_qsumpn.DSC.L2,t675+xyz_qsumpn.DSC.L3) =           
     .       2            0.0000000000000000e+000                               
     .                 xyz_dqfill(xyz_dqfill.DSC.L1+t679-1,t677-1+              
     .       1            xyz_dqfill.DSC.L2,t675+xyz_dqfill.DSC.L3) =           
     .       2            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t677 = J3 + 1, xyz_qsumpn.DSC.U2 + 1 - xyz_qsumpn.DSC.L2, 2 
     .  !CDIR       NODEP                                                       
     .              do t679 = 1, xyz_qsumpn.DSC.U1 + 1 - xyz_qsumpn.DSC.L1      
     .                 xyz_qsumpn(xyz_qsumpn.DSC.L1+t679-1,t677-1+              
     .       1            xyz_qsumpn.DSC.L2,t675+xyz_qsumpn.DSC.L3) =           
     .       2            0.0000000000000000e+000                               
     .                 xyz_qsumpn(xyz_qsumpn.DSC.L1+t679-1,t677+                
     .       1            xyz_qsumpn.DSC.L2,t675+xyz_qsumpn.DSC.L3) =           
     .       2            0.0000000000000000e+000                               
     .                 xyz_dqfill(xyz_dqfill.DSC.L1+t679-1,t677-1+              
     .       1            xyz_dqfill.DSC.L2,t675+xyz_dqfill.DSC.L3) =           
     .       2            0.0000000000000000e+000                               
     .                 xyz_dqfill(xyz_dqfill.DSC.L1+t679-1,t677+                
     .       1            xyz_dqfill.DSC.L2,t675+xyz_dqfill.DSC.L3) =           
     .       2            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   441        xyz_DQFILL = 0.0d0
   442  
   443        do k = kmin+2, kmax-2
   444          do j = jmin+2, jmax-2
   445            do i = imin+2, imax-2
   446              xyz_QSUMPN(i,j,k) = 1.0d0 /               &
   447                & ( (    MAX( 0.0d0, xyz_Var(i-1,j,k) ) &
   448                &      + MAX( 0.0d0, xyz_Var(i+1,j,k) ) &
   449                &      + MAX( 0.0d0, xyz_Var(i,j-1,k) ) &
   450                &      + MAX( 0.0d0, xyz_Var(i,j+1,k) ) &
   451                &      + MAX( 0.0d0, xyz_Var(i,j,k-1) ) &
   452                &      + MAX( 0.0d0, xyz_Var(i,j,k+1) ) &
   453                &     ) * 0.75d0                        &
   454                &  + (   MAX( 0.0d0, xyz_Var(i-2,j,k) ) &
   455                &      + MAX( 0.0d0, xyz_Var(i+2,j,k) ) &
   456                &      + MAX( 0.0d0, xyz_Var(i,j-2,k ) ) &
   457                &      + MAX( 0.0d0, xyz_Var(i,j+2,k) ) &
   458                &      + MAX( 0.0d0, xyz_Var(i,j,k-2) ) &
   459                &      + MAX( 0.0d0, xyz_Var(i,j,k+2) ) &
   460                &     ) * 0.25d0                        &
   461                &  + EPS )
   462            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xyz_qsumpn(imin+1+i,j,k) = 1.00000000000000e+000/((max(        
     .       1      0.0000000000000000e+000,xyz_var(imin+i,j,k))+max(           
     .       2      0.0000000000000000e+000,xyz_var(imin+2+i,j,k))+max(         
     .       3      0.0000000000000000e+000,xyz_var(imin+1+i,j-1,k))+max(       
     .       4      0.0000000000000000e+000,xyz_var(imin+1+i,j+1,k))+max(       
     .       5      0.0000000000000000e+000,xyz_var(imin+1+i,j,k-1))+max(       
     .       6      0.0000000000000000e+000,xyz_var(imin+1+i,j,k+1)))*          
     .       7      7.50000000000000e-001+(max(0.0000000000000000e+000,xyz_var( 
     .       8      imin+i-1,j,k))+max(0.0000000000000000e+000,xyz_var(imin+3+i,
     .       9      j,k))+max(0.0000000000000000e+000,xyz_var(imin+1+i,j-2,k))+ 
     .       .      max(0.0000000000000000e+000,xyz_var(imin+1+i,j+2,k))+max(   
     .       1      0.0000000000000000e+000,xyz_var(imin+1+i,j,k-2))+max(       
     .       2      0.0000000000000000e+000,xyz_var(imin+1+i,j,k+2)))*          
     .       3      2.50000000000000e-001+9.99999999999999e-061)                
     .        end do                                                            
   463          end do
   464        end do
   465  
   466        do k = kmin+2, kmax-2
   467          do j = jmin+2, jmax-2
   468            do i = imin+2, imax-2
   469              xyz_DQFILL(i,j,k) =                                                &
   470                &  - MIN( 0.0d0, xyz_Var(i,j,k) )                                 &
   471                &  + MAX( 0.0d0, xyz_Var(i,j,k) )                                 &
   472                &    * ( ( MIN( 0.0d0, xyz_Var(i-1,j,k) ) * xyz_QSUMPN(i-1,j,k)  &
   473                &        + MIN( 0.0d0, xyz_Var(i+1,j,k) ) * xyz_QSUMPN(i+1,j,k)  &
   474                &        + MIN( 0.0d0, xyz_Var(i,j-1,k) ) * xyz_QSUMPN(i,j-1,k)  &
   475                &        + MIN( 0.0d0, xyz_Var(i,j+1,k) ) * xyz_QSUMPN(i,j+1,k)  &
   476                &        + MIN( 0.0d0, xyz_Var(i,j,k-1) ) * xyz_QSUMPN(i,j,k-1)  &
   477                &        + MIN( 0.0d0, xyz_Var(i,j,k+1) ) * xyz_QSUMPN(i,j,k+1)  &
   478                &       ) * 0.75d0                                                &
   479                &      + ( MIN( 0.0d0, xyz_Var(i-2,j,k) ) * xyz_QSUMPN(i-2,j,k)  &
   480                &        + MIN( 0.0d0, xyz_Var(i+2,j,k) ) * xyz_QSUMPN(i+2,j,k)  &
   481                &        + MIN( 0.0d0, xyz_Var(i,j-2,k) ) * xyz_QSUMPN(i,j-2,k)  &
   482                &        + MIN( 0.0d0, xyz_Var(i,j+2,k) ) * xyz_QSUMPN(i,j+2,k)  &
   483                &        + MIN( 0.0d0, xyz_Var(i,j,k-2) ) * xyz_QSUMPN(i,j,k-2)  &
   484                &        + MIN( 0.0d0, xyz_Var(i,j,k+2) ) * xyz_QSUMPN(i,j,k+2)  &
   485                &       ) * 0.25d0                                                &
   486                &     )
   487            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax - imin - 3                                         
     .           xyz_dqfill(imin+1+i,j,k) = max(0.0000000000000000e+000,xyz_var(
     .       1      imin+1+i,j,k))*((min(0.0000000000000000e+000,xyz_var(imin+i,
     .       2      j,k))*xyz_qsumpn(imin+i,j,k)+min(0.0000000000000000e+000,   
     .       3      xyz_var(imin+2+i,j,k))*xyz_qsumpn(imin+2+i,j,k)+min(        
     .       4      0.0000000000000000e+000,xyz_var(imin+1+i,j-1,k))*xyz_qsumpn(
     .       5      imin+1+i,j-1,k)+min(0.0000000000000000e+000,xyz_var(imin+1+i
     .       6      ,j+1,k))*xyz_qsumpn(imin+1+i,j+1,k)+min(                    
     .       7      0.0000000000000000e+000,xyz_var(imin+1+i,j,k-1))*xyz_qsumpn(
     .       8      imin+1+i,j,k-1)+min(0.0000000000000000e+000,xyz_var(imin+1+i
     .       9      ,j,k+1))*xyz_qsumpn(imin+1+i,j,k+1))*7.50000000000000e-001+(
     .       .      min(0.0000000000000000e+000,xyz_var(imin+i-1,j,k))*         
     .       1      xyz_qsumpn(imin+i-1,j,k)+min(0.0000000000000000e+000,xyz_var
     .       2      (imin+3+i,j,k))*xyz_qsumpn(imin+3+i,j,k)+min(               
     .       3      0.0000000000000000e+000,xyz_var(imin+1+i,j-2,k))*xyz_qsumpn(
     .       4      imin+1+i,j-2,k)+min(0.0000000000000000e+000,xyz_var(imin+1+i
     .       5      ,j+2,k))*xyz_qsumpn(imin+1+i,j+2,k)+min(                    
     .       6      0.0000000000000000e+000,xyz_var(imin+1+i,j,k-2))*xyz_qsumpn(
     .       7      imin+1+i,j,k-2)+min(0.0000000000000000e+000,xyz_var(imin+1+i
     .       8      ,j,k+2))*xyz_qsumpn(imin+1+i,j,k+2))*2.50000000000000e-001) 
     .       9       - min(0.0000000000000000e+000,xyz_var(imin+1+i,j,k))       
     .        end do                                                            
   488          end do
   489        end do
   490  
   491        !
   492        xyz_FillNegativeDensity_xyz = xyz_Var + xyz_DQFILL
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J4 = and(jmax + 1 - jmin,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t689 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t691 = 1, imax + 1 - imin                                
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t691-1,t689-1+                                        
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L2,   
     .       4            t687+                                                 
     .       5            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       6            xyz_var(t53+t691-1,t689-1+t55,t687+t57) + xyz_dqfill( 
     .       7            xyz_dqfill.DSC.L1+t691-1,t689-1+xyz_dqfill.DSC.L2,t687
     .       8            +xyz_dqfill.DSC.L3)                                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t689 = J4 + 1, jmax + 1 - jmin, 4                           
     .  !CDIR       NODEP                                                       
     .              do t691 = 1, imax + 1 - imin                                
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t691-1,t689-1+                                        
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L2,   
     .       4            t687+                                                 
     .       5            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       6            xyz_var(t53+t691-1,t689-1+t55,t687+t57) + xyz_dqfill( 
     .       7            xyz_dqfill.DSC.L1+t691-1,t689-1+xyz_dqfill.DSC.L2,t687
     .       8            +xyz_dqfill.DSC.L3)                                   
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t691-1,t689+                                          
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L2,   
     .       4            t687+                                                 
     .       5            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       6            xyz_var(t53+t691-1,t689+t55,t687+t57) + xyz_dqfill(   
     .       7            xyz_dqfill.DSC.L1+t691-1,t689+xyz_dqfill.DSC.L2,t687+ 
     .       8            xyz_dqfill.DSC.L3)                                    
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t691-1,t689+1+                                        
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L2,   
     .       4            t687+                                                 
     .       5            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       6            xyz_var(t53+t691-1,t689+1+t55,t687+t57) + xyz_dqfill( 
     .       7            xyz_dqfill.DSC.L1+t691-1,t689+1+xyz_dqfill.DSC.L2,t687
     .       8            +xyz_dqfill.DSC.L3)                                   
     .                 xyz_fillnegativedensity_xyz(                             
     .       1            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L1+   
     .       2            t691-1,t689+2+                                        
     .       3            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L2,   
     .       4            t687+                                                 
     .       5            xyz_fillnegativedensity_xyz.DESCRIPT.RETVAL.DSC.L3) = 
     .       6            xyz_var(t53+t691-1,t689+2+t55,t687+t57) + xyz_dqfill( 
     .       7            xyz_dqfill.DSC.L1+t691-1,t689+2+xyz_dqfill.DSC.L2,t687
     .       8            +xyz_dqfill.DSC.L3)                                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   493  
   494      end if
   495  
   496    end function xyz_FillNegativeDensity_xyz
   497  
   498  end module FillNegative
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:04 2011
FILE NAME: fillnegative.f90
PROGRAM NAME: fillnegative
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module FillNegative
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4:            ! Version::   $Id: fillnegative.f90,v 1.10 2011-07-15 08:43:30 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview
    10:            !
    11:            !α̤ʤɤ᤹뤿Υ롼
    12:            !  * Ȥʤäˤ, Ϥ 8 ʻͤäƷ᤹.
    13:            ! 
    14:            !== Error Handling
    15:            !
    16:            !== Bugs
    17:            !
    18:            !== Note
    19:            !
    20:            !  *  deepconv  QFILL.f 
    21:            !
    22:            !== Future Plans
    23:            !
    24:            !
    25:            
    26:            module FillNegative
    27:              !
    28:              !α̤ʤɤ᤹뤿Υ롼
    29:              !  * Ȥʤäˤ, Ϥ 8 ʻͤäƷ᤹.
    30:              ! 
    31:            
    32:              !⥸塼ɤ߹
    33:              use dc_types,   only: DP
    34:              use dc_message, only: MessageNotify
    35:              use gtool_historyauto, only: HistoryAutoAddVariable, HistoryAutoPut
    36:              use timeset, only:  DelTimeLong, DelTimeShort, TimeN
    37:              use gridset, only: imin,  &!  X β
    38:                &                imax,  &!  X ξ
    39:                &                jmin,  &!  Y β
    40:                &                jmax,  &!  Y ξ
    41:                &                kmin,  &!  Z β
    42:                &                kmax,  &!  Z ξ
    43:                &                nx,ny,nz,ncmax
    44:              use basicset, only: xyzf_QMixBZ, xyz_DensBZ
    45:              use composition, only: SpcWetSymbol
    46:            
    47:              implicit none
    48:            
    49:              public FillNegative_Init
    50:              public FillNegativeQMix
    51:              public FillNegativeDensity
    52:            
    53:              real(DP), save, allocatable  :: xyza_Basic(:,:,:,:)
    54:              real(DP), save, allocatable  :: xyz_Dens(:,:,:)
    55:              real(DP), save, allocatable  :: xza_Basic(:,:,:)
    56:              real(DP), save, allocatable  :: xz_Dens(:,:)
    57:            
    58:            contains
    59:            
    60:              subroutine FillNegative_Init( )    
    61:                !
    62:                ! ͤ. 
    63:                ! ܾȾʬ¤⾮ʤ뤳ȤϵƤʤ
    64:                !
    65:            
    66:                implicit none
    67:            
    68:                !ѿ
    69:                integer  :: l
    70:            
    71:                !
    72:                allocate( xyza_Basic(imin:imax,jmin:jmax,kmin:kmax, ncmax) )
    73:                allocate( xyz_Dens  (imin:imax,jmin:jmax,kmin:kmax) )
    74:                allocate( xza_Basic(imin:imax,kmin:kmax, ncmax) )
    75:                allocate( xz_Dens(imin:imax,kmin:kmax ) )
    76:                
    77:                !ͤ
    78: +++V===        xyza_Basic = xyzf_QMixBZ
    79: ++V====        xyz_Dens   = xyz_DensBZ
    80:            
    81: ++V====        xza_Basic = xyzf_QMixBZ(:,1,:,:)
    82: +V=====        xz_Dens   = xyz_DensBZ(:,1,:)
    83:            
    84:                call HistoryAutoAddVariable(  &
    85:                  & varname="CDensFill", & 
    86:                  & dims=(/'x','y','z','t'/),     &
    87:                  & longname='Filling Negative term of cloud density ',  &
    88:                  & units='kg.m-3.s-1',    &
    89:                  & xtype='float')
    90: +------>       do l = 1, ncmax
    91: |                call HistoryAutoAddVariable(  &
    92: |                  & varname=trim(SpcWetSymbol(l))//'_Fill', & 
    93: |                  & dims=(/'x','y','z','t'/),     &
    94: |                  & longname='Filling Negative term of '          &
    95: |                  &           //trim(SpcWetSymbol(l))//' mixing ratio',  &
    96: |                  & units='kg.kg-1.s-1',    &
    97: |                  & xtype='float')
    98: +------        end do
    99:            
   100:              end subroutine FillNegative_Init
   101:            
   102:              
   103:              subroutine FillNegativeQMix(xyzf_QMixAl)
   104:                
   105:                implicit none
   106:                
   107:                real(DP), intent(inout)  :: xyzf_QMixAl(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   108:                real(DP)                 :: xyzf_QMixOrig(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   109:                real(DP)                 :: xyzf_QMixWork(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   110:                real(DP)                 :: xyza_Del(imin:imax, jmin:jmax, kmin:kmax, ncmax)
   111:                real(DP)                 :: DelTime
   112:                integer                  :: l
   113:            
   114:                ! ֹ
   115:                !
   116:                DelTime = 2.0d0 * DelTimeLong
   117:            
   118:                ! ͤݴ Store Initial Value
   119:                !
   120: ***V--->       xyzf_QMixOrig = xyzf_QMixAl
   121: ||||           
   122: ||||           ! ήˤäˤʤäʬ
   123: ||||           ! Negative values due to advection are corrected.
   124: ||||           !
   125: ***V---        xyzf_QMixWork = xyzf_QMixAl
   126:                xyzf_QMixAl   = xyza_FillNegative_xyza( xyzf_QMixWork ) 
   127:                
   128:                ! ڤʤäʬ򥼥ˤ. 
   129:                ! Negative values mixing ratios are corrected.
   130:                !
   131: ***V--->       xyzf_QMixWork = xyzf_QMixAl
   132: ||||           xyzf_QMixAl = max( - xyzf_QMixBZ, xyzf_QMixWork )
   133: ||||       
   134: ||||           ! ᤿/ä̤ݴ
   135: ||||           ! Adjustion value is stored.
   136: ||||           !    
   137: ***V---        xyza_Del = xyzf_QMixAl - xyzf_QMixOrig
   138:            
   139:                ! Output
   140: +------>       do l = 1, ncmax
   141: |++V===          call HistoryAutoPut(TimeN, trim(SpcWetSymbol(l))//'_Fill', xyza_Del(1:nx,1:ny,1:nz,l)/ DelTime)
   142: +------        end do
   143:            
   144:              end subroutine FillNegativeQMix
   145:            
   146:            
   147:              subroutine FillNegativeDensity(xyz_CDensAl)
   148:                
   149:                implicit none
   150:                
   151:                real(DP), intent(inout)  :: xyz_CDensAl(imin:imax, jmin:jmax, kmin:kmax)
   152:                real(DP)                 :: xyz_CDensOrig(imin:imax, jmin:jmax, kmin:kmax)
   153:                real(DP)                 :: xyz_CDensWork(imin:imax, jmin:jmax, kmin:kmax)
   154:                real(DP)                 :: xyz_Del(imin:imax, jmin:jmax, kmin:kmax)
   155:            
   156:            
   157:                ! ͤݴ Store Initial Value
   158:                !
   159: **V---->       xyz_CDensOrig = xyz_CDensAl
   160: |||            
   161: |||            ! ήˤäˤʤäʬ
   162: |||            ! Negative values due to advection are corrected.
   163: |||            !
   164: **V----        xyz_CDensWork = xyz_CDensAl
   165:                xyz_CDensAl   = xyz_FillNegativeDensity_xyz( xyz_CDensWork ) 
   166:                
   167:                ! ڤʤäʬ򥼥ˤ. 
   168:                ! Negative values mixing ratios are corrected.
   169:                !
   170: **V---->       xyz_CDensWork = xyz_CDensAl
   171: |||            xyz_CDensAl = max( 0.0d0, xyz_CDensWork )
   172: |||            
   173: |||            ! ᤿/ä̤ݴ
   174: |||            ! Adjustion value is stored.
   175: |||            !    
   176: **V----        xyz_Del = xyz_CDensAl - xyz_CDensOrig
   177:            
   178:                ! Output
   179: ++V====        call HistoryAutoPut(TimeN, 'CDensFill', xyz_Del(1:nx,1:ny,1:nz)/ DelTimeShort)
   180:                
   181:              end subroutine FillNegativeDensity
   182:             
   183:            
   184:              function xyza_FillNegative_xyza( xyza_Var )
   185:                
   186:                implicit none
   187:            
   188:                real(DP), intent(in) :: xyza_Var(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   189:                real(DP) :: xyza_FillNegative_xyza(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   190:                real(DP) :: xyza_DQFILL(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   191:                real(DP) :: xyza_QSUMPN(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   192:                real(DP) :: xza_Var(imin:imax, kmin:kmax, ncmax)
   193:                real(DP) :: xza_DQFILL(imin:imax, kmin:kmax, ncmax)
   194:                real(DP) :: xza_QSUMPN(imin:imax, kmin:kmax, ncmax)
   195:                real(DP), parameter     :: EPS = 1.0d-60  !Ǥγ껻ɤ
   196:                integer                :: i, j, k, s
   197:            
   198:                
   199:                if (jmin==jmax) then 
   200:            
   201:                  !
   202: **V---->         xza_QSUMPN = 0.0d0
   203: **V----          xza_DQFILL = 0.0d0
   204: ++V====          xza_Var(:,:,:) = xyza_Var(:,1,:,:)
   205:                  
   206: +------>         do s = 1, ncmax
   207: |+----->           do k = kmin+2, kmax-2
   208: ||V---->             do i = imin+2, imax-2
   209: |||                    xza_QSUMPN(i,k,s) = 1.0d0 /                                     &
   210: |||                      & ( (    MAX( 0.0d0, xza_Basic(i-1,k,s) + xza_Var(i-1,k,s) )  &
   211: |||                      &         * xz_Dens(i-1,k)                                    &
   212: |||                      &      + MAX( 0.0d0, xza_Basic(i+1,k,s) + xza_Var(i+1,k,s) )  &
   213: |||                      &         * xz_Dens(i+1,k)                                    &
   214: |||                      &      + MAX( 0.0d0, xza_Basic(i,k-1,s) + xza_Var(i,k-1,s) )  &
   215: |||                      &         * xz_Dens(i,k-1)                                    &
   216: |||                      &      + MAX( 0.0d0, xza_Basic(i,k+1,s) + xza_Var(i,k+1,s) )  &
   217: |||                      &         * xz_Dens(i,k+1)                                    &
   218: |||                      &     ) * 0.75d0                                              &
   219: |||                      &  + (   MAX( 0.0d0, xza_Basic(i-2,k,s) + xza_Var(i-2,k,s) )  &
   220: |||                      &         * xz_Dens(i-2,k)                                    &
   221: |||                      &      + MAX( 0.0d0, xza_Basic(i+2,k,s) + xza_Var(i+2,k,s) )  &
   222: |||                      &         * xz_Dens(i+2,k)                                    &
   223: |||                      &      + MAX( 0.0d0, xza_Basic(i,k-2,s) + xza_Var(i,k-2,s) )  &
   224: |||                      &         * xz_Dens(i,k-2)                                    &
   225: |||                      &      + MAX( 0.0d0, xza_Basic(i,k+2,s) + xza_Var(i,k+2,s) )  &
   226: |||                      &         * xz_Dens(i,k+2)                                    &
   227: |||                      &     ) * 0.25d0                                              &
   228: |||                      &  + EPS ) 
   229: ||V----              end do
   230: |+-----            end do
   231: +------          end do
   232:                  
   233: +------>         do s = 1, ncmax
   234: |+----->           do k = kmin+2, kmax-2
   235: ||V---->             do i = imin+2, imax-2
   236: |||                    xza_DQFILL(i,k,s) =                                               &
   237: |||                      &  - MIN( 0.0d0, xza_Basic(i,k,s) + xza_Var(i,k,s) )            &
   238: |||                      &  + MAX( 0.0d0, xza_Basic(i,k,s) + xza_Var(i,k,s) )            &
   239: |||                      &    * ( ( MIN( 0.0d0, xza_Basic(i-1,k,s) + xza_Var(i-1,k,s) )  &
   240: |||                      &           * xza_QSUMPN(i-1,k,s)                               &
   241: |||                      &           * xz_Dens(i-1,k)                                    &
   242: |||                      &        + MIN( 0.0d0, xza_Basic(i+1,k,s) + xza_Var(i+1,k,s) )  &
   243: |||                      &           * xza_QSUMPN(i+1,k,s)                               &
   244: |||                      &           * xz_Dens(i+1,k)                                    &
   245: |||                      &        + MIN( 0.0d0, xza_Basic(i,k-1,s) + xza_Var(i,k-1,s) )  &
   246: |||                      &           * xza_QSUMPN(i,k-1,s)                               &
   247: |||                      &           * xz_Dens(i,k-1)                                    &
   248: |||                      &        + MIN( 0.0d0, xza_Basic(i,k+1,s) + xza_Var(i,k+1,s) )  &
   249: |||                      &           * xza_QSUMPN(i,k+1,s)                               &
   250: |||                      &           * xz_Dens(i,k+1)                                    &  
   251: |||                      &       ) * 0.75d0                                              &
   252: |||                      &      + ( MIN( 0.0d0, xza_Basic(i-2,k,s) + xza_Var(i-2,k,s) )  &
   253: |||                      &           * xza_QSUMPN(i-2,k,s)                               &
   254: |||                      &           * xz_Dens(i-2,k)                                    &
   255: |||                      &        + MIN( 0.0d0, xza_Basic(i+2,k,s) + xza_Var(i+2,k,s) )  &
   256: |||                      &           * xza_QSUMPN(i+2,k,s)                               &
   257: |||                      &           * xz_Dens(i+2,k)                                    &
   258: |||                      &        + MIN( 0.0d0, xza_Basic(i,k-2,s) + xza_Var(i,k-2,s) )  &
   259: |||                      &           * xza_QSUMPN(i,k-2,s)                               &
   260: |||                      &           * xz_Dens(i,k-2)                                    &
   261: |||                      &        + MIN( 0.0d0, xza_Basic(i,k+2,s) + xza_Var(i,k+2,s) )  &
   262: |||                      &           * xza_QSUMPN(i,k+2,s)                               &
   263: |||                      &           * xz_Dens(i,k+2)                                    &
   264: |||                      &       ) * 0.25d0                                              &
   265: |||                      &     )
   266: ||V----              end do
   267: |+-----            end do
   268: +------          end do
   269:                  
   270:                  !
   271: ++V====          xyza_FillNegative_xyza(:,1,:,:) = xza_Var + xza_DQFILL
   272:                  
   273:                else
   274:                  
   275:                  !
   276: ***V--->         xyza_QSUMPN = 0.0d0
   277: ***V---          xyza_DQFILL = 0.0d0
   278:                  
   279: +------>         do s = 1, ncmax
   280: |+----->           do k = kmin+2, kmax-2
   281: ||+---->             do j = jmin+2, jmax-2
   282: |||V--->               do i = imin+2, imax-2
   283: ||||                     xyza_QSUMPN(i,j,k,s) = 1.0d0 /                                       &
   284: ||||                       & ( (    MAX( 0.0d0, xyza_Basic(i-1,j,k,s) + xyza_Var(i-1,j,k,s) ) &
   285: ||||                       &         * xyz_Dens(i-1,j,k)                                      &
   286: ||||                       &      + MAX( 0.0d0, xyza_Basic(i+1,j,k,s) + xyza_Var(i+1,j,k,s) ) &
   287: ||||                       &         * xyz_Dens(i+1,j,k)                                      &
   288: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j-1,k,s) + xyza_Var(i,j-1,k,s) ) &
   289: ||||                       &         * xyz_Dens(i,j-1,k)                                      &
   290: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j+1,k,s) + xyza_Var(i,j+1,k,s) ) &
   291: ||||                       &         * xyz_Dens(i,j+1,k)                                      &
   292: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j,k-1,s) + xyza_Var(i,j,k-1,s) ) &
   293: ||||                       &         * xyz_Dens(i,j,k-1)                                      &
   294: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j,k+1,s) + xyza_Var(i,j,k+1,s) ) &
   295: ||||                       &         * xyz_Dens(i,j,k+1)                                      &
   296: ||||                       &     ) * 0.75d0                                                   &
   297: ||||                       &  + (   MAX( 0.0d0, xyza_Basic(i-2,j,k,s) + xyza_Var(i-2,j,k,s) ) &
   298: ||||                       &         * xyz_Dens(i-2,j,k)                                      &
   299: ||||                       &      + MAX( 0.0d0, xyza_Basic(i+2,j,k,s) + xyza_Var(i+2,j,k,s) ) &
   300: ||||                       &         * xyz_Dens(i+2,j,k)                                      &
   301: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j-2,k,s) + xyza_Var(i,j-2,k,s) ) &
   302: ||||                       &         * xyz_Dens(i,j-2,k)                                      &
   303: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j+2,k,s) + xyza_Var(i,j+2,k,s) ) &
   304: ||||                       &         * xyz_Dens(i,j+2,k)                                      &
   305: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j,k-2,s) + xyza_Var(i,j,k-2,s) ) &
   306: ||||                       &         * xyz_Dens(i,j,k-2)                                      &
   307: ||||                       &      + MAX( 0.0d0, xyza_Basic(i,j,k+2,s) + xyza_Var(i,j,k+2,s) ) &
   308: ||||                       &         * xyz_Dens(i,j,k+2)                                      &
   309: ||||                       &     ) * 0.25d0                                              &
   310: ||||                       &  + EPS ) 
   311: |||V---                end do
   312: ||+----              end do
   313: |+-----            end do
   314: +------          end do
   315:                  
   316: +------>         do s = 1, ncmax
   317: |+----->           do k = kmin+2, kmax-2
   318: ||+---->             do j = jmin+2, jmax-2
   319: |||V--->               do i = imin+2, imax-2
   320: ||||                     xyza_DQFILL(i,j,k,s) =                                              &
   321: ||||                       &  - MIN( 0.0d0, xyza_Basic(i,j,k,s) + xyza_Var(i,j,k,s) )        &
   322: ||||                       &  + MAX( 0.0d0, xyza_Basic(i,j,k,s) + xyza_Var(i,j,k,s) )        &
   323: ||||                       &    * ( ( MIN( 0.0d0, xyza_Basic(i-1,j,k,s) + xyza_Var(i-1,j,k,s) ) &
   324: ||||                       &           * xyza_QSUMPN(i-1,j,k,s)                               &
   325: ||||                       &           * xyz_Dens(i-1,j,k)                                    &
   326: ||||                       &        + MIN( 0.0d0, xyza_Basic(i+1,j,k,s) + xyza_Var(i+1,j,k,s) ) &
   327: ||||                       &           * xyza_QSUMPN(i+1,j,k,s)                               &
   328: ||||                       &           * xyz_Dens(i+1,j,k)                                    &
   329: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j-1,k,s) + xyza_Var(i,j-1,k,s) ) &
   330: ||||                       &           * xyza_QSUMPN(i,j-1,k,s)                               &
   331: ||||                       &           * xyz_Dens(i,j-1,k)                                    &
   332: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j+1,k,s) + xyza_Var(i,j+1,k,s) ) &
   333: ||||                       &           * xyza_QSUMPN(i,j+1,k,s)                               &
   334: ||||                       &           * xyz_Dens(i,j+1,k)                                    &  
   335: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j,k-1,s) + xyza_Var(i,j,k-1,s) ) &
   336: ||||                       &           * xyza_QSUMPN(i,j,k-1,s)                               &
   337: ||||                       &           * xyz_Dens(i,j,k-1)                                    &
   338: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j,k+1,s) + xyza_Var(i,j,k+1,s) ) &
   339: ||||                       &           * xyza_QSUMPN(i,j,k+1,s)                               &
   340: ||||                       &           * xyz_Dens(i,j,k+1)                                    &  
   341: ||||                       &       ) * 0.75d0                                                 &
   342: ||||                       &      + ( MIN( 0.0d0, xyza_Basic(i-2,j,k,s) + xyza_Var(i-2,j,k,s) ) &
   343: ||||                       &           * xyza_QSUMPN(i-2,j,k,s)                               &
   344: ||||                       &           * xyz_Dens(i-2,j,k)                                    &
   345: ||||                       &        + MIN( 0.0d0, xyza_Basic(i+2,j,k,s) + xyza_Var(i+2,j,k,s) ) &
   346: ||||                       &           * xyza_QSUMPN(i+2,j,k,s)                               &
   347: ||||                       &           * xyz_Dens(i+2,j,k)                                    &
   348: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j-2,k,s) + xyza_Var(i,j-2,k,s) ) &
   349: ||||                       &           * xyza_QSUMPN(i,j-2,k,s)                               &
   350: ||||                       &           * xyz_Dens(i,j-2,k)                                    &
   351: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j+2,k,s) + xyza_Var(i,j+2,k,s) ) &
   352: ||||                       &           * xyza_QSUMPN(i,j+2,k,s)                               &
   353: ||||                       &           * xyz_Dens(i,j+2,k)                                    &
   354: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j,k-2,s) + xyza_Var(i,j,k-2,s) ) &
   355: ||||                       &           * xyza_QSUMPN(i,j,k-2,s)                               &
   356: ||||                       &           * xyz_Dens(i,j,k-2)                                    &
   357: ||||                       &        + MIN( 0.0d0, xyza_Basic(i,j,k+2,s) + xyza_Var(i,j,k+2,s) ) &
   358: ||||                       &           * xyza_QSUMPN(i,j,k+2,s)                                &
   359: ||||                       &           * xyz_Dens(i,j,k+2)                                    &
   360: ||||                       &       ) * 0.25d0                                                 &
   361: ||||                       &     )
   362: |||V---                end do
   363: ||+----              end do
   364: |+-----            end do
   365: +------          end do
   366:                  
   367:                  !
   368: +++V===          xyza_FillNegative_xyza = xyza_Var + xyza_DQFILL
   369:                
   370:                end if
   371:            
   372:              end function xyza_FillNegative_xyza
   373:            
   374:            !!!-----------------------------------------------------------
   375:              function xyz_FillNegativeDensity_xyz( xyz_Var )
   376:                ! ʬŷή. 
   377:                ! ̩٤ФƤΤŬѲǽ. 
   378:                ! ԤʤäƤ뤳ȤǤƱ. 
   379:            
   380:                implicit none
   381:            
   382:                real(8), intent(inout) :: xyz_Var(imin:imax, jmin:jmax, kmin:kmax)
   383:                real(8)                :: xyz_FillNegativeDensity_xyz(imin:imax, jmin:jmax, kmin:kmax)
   384:                real(8)                :: xyz_DQFILL(imin:imax, jmin:jmax, kmin:kmax)
   385:                real(8)                :: xyz_QSUMPN(imin:imax, jmin:jmax, kmin:kmax)
   386:                real(8)                :: xz_Var(imin:imax, kmin:kmax)
   387:                real(8)                :: xz_DQFILL(imin:imax, kmin:kmax)
   388:                real(8)                :: xz_QSUMPN(imin:imax, kmin:kmax)
   389:                real(8), parameter     :: EPS = 1.0d-60  !Ǥγ껻ɤ
   390:                integer                :: i, j, k
   391:            
   392:                if (jmin==jmax) then     
   393:            
   394:                  !
   395: *V----->         xz_QSUMPN = 0.0d0
   396: ||               xz_DQFILL = 0.0d0
   397: *V-----          xz_Var = xyz_Var(:,1,:)
   398:            
   399: +------>         do k = kmin+2, kmax-2
   400: |V----->           do i = imin+2, imax-2
   401: ||                   xz_QSUMPN(i,k) = 1.0d0 /                &
   402: ||                     & ( (    MAX( 0.0d0, xz_Var(i-1,k) )  &
   403: ||                     &      + MAX( 0.0d0, xz_Var(i+1,k) )  &
   404: ||                     &      + MAX( 0.0d0, xz_Var(i,k-1) )  &
   405: ||                     &      + MAX( 0.0d0, xz_Var(i,k+1) )  &
   406: ||                     &     ) * 0.75d0                      &
   407: ||                     &  + (   MAX( 0.0d0, xz_Var(i-2,k) )  &
   408: ||                     &      + MAX( 0.0d0, xz_Var(i+2,k) )  &
   409: ||                     &      + MAX( 0.0d0, xz_Var(i,k-2) )  &
   410: ||                     &      + MAX( 0.0d0, xz_Var(i,k+2) )  &
   411: ||                     &     ) * 0.25d0                      &
   412: ||                     &  + EPS ) 
   413: |V-----            end do
   414: +------          end do
   415:            
   416: +------>         do k = kmin+2, kmax-2
   417: |V----->           do i = imin+2, imax-2
   418: ||                   xz_DQFILL(i,k) =                            &
   419: ||                     &  - MIN( 0.0d0, xz_Var(i,k) )            &
   420: ||                     &  + MAX( 0.0d0, xz_Var(i,k) )            &
   421: ||                     &    * ( ( MIN( 0.0d0, xz_Var(i-1,k) ) * xz_QSUMPN(i-1,k) &
   422: ||                     &        + MIN( 0.0d0, xz_Var(i+1,k) ) * xz_QSUMPN(i+1,k) &
   423: ||                     &        + MIN( 0.0d0, xz_Var(i,k-1) ) * xz_QSUMPN(i,k-1) &
   424: ||                     &        + MIN( 0.0d0, xz_Var(i,k+1) ) * xz_QSUMPN(i,k+1) &
   425: ||                     &       ) * 0.75d0                                        &
   426: ||                     &      + ( MIN( 0.0d0, xz_Var(i-2,k) ) * xz_QSUMPN(i-2,k) &
   427: ||                     &        + MIN( 0.0d0, xz_Var(i+2,k) ) * xz_QSUMPN(i+2,k) &
   428: ||                     &        + MIN( 0.0d0, xz_Var(i,k-2) ) * xz_QSUMPN(i,k-2) &
   429: ||                     &        + MIN( 0.0d0, xz_Var(i,k+2) ) * xz_QSUMPN(i,k+2) &
   430: ||                     &       ) * 0.25d0                                        &
   431: ||                     &     )
   432: |V-----            end do
   433: +------          end do
   434:                  !
   435: +V=====          xyz_FillNegativeDensity_xyz(:,1,:) = xz_Var + xz_DQFILL
   436:            
   437:                else
   438:            
   439:                  !
   440: **V---->         xyz_QSUMPN = 0.0d0
   441: **V----          xyz_DQFILL = 0.0d0
   442:                  
   443: +------>         do k = kmin+2, kmax-2
   444: |+----->           do j = jmin+2, jmax-2
   445: ||V---->             do i = imin+2, imax-2
   446: |||                    xyz_QSUMPN(i,j,k) = 1.0d0 /               &
   447: |||                      & ( (    MAX( 0.0d0, xyz_Var(i-1,j,k) ) &
   448: |||                      &      + MAX( 0.0d0, xyz_Var(i+1,j,k) ) &
   449: |||                      &      + MAX( 0.0d0, xyz_Var(i,j-1,k) ) &
   450: |||                      &      + MAX( 0.0d0, xyz_Var(i,j+1,k) ) &
   451: |||                      &      + MAX( 0.0d0, xyz_Var(i,j,k-1) ) &
   452: |||                      &      + MAX( 0.0d0, xyz_Var(i,j,k+1) ) &
   453: |||                      &     ) * 0.75d0                        &
   454: |||                      &  + (   MAX( 0.0d0, xyz_Var(i-2,j,k) ) &
   455: |||                      &      + MAX( 0.0d0, xyz_Var(i+2,j,k) ) &
   456: |||                      &      + MAX( 0.0d0, xyz_Var(i,j-2,k ) ) &
   457: |||                      &      + MAX( 0.0d0, xyz_Var(i,j+2,k) ) &
   458: |||                      &      + MAX( 0.0d0, xyz_Var(i,j,k-2) ) &
   459: |||                      &      + MAX( 0.0d0, xyz_Var(i,j,k+2) ) &
   460: |||                      &     ) * 0.25d0                        &
   461: |||                      &  + EPS ) 
   462: ||V----              end do
   463: |+-----            end do
   464: +------          end do
   465:            
   466: +------>         do k = kmin+2, kmax-2
   467: |+----->           do j = jmin+2, jmax-2
   468: ||V---->             do i = imin+2, imax-2
   469: |||                    xyz_DQFILL(i,j,k) =                                                &
   470: |||                      &  - MIN( 0.0d0, xyz_Var(i,j,k) )                                 &
   471: |||                      &  + MAX( 0.0d0, xyz_Var(i,j,k) )                                 &
   472: |||                      &    * ( ( MIN( 0.0d0, xyz_Var(i-1,j,k) ) * xyz_QSUMPN(i-1,j,k)  &
   473: |||                      &        + MIN( 0.0d0, xyz_Var(i+1,j,k) ) * xyz_QSUMPN(i+1,j,k)  &
   474: |||                      &        + MIN( 0.0d0, xyz_Var(i,j-1,k) ) * xyz_QSUMPN(i,j-1,k)  &
   475: |||                      &        + MIN( 0.0d0, xyz_Var(i,j+1,k) ) * xyz_QSUMPN(i,j+1,k)  &
   476: |||                      &        + MIN( 0.0d0, xyz_Var(i,j,k-1) ) * xyz_QSUMPN(i,j,k-1)  &
   477: |||                      &        + MIN( 0.0d0, xyz_Var(i,j,k+1) ) * xyz_QSUMPN(i,j,k+1)  &
   478: |||                      &       ) * 0.75d0                                                &
   479: |||                      &      + ( MIN( 0.0d0, xyz_Var(i-2,j,k) ) * xyz_QSUMPN(i-2,j,k)  &
   480: |||                      &        + MIN( 0.0d0, xyz_Var(i+2,j,k) ) * xyz_QSUMPN(i+2,j,k)  &
   481: |||                      &        + MIN( 0.0d0, xyz_Var(i,j-2,k) ) * xyz_QSUMPN(i,j-2,k)  &
   482: |||                      &        + MIN( 0.0d0, xyz_Var(i,j+2,k) ) * xyz_QSUMPN(i,j+2,k)  &
   483: |||                      &        + MIN( 0.0d0, xyz_Var(i,j,k-2) ) * xyz_QSUMPN(i,j,k-2)  &
   484: |||                      &        + MIN( 0.0d0, xyz_Var(i,j,k+2) ) * xyz_QSUMPN(i,j,k+2)  &
   485: |||                      &       ) * 0.25d0                                                &
   486: |||                      &     )
   487: ||V----              end do
   488: |+-----            end do
   489: +------          end do
   490:                  
   491:                  !
   492: ++V====          xyz_FillNegativeDensity_xyz = xyz_Var + xyz_DQFILL
   493:            
   494:                end if
   495:                
   496:              end function xyz_FillNegativeDensity_xyz
   497:                
   498:            end module FillNegative
